'$DYNAMIC
'$INCLUDE: 'DIRECTQB.BI'
DEFINT A-Z

IF DQBinit(0, 0, 0) THEN DQBclose: PRINT DQBerror$: END
Q& = SETMEM(-80000)
IF DQBsetBaseLayer%(B0) = 0 THEN DQBclose: PRINT DQBerror$: Q& = SETMEM(80000)

DQBinitVGA

DIM Divide(8191), YMap(63, 99), XScan(63) ' Precalculate everthing possible!
DIM Pic(63, 63)
DIM XLine(161)
DQBget B0, 16, 0, 287, 0, VARSEG(XLine(0)), VARPTR(XLine(0))

FOR I = 0 TO 8191
Divide(I) = (I \ 64) AND 63
NEXT

' palette
OUT 968, 64
FOR I = 0 TO 63
OUT 969, 63 - I
OUT 969, 63 - (I \ 2)
OUT 969, 63
NEXT

FOR Y = 0 TO 31
FOR X = 0 TO 31
Col = (X + Y)
Pic(X, Y) = Col
Pic(63 - X, Y) = Col
Pic(X, 63 - Y) = Col
Pic(63 - X, 63 - Y) = Col
NEXT
NEXT


FOR Y = 0 TO 99
FOR I = 0 TO 63
YMap(I, Y) = I * Y \ 100
NEXT
NEXT

DIM SX(0 TO 99)
DIM SY(0 TO 99)

FOR Y = 0 TO 99                            ' Horizon
IF Y THEN D! = 10000 / Y ELSE D! = 10000
SX(Y) = .01 * -160 * D!
SY(Y) = .01 * 240 * D! - 200
NEXT

CONST PI = 3.141593 / 1440

LPF = 32000
DO
 T = T + 1: IF G! < TIMER THEN G! = TIMER + 1: FPS = T: T = 0
 IF FPS > 40 AND LPF > FPS THEN LPF = FPS
 Angle = (Angle + 1) MOD 2880

 MCOS& = 128 * COS(Angle * PI)
 MSIN& = 128 * SIN(Angle * PI)
 PX& = PX& - (MSIN& * 3)
 PY& = PY& + (MCOS& * 3)

 FOR Y = 0 TO 83
   COSx = SX(Y) * MCOS& \ 64
   SINx = SX(Y) * MSIN& \ 64
   COSy = SY(Y) * MCOS& \ 64
   SINy = SY(Y) * MSIN& \ 64
   XP = COSx - SINy + PX& \ 100
   YP = SINx + COSy + PY& \ 100
   XP2 = XP - COSx - COSx
   YP2 = YP - SINx - SINx
   XC = (XP * 16) AND 4095
   YC = (YP * 16) AND 4095
   DX = (XP2 - XP) \ 10
   DY = (YP2 - YP) \ 10
   DX2 = (DX \ 2) AND 4095
   DY2 = (DY \ 2) AND 4095
  
   SSeg = VARSEG(XLine(0))
   SOff = VARPTR(XLine(0))
   DEF SEG = SSeg
   FOR I = 0 TO 63: XScan(I) = YMap(I, Y) + 64: NEXT ' Depth
 
      FOR X = (SOff + 20) TO (SOff + 287) STEP 8  ' Bottleneck

      POKE X, XScan(Pic(Divide(XC), Divide(YC)))
      POKE X + 1, XScan(Pic(Divide(XC + DX2), Divide(YC + DY2)))
      XC2 = (XC + DX) AND 4095
      YC2 = (YC + DY) AND 4095
      POKE X + 2, XScan(Pic(Divide(XC2), Divide(YC2)))
      POKE X + 3, XScan(Pic(Divide(XC2 + DX2), Divide(YC2 + DY2)))
      XC = (XC2 + DX) AND 4095
      YC = (YC2 + DY) AND 4095
      POKE X + 4, XScan(Pic(Divide(XC), Divide(YC)))
      POKE X + 5, XScan(Pic(Divide(XC + DX2), Divide(YC + DY2)))
      XC2 = (XC + DX) AND 4095
      YC2 = (YC + DY) AND 4095
      POKE X + 6, XScan(Pic(Divide(XC2), Divide(YC2)))
      POKE X + 7, XScan(Pic(Divide(XC2 + DX2), Divide(YC2 + DY2)))
      XC = (XC2 + DX) AND 4095
      YC = (YC2 + DY) AND 4095

      NEXT

   DQBfput B0, 16, Y + 100, SSeg, SOff
   DQBfput B0, 16, 99 - Y, SSeg, SOff

NEXT

'DQBwait 1
DQBcopyLayer B0, 0

LOOP UNTIL INP(96) = 1
DQBclose
Q& = SETMEM(80000)
PRINT FPS
PRINT "Lowest: "; LPF

