' Precalculate everthing possible!
REDIM Divide(8191) AS INTEGER, Pic(63, 63), YMap(63, 99) AS INTEGER
REDIM XLine(161) AS INTEGER, XScan(63) AS INTEGER
REDIM SX(99) AS INTEGER, SY(99) AS INTEGER

' Create raster
DQBget B0, 0, 0, 319, 0, VARSEG(XLine(0)), VARPTR(XLine(0))

' Divide table for Mode7 mapper
FOR I = 0 TO 8191
 Divide(I) = (I \ 64) AND 63
NEXT

' Palette
FOR I = 0 TO 31
 PCW I + 192, DQBpoint(4, I, 197), DQBpoint(4, I, 198), DQBpoint(4, I, 199)
NEXT
FOR I = 0 TO 15
 PCW I + 48, DQBpoint(3, I, 197), DQBpoint(3, I, 198), DQBpoint(3, I, 199)
NEXT
FOR I = 0 TO 23
 PCW I, DQBpoint(1, I, 197), DQBpoint(1, I, 198), DQBpoint(1, I, 199)
 PCW I + 24, DQBpoint(2, I, 197), DQBpoint(2, I, 198), DQBpoint(2, I, 199)
NEXT
FOR I = 0 TO 63: PCW I + 64, 0, (I \ 2), I: NEXT

' Picture
FOR Y = 0 TO 31
FOR X = 0 TO 31
 Col = (X + Y)
 Pic(X, Y) = Col
 Pic(63 - X, Y) = Col
 Pic(X, 63 - Y) = Col
 Pic(63 - X, 63 - Y) = Col
NEXT
NEXT

' Z Projection depth for Mode7 map
FOR Y = 0 TO 99
FOR I = 0 TO 63
YMap(I, Y) = I * Y \ 100
NEXT
NEXT

FOR Y = 0 TO 99                            ' Horizon
IF Y THEN D! = 10000 / Y ELSE D! = 10000
SX(Y) = .01 * -160 * D!
SY(Y) = .01 * 240 * D! - 200
NEXT

PIR! = 3.141593 / 1440        ' For Mode7
Z = 189
V = -50

DO
 IF V < 2450 THEN
  Angle = (Angle + 1) MOD 2880
  ELSE
  FFH = (FFH + 1) AND 15
  IF FFH = 8 THEN NM = NM - (NM < 21)
  IF NM = 21 THEN JNM = JNM + 1
  IF JNM >= 150 THEN FadeOUT 0, 0, 255, 63, 63, 63: JNM = 146: PJ7 = PJ7 + 1
  IF PJ7 = 64 THEN GOTO TheEndOfCC
 END IF
 F = F XOR 1
 IF Angle MOD 3 = 2 THEN V = V + 1

 SDOff = F * 40 + 10
 IF Z THEN FadeBlack Z \ 3, 0, 255: SetMusicVolume 63 - (Z \ 3)
 Z = Z + (Z > 0)       ' Fade

 MCOS& = 128 * COS(Angle * PIR!)
 MSIN& = 128 * SIN(Angle * PIR!)
 PX& = PX& - (MSIN& * (3 + NM))
 PY& = PY& + (MCOS& * (3 + NM))

 SSeg = VARSEG(XLine(0))  ' Sprite
 SOff = VARPTR(XLine(0))
 DEF SEG = SSeg


 ' Render Mode7
 FOR Y = SDOff TO (SDOff + 39)
 
   COSx = SX(Y) * MCOS& \ 64
   SINx = SX(Y) * MSIN& \ 64
   COSy = SY(Y) * MCOS& \ 64
   SINy = SY(Y) * MSIN& \ 64
   XP = COSx - SINy + PX& \ 100
   YP = SINx + COSy + PY& \ 100
   XP2 = XP - COSx - COSx
   YP2 = YP - SINx - SINx
   XC = (XP * 16) AND &HFFF
   YC = (YP * 16) AND &HFFF
   dx = (XP2 - XP) \ 10
   dy = (YP2 - YP) \ 10
   DX2 = (dx \ 2) AND &HFFF
   DY2 = (dy \ 2) AND &HFFF

   FOR I = 0 TO 63: XScan(I) = YMap(I, Y) + 64: NEXT   ' Depth
     FOR X = (SOff + 4) TO (SOff + 319) STEP 8        ' Bottleneck
       POKE X, XScan(Pic(Divide(XC), Divide(YC)))
       POKE X + 1, XScan(Pic(Divide(XC + DX2), Divide(YC + DY2)))
       XC2 = (XC + dx) AND &HFFF
       YC2 = (YC + dy) AND &HFFF
       POKE X + 2, XScan(Pic(Divide(XC2), Divide(YC2)))
       POKE X + 3, XScan(Pic(Divide(XC2 + DX2), Divide(YC2 + DY2)))
       XC = (XC2 + dx) AND &HFFF
       YC = (YC2 + dy) AND &HFFF
       POKE X + 4, XScan(Pic(Divide(XC), Divide(YC)))
       POKE X + 5, XScan(Pic(Divide(XC + DX2), Divide(YC + DY2)))
       XC2 = (XC + dx) AND &HFFF
       YC2 = (YC + dy) AND &HFFF
       POKE X + 6, XScan(Pic(Divide(XC2), Divide(YC2)))
       POKE X + 7, XScan(Pic(Divide(XC2 + DX2), Divide(YC2 + DY2)))
       XC = (XC2 + dx) AND &HFFF
       YC = (YC2 + dy) AND &HFFF
     NEXT
   DQBfPut B0, 0, Y + 100, SSeg, SOff ' Rasters
   DQBfPut B0, 0, 99 - Y, SSeg, SOff
NEXT

DQBboxF B0, 0, 90, 319, 109, 64

CreditPrintS "DIRECTOR:", -12, V
CreditPrintS "PRODUCER:", 38, V
CreditPrintS "MAIN PROGRAMMER:", 88, V
CreditPrintS "GRAPHIC DESIGNER:", 138, V
CreditPrintS "HANDDRAWN ARTWORK:", 188, V
CreditPrintS "MUSIC COMPOSER:", 238, V
CreditPrintS "STORY WRITER:", 288, V
CreditPrintS "MAP DESIGNER:", 338, V
CreditPrintS "VOICE EFFECTS BY:", 388, V
CreditPrintS "DIRECTQB V1.71 BY:", 438, V
CreditPrintS "QUICKBASIC V4.5 BY:", 488, V

CreditPrint "WisdomDude", 0, V
CreditPrint "WisdomDude", 50, V
CreditPrint "WisdomDude", 100, V
CreditPrint "WisdomDude", 150, V
CreditPrint "WisdomDude", 200, V
CreditPrint "WisdomDude", 250, V
CreditPrint "WisdomDude", 300, V
CreditPrint "WisdomDude", 350, V
CreditPrint "Julie Angel", 400, V
CreditPrint "Angelo Mottola", 450, V
CreditPrint "Microsoft", 500, V

CreditPrintS "GREETINGS TO THESE PEOPLE:", 625, V

CreditPrint "_narf (Jason Gould)", 700, V
CreditPrint "Adam (Fishstix)", 750, V
CreditPrint "AhmedF", 800, V
CreditPrint "Alan O'Hagan", 850, V
CreditPrint "Alias (Blobeteer)", 900, V
CreditPrint "Angelo Mottola", 950, V
CreditPrint "Bram Bouwmans", 1000, V
CreditPrint "BudFish (Kyle)", 1050, V
CreditPrint "Chaoticmass", 1100, V
CreditPrint "Deception", 1150, V
CreditPrint "Dunric", 1200, V
CreditPrint "Eagle-X (Sam)", 1250, V
CreditPrint "Glenn Stumpff", 1300, V
CreditPrint "Jake Oster", 1350, V
CreditPrint "Jeremy Hammond", 1400, V
CreditPrint "Jorden Chamid", 1450, V
CreditPrint "JQB45", 1500, V
CreditPrint "Lithium (Chris)", 1550, V
CreditPrint "lutasarts (lutas)", 1600, V
CreditPrint "Marcade", 1650, V
CreditPrint "Pete Berg", 1700, V
CreditPrint "RaeVan", 1750, V
CreditPrint "Sknapper", 1800, V
CreditPrint "solus (Jesse)", 1850, V
CreditPrint "Speige (Devin)", 1900, V
CreditPrint "Terminator_Z", 1950, V
CreditPrint "The Car (Eric Carr)", 2000, V
CreditPrint "V1ctor", 2050, V
CreditPrint "WeirdAlexa", 2100, V
CreditPrint "wildcard", 2150, V
CreditPrint "Zephod", 2200, V

DQBboxF B0, 0, 0, 319, 9, 64
DQBboxF B0, 0, 190, 319, 199, 64

EndLoop              ' End loop stuff
DQBcopyLayer B0, 0
MusicLoop

LOOP

TheEndOfCC:


