'    NOTE: You can only run this compiled with DQB 1.71
'$INCLUDE: 'DIRECTQB.BI'
'$INCLUDE: 'CCLEV.BI'

Init
Logo
Loading
CalcTrans

MainLoop:
 DQBclearLayer B0
 IInput
 IF Viewing = 0 THEN MainInp
 SELECT CASE DA(0)
  CASE 0: MainLoad.Inp: MainLoad.Disp
  CASE 1: Preview.Inp: Preview.Disp
  CASE 2: Object.Inp: Object.Disp
  CASE 3: Tile.Inp: Tile.Disp
  CASE 4: ExtraTile.Inp: ExtraTile.Disp
  CASE 5: BG.Inp: BG.Disp
  CASE 6: Draw.Inp: Draw.Disp
  CASE 7: CalcPalTrans.Inp: CalcPalTrans.Disp
  CASE 8: DemoMisc.Inp: DemoMisc.Disp
 END SELECT
 IF Viewing = 0 THEN MainDisp
 PalBitTil
 IF Viewing = 0 THEN FPSDisplay
 MyMsg 0
 DQBwait 1
 PALupdate
 DQBcopyLayer B0, 0
 MusicLoop
GOTO MainLoop

REM $DYNAMIC
SUB Border

' Nice blue borders
FOR I = 0 TO 15
DQBbox B0, I, I, 319 - I, 191 - I, 8 - (I AND 1)
NEXT
FOR I = 192 TO 199
DQBline B0, 0, I, 319, I, 8 - ((I + 1) AND 1)
NEXT

END SUB

FUNCTION ByteCode (Pointer&)

x = Pointer& MOD 320
y = Pointer& \ 320 MOD 200
L = Pointer& \ 64000 + 14
ByteCode = DQBpoint(L, x, y)

END FUNCTION

REM $STATIC
SUB CalcTrans

' Translucency calculation
PALreset
FOR I = 0 TO 7
OP = Header71(46 + (I * 3))
F1 = Header71(47 + (I * 3))
F2 = Header71(48 + (I * 3))
  PALpcr I + 129, R1, G1, BBB1
   FOR N1 = 0 TO 255
    PALpcr N1, R2, G2, BBB2
     R3 = Interpolate(R2, R1, OP, 100)
     G3 = Interpolate(G2, G1, OP, 100)
     BBB3 = Interpolate(BBB2, BBB1, OP, 100)
      C2 = 189
       C1 = 0
         FOR N2 = F1 TO F2
          PALpcr N2, R2, G2, BBB2
          D = ABS(R3 - R2) + ABS(G3 - G2) + ABS(BBB3 - BBB2)
          IF D < C2 THEN C1 = N2: C2 = D
         NEXT
       BMap(I * 256 + N1) = C1
   IF N1 MOD 52 = 51 THEN DQBwait 1: MusicLoop
   NEXT
NEXT

END SUB

REM $DYNAMIC
SUB Draw.Disp

' Coordinates
EDIT = (DA(25) * 14)
TCol = DA(26 + EDIT)

' Showing VIEWed
IF Viewing THEN
 DQBcopyLayer SGN(EDIT) + 11, B0
 DQBboxf B0, 0, 192, 319, 199, 0
 EXIT SUB
END IF

' Field
x = DA(34 + EDIT)
y = DA(35 + EDIT)
DQBsetSolidPut
DQBcopyLayer SGN(EDIT) + 11, B0

' Intermediate drawing
IF Active = 1 THEN
 SELECT CASE DA(28 + EDIT)
  CASE 1
     DQBline B0, XXX, YYY, XHeld, YHeld, 224
  CASE 2, 3
     DQBline B0, XXX, YYY, XXX, YHeld, 224
     DQBline B0, XXX, YYY, XHeld, YYY, 224
     DQBline B0, XHeld, YYY, XHeld, YHeld, 224
     DQBline B0, XXX, YHeld, XHeld, YHeld, 224
  CASE 4, 5
     DQBellipse B0, XHeld, YHeld, ABS(XXX - XHeld), ABS(YYY - YHeld), 224
 END SELECT
END IF

' Draw selected thing
IF DA(28 + EDIT) = 8 THEN
 XR1 = DA(36 + EDIT)
 YR1 = DA(37 + EDIT)
 XR2 = DA(38 + EDIT)
 YR2 = DA(39 + EDIT)
 FR1 = (FrameTile \ 4) AND 3
   DEF SEG = DQBmapLayer(B0)
   FOR K = (XR1 + FR1) TO XR2 STEP 3
   POKE YR1 * 320 + K, 224
   NEXT
   FOR K = (YR1 + FR1) TO YR2 STEP 3
   POKE K * 320 + XR2, 224
   NEXT
   FOR K = (YR2 - FR1) TO YR1 STEP -3
   POKE K * 320 + XR1, 224
   NEXT
   FOR K = (XR2 - FR1) TO XR1 STEP -3
   POKE YR2 * 320 + K, 224
   NEXT
END IF

' Copy sprite
IF Copy AND DA(28 + EDIT) = 9 AND Area = 1 THEN
  XR2 = (Copied(0) \ 8) + XXX - 1
  YR2 = (Copied(1) AND 255) + YYY - 1
  IF XR2 > 319 THEN XR2 = 319
  IF YR2 > 191 THEN YR2 = 191
  IF ZoomTrans = 0 THEN
   IF DA(27 + EDIT) = 0 THEN DQBboxf B0, XXX, YYY, XR2, YR2, DA(26 + EDIT)
   DQBsetTransPut
   DQBput B0, XXX, YYY, VARSEG(Copied(0)), VARPTR(Copied(0))
   DQBsetSolidPut
  END IF
END IF

' Project intermediate
DQBget B0, x, y, DA(32 + EDIT) + x, DA(33 + EDIT) + y, VARSEG(Array(0)), VARPTR(Array(0))
DQBsPut B0, 16, 16, VARSEG(Array(0)), VARPTR(Array(0)), 240, 112
DQBsetTransPut

' Base
DQBboxf B0, 272, 16, 303, 159, 0
DQBboxf B0, 256, 160, 303, 175, 1
Border
FOR I = 0 TO 7
DQBbox B0, 15 - I, 15 - I, 256 + I, 128 + I, 7 + (I AND 1)
DQBbox B0, 15 - I, 15 - I, 271 - I, 143 - I, 7 + (I AND 1)
NEXT
FOR I = 0 TO 24 STEP 8
 DQBfPut B0, 24 + I, 132, VARSEG(Arrows(0, 0)), VARPTR(Arrows(0, 0))
 DQBfPut B0, 216 + I, 132, VARSEG(Arrows(0, 4)), VARPTR(Arrows(0, 4))
 DQBfPut B0, 260, 24 + I, VARSEG(Arrows(0, 2)), VARPTR(Arrows(0, 2))
 DQBfPut B0, 260, 88 + I, VARSEG(Arrows(0, 6)), VARPTR(Arrows(0, 6))
NEXT

' Icons
C = -((Area = 54) AND (Area = Active))
DQBfPut B0, 272, 120, VARSEG(Buttons(0, C)), VARPTR(Buttons(0, C))
C = -((Area = 55) AND (Area = Active)) + 2
DQBfPut B0, 272, 128, VARSEG(Buttons(0, C)), VARPTR(Buttons(0, C))
C = -((Area = 57) AND (Area = Active)) + 4
DQBfPut B0, 264, 164, VARSEG(Buttons(0, C)), VARPTR(Buttons(0, C))
C = -((Area = 20) AND Active = Area) + 6
DQBfPut B0, 120, 132, VARSEG(Buttons(0, C)), VARPTR(Buttons(0, C))
C = -((Area = 56) AND (Area = Active)) + 8
DQBfPut B0, 272, 136, VARSEG(Buttons(0, C)), VARPTR(Buttons(0, C))
C = DA(27 + EDIT)
DQBfPut B0, 0, 80, VARSEG(Buttons(0, 27 - C)), VARPTR(Buttons(0, 27 - C))
DQBfPut B0, 0, 96, VARSEG(Buttons(0, 28 + C)), VARPTR(Buttons(0, 28 + C))
DQBfPut B0, 0, 32, VARSEG(Buttons(0, 31 - SGN(EDIT))), VARPTR(Buttons(0, 31 - SGN(EDIT)))
DQBfPut B0, 0, 48, VARSEG(Buttons(0, 32 + SGN(EDIT))), VARPTR(Buttons(0, 32 + SGN(EDIT)))
FOR I = 0 TO 7
DQBfPut B0, 144 + (I * 16), 144, VARSEG(Buttons(0, 10 + (I * 2))), VARPTR(Buttons(0, 10 + (I * 2)))
NEXT
FOR I = 0 TO 6
DQBfPut B0, 144 + (I * 16), 160, VARSEG(Buttons(0, 34 + (I * 2))), VARPTR(Buttons(0, 34 + (I * 2)))
NEXT

' Pressed tools
SELECT CASE DA(28 + EDIT)
 CASE 0 TO 7
  I = DA(28 + EDIT)
  DQBfPut B0, 144 + (I * 16), 144, VARSEG(Buttons(0, 11 + (I * 2))), VARPTR(Buttons(0, 11 + (I * 2)))
 CASE 8
  DQBfPut B0, 240, 160, VARSEG(Buttons(0, 47)), VARPTR(Buttons(0, 47))
END SELECT

' Rightside stuff
PrintS "Zoom:", 276, 17, 55, 50
C = DA(30 + EDIT) * 10
DQBboxf B0, 272, 24 + C, 303, 33 + C, 224
DQBboxf B0, 273, 25 + C, 302, 32 + C, 226
PrintS "1 x 1", 275, 26, 6, 4
PrintS "2 x 2", 275, 36, 6, 4
PrintS "4 x 4", 275, 46, 6, 4
PrintS "8 x 8", 275, 56, 6, 4
PrintS "Size:", 276, 65, 55, 50
C = DA(29 + EDIT) * 10
DQBboxf B0, 272, 72 + C, 303, 81 + C, 224
DQBboxf B0, 273, 73 + C, 302, 80 + C, 226
PrintS "1 x 1", 275, 74, 6, 4
PrintS "2 x 2", 275, 84, 6, 4
PrintS "4 x 4", 275, 94, 6, 4
PrintS "8 x 8", 275, 104, 6, 4

' Palette
FOR I = 0 TO 120 STEP 8
 C = (I \ 8) + (DA(25) * 64)
 DQBboxf B0, 16 + I, 144, 16 + I + 7, 151, C + 64
 DQBboxf B0, 16 + I, 152, 16 + I + 7, 159, C + 80
 DQBboxf B0, 16 + I, 160, 16 + I + 7, 167, C + 96
 DQBboxf B0, 16 + I, 168, 16 + I + 7, 175, C + 112
NEXT
DQBbox B0, 16, 144, 80, 160, 0
DQBbox B0, 80, 160, 143, 175, 0
DQBboxf B0, 16, 177, 47, 199, 253
DQBboxf B0, 48, 177, 79, 199, 254
DQBboxf B0, 80, 177, 111, 199, 255
FOR I = 0 TO 2
 DQBfPut B0, (I * 32) + 24, 184, VARSEG(Arrows(0, 2)), VARPTR(Arrows(0, 2))
 DQBfPut B0, (I * 32) + 32, 184, VARSEG(Arrows(0, 2)), VARPTR(Arrows(0, 2))
 DQBfPut B0, (I * 32) + 24, 192, VARSEG(Arrows(0, 6)), VARPTR(Arrows(0, 6))
 DQBfPut B0, (I * 32) + 32, 192, VARSEG(Arrows(0, 6)), VARPTR(Arrows(0, 6))
NEXT

' Pressed scrolled arrows
IF Area = Active THEN
 SELECT CASE Area
  CASE 4: YY = 24
  CASE 5: YY = 32
  CASE 6: YY = 40
  CASE 7: YY = 48
  CASE 8: YY = 88
  CASE 9: YY = 96
  CASE 10: YY = 104
  CASE 11: YY = 112
  CASE 12: XX = 24
  CASE 13: XX = 32
  CASE 14: XX = 40
  CASE 15: XX = 48
  CASE 16: XX = 216
  CASE 17: XX = 224
  CASE 18: XX = 232
  CASE 19: XX = 240
  CASE 27: XX = 24
  CASE 28: XX = 32
  CASE 29: XX = 56
  CASE 30: XX = 64
  CASE 31: XX = 88
  CASE 32: XX = 96
  CASE 33: XX = 24
  CASE 34: XX = 32
  CASE 35: XX = 56
  CASE 36: XX = 64
  CASE 37: XX = 88
  CASE 38: XX = 96
  CASE 48 TO 53
   I = Area - 48
   DQBfPut B0, 144 + (I * 16), 160, VARSEG(Buttons(0, 35 + (I * 2))), VARPTR(Buttons(0, 35 + (I * 2)))
 END SELECT
 SELECT CASE Area
  CASE 4 TO 11: XX = 260
  CASE 12 TO 19: YY = 132
  CASE 27 TO 32: YY = 184
  CASE 33 TO 38: YY = 192
 END SELECT
 SELECT CASE Area
  CASE 4 TO 7, 27 TO 32: DQBfPut B0, XX, YY, VARSEG(Arrows(0, 3)), VARPTR(Arrows(0, 3))
  CASE 8 TO 11, 33 TO 38: DQBfPut B0, XX, YY, VARSEG(Arrows(0, 7)), VARPTR(Arrows(0, 7))
  CASE 12 TO 15: DQBfPut B0, XX, YY, VARSEG(Arrows(0, 1)), VARPTR(Arrows(0, 1))
  CASE 16 TO 19: DQBfPut B0, XX, YY, VARSEG(Arrows(0, 5)), VARPTR(Arrows(0, 5))
 END SELECT
END IF

' Chosen color
IF TCol THEN
 C = TCol AND 63
 x = (C AND 15) * 8 + 16
 y = (C \ 16) * 8 + 144
ELSE
 x = 8
 y = 144
END IF

' Palette
DQBboxf B0, 8, 144, 15, 151, 0
DQBboxf B0, 160, 182, 303, 191, 0
DQBbox B0, x, y, x + 7, y + 7, 224
PrintS "R", 16, 192, 22, 0
PrintS "G", 48, 192, 0, 22
PrintS "B", 80, 192, 22, 0
PALpcr TCol, RR, GG, BB
PrintS Zero$(RR, 2), 24, 177, 22, 0
PrintS Zero$(GG, 2), 56, 177, 0, 22
PrintS Zero$(BB, 2), 88, 177, 22, 0
PrintS Zero$(TCol, 3), 120, 177, 6, 4
DQBboxf B0, 112, 184, 143, 199, TCol

A$ = "(" + LTRIM$(STR$(XHeld)) + ", " + LTRIM$(STR$(YHeld)) + ")-"
A$ = A$ + "(" + LTRIM$(STR$(XXX)) + ", " + LTRIM$(STR$(YYY)) + ")"
IF Area = 1 THEN PrintS A$, 162, 184, 6, 4

A$ = ""
SELECT CASE Area
 CASE 2: A$ = "Zoom in/out of picture"
 CASE 3: A$ = "Size of tools' output"
 CASE 20: A$ = "View output!"
 CASE 21: A$ = "Edit background"
 CASE 22: A$ = "Edit tile set"
 CASE 23: A$ = "Solid put mode"
 CASE 24: A$ = "Transparent put mode"
 CASE 25, 26: A$ = "Choose color for picture"
 CASE 27 TO 38: A$ = "Edit RGB values of color"
 CASE 39: A$ = "Drawing (Pen)"
 CASE 40: A$ = "Drawing (Line)"
 CASE 41: A$ = "Drawing (Box)"
 CASE 42: A$ = "Drawing (Box-Fill)"
 CASE 43: A$ = "Drawing (Circle)"
 CASE 44: A$ = "Drawing (Circle-Fill)"
 CASE 45: A$ = "Drawing (Spray)"
 CASE 46: A$ = "Drawing (Paint)"
 CASE 47: A$ = "SELECT Tool"
 CASE 48: A$ = "Scroll selection Right"
 CASE 49: A$ = "Scroll selection Down"
 CASE 50: A$ = "Scroll selection Left"
 CASE 51: A$ = "Scroll selection Up"
 CASE 52: A$ = "Mirror selection"
 CASE 53: A$ = "Flip selection"
 CASE 54: A$ = "Copy selection to clipboard"
 CASE 55: A$ = "Paste selected from clipboard"
 CASE 56: A$ = "Undo last change"
 CASE 57: A$ = "Clear picture into grid"
END SELECT
PrintS A$, 162, 184, 60, 57

END SUB

REM $STATIC
SUB Draw.Inp

' Stuff
EDIT = (DA(25) * 14)
TCol = DA(26 + EDIT)

' VIEWING OFF
IF Viewing THEN
 IF MLB1 OR MRB THEN
  IF MLB1 > 0 THEN MLB1 = 2
  IF MRB > 0 THEN MRB = 2
  Viewing = 0
 ELSE
  EXIT SUB
 END IF
END IF

' Areas
IF MX > 15 AND MY > 15 AND MX < 256 AND MY < 128 THEN Area = 1
IF MX > 271 AND MX < 304 THEN
SELECT CASE MY
 CASE 24 TO 63: Area = 2
 CASE 72 TO 111: Area = 3
END SELECT
END IF
IF MX > 259 AND MX < 268 THEN
 SELECT CASE MY
  CASE 24 TO 31: Area = 4
  CASE 32 TO 39: Area = 5
  CASE 40 TO 47: Area = 6
  CASE 48 TO 55: Area = 7
  CASE 88 TO 95: Area = 8
  CASE 96 TO 103: Area = 9
  CASE 104 TO 111: Area = 10
  CASE 112 TO 119: Area = 11
 END SELECT
END IF
IF MY > 131 AND MY < 140 THEN
 SELECT CASE MX
  CASE 24 TO 31: Area = 12
  CASE 32 TO 39: Area = 13
  CASE 40 TO 47: Area = 14
  CASE 48 TO 55: Area = 15
  CASE 120 TO 151: Area = 20
  CASE 216 TO 223: Area = 16
  CASE 224 TO 231: Area = 17
  CASE 232 TO 239: Area = 18
  CASE 240 TO 247: Area = 19
 END SELECT
END IF
IF MX < 16 THEN
 SELECT CASE MY
  CASE 32 TO 47: Area = 21
  CASE 48 TO 63: Area = 22
  CASE 80 TO 95: Area = 23
  CASE 96 TO 111: Area = 24
 END SELECT
END IF
IF MX >= 8 AND MX <= 15 AND MY >= 144 AND MY <= 151 THEN Area = 25
IF MX >= 16 AND MY >= 144 AND MX <= 143 AND MY <= 175 THEN Area = 26
IF MY >= 184 AND MY <= 191 THEN
 SELECT CASE MX
  CASE 24 TO 31: Area = 27
  CASE 32 TO 39: Area = 28
  CASE 56 TO 63: Area = 29
  CASE 64 TO 71: Area = 30
  CASE 88 TO 95: Area = 31
  CASE 96 TO 103: Area = 32
 END SELECT
END IF
IF MY >= 192 AND MY <= 199 THEN
 SELECT CASE MX
  CASE 24 TO 31: Area = 33
  CASE 32 TO 39: Area = 34
  CASE 56 TO 63: Area = 35
  CASE 64 TO 71: Area = 36
  CASE 88 TO 95: Area = 37
  CASE 96 TO 103: Area = 38
 END SELECT
END IF
IF MY >= 144 AND MY <= 159 THEN
 SELECT CASE MX
  CASE 144 TO 159: Area = 39
  CASE 160 TO 175: Area = 40
  CASE 176 TO 191: Area = 41
  CASE 192 TO 207: Area = 42
  CASE 208 TO 223: Area = 43
  CASE 224 TO 239: Area = 44
  CASE 240 TO 255: Area = 45
  CASE 256 TO 271: Area = 46
 END SELECT
END IF
IF MX >= 240 AND MY >= 160 AND MX <= 255 AND MY <= 175 THEN Area = 47
IF MY >= 160 AND MY <= 175 THEN
 SELECT CASE MX
  CASE 144 TO 159: Area = 48
  CASE 160 TO 175: Area = 49
  CASE 176 TO 191: Area = 50
  CASE 192 TO 207: Area = 51
  CASE 208 TO 223: Area = 52
  CASE 224 TO 239: Area = 53
 END SELECT
END IF
IF MX >= 272 AND MX <= 303 THEN
 SELECT CASE MY
  CASE 120 TO 127: Area = 54
  CASE 128 TO 135: Area = 55
  CASE 136 TO 143: Area = 56
 END SELECT
END IF
IF MY >= 164 AND MY <= 171 AND MX >= 264 AND MX <= 295 THEN Area = 57

' Background or Tiles
IF MLB1 = 1 THEN Active = Area
IF TCol THEN
 IF TCol < 64 THEN TCol = 64
 IF TCol > 191 THEN TCol = 191
END IF

' Selecting zoom
IF ZoomTrans = 0 AND Area = 2 AND MLB1 = 1 THEN
 DA(31 + EDIT) = DA(30 + EDIT)
 DA(30 + EDIT) = (MY - 24) \ 10
 IF DA(31 + EDIT) <> DA(30 + EDIT) THEN ZoomTrans = 1
END IF

' Pen
IF MLB1 AND Area = 3 AND Active = 3 THEN DA(29 + EDIT) = (MY - 72) \ 10

' Viewing ON
IF MLB1 = -1 AND Area = 20 AND Active = Area THEN
 MLB1 = 0
 Viewing = 1
EXIT SUB
END IF

IF Active = Area THEN

 ' Arrow pressing
 IF MLB2 THEN
  x = DA(34 + EDIT)
  y = DA(35 + EDIT)
  SELECT CASE Area
   CASE 4: y = y - 4
   CASE 5: y = y - 3
   CASE 6: y = y - 2
   CASE 7: y = y - 1
   CASE 8: y = y + 1
   CASE 9: y = y + 2
   CASE 10: y = y + 3
   CASE 11: y = y + 4
   CASE 12: x = x - 4
   CASE 13: x = x - 3
   CASE 14: x = x - 2
   CASE 15: x = x - 1
   CASE 16: x = x + 1
   CASE 17: x = x + 2
   CASE 18: x = x + 3
   CASE 19: x = x + 4
  END SELECT
  DA(34 + EDIT) = x
  DA(35 + EDIT) = y
 END IF
END IF

' Dragging off sides?
IF Active = 1 AND Area <> 1 THEN
  x = DA(34 + EDIT)
  y = DA(35 + EDIT)
   IF MX < 16 THEN x = x - 1
   IF MY < 16 THEN y = y - 1
   IF MX > 255 THEN x = x + 1
   IF MY > 127 THEN y = y + 1
  DA(34 + EDIT) = x
  DA(35 + EDIT) = y
END IF

' Stretch variables
SELECT CASE DA(30 + EDIT)
 CASE 0: x1 = 239: y1 = 111
 CASE 1: x1 = 119: y1 = 55
 CASE 2: x1 = 59: y1 = 27
 CASE 3: x1 = 29: y1 = 13
END SELECT
SELECT CASE DA(31 + EDIT)
 CASE 0: x2 = 239: y2 = 111
 CASE 1: x2 = 119: y2 = 55
 CASE 2: x2 = 59: y2 = 27
 CASE 3: x2 = 29: y2 = 13
END SELECT

' Zooming
IF ZoomTrans THEN
 PX = DA(32 + EDIT)
 PY = DA(33 + EDIT)
 DA(32 + EDIT) = Interpolate(x2, x1, ZoomTrans, 64)
 DA(33 + EDIT) = Interpolate(y2, y1, ZoomTrans, 64)
 ZoomTrans = (ZoomTrans + 1) MOD 65
 IF ZoomTrans AND 1 THEN
  DA(34 + EDIT) = DA(34 + EDIT) + (PX - DA(32 + EDIT))
  DA(35 + EDIT) = DA(35 + EDIT) + (PY - DA(33 + EDIT))
 END IF
END IF

' Correction of coordinates
x = DA(34 + EDIT)
y = DA(35 + EDIT)
 IF x < 0 THEN x = 0
 IF y < 0 THEN y = 0
 IF x + DA(32 + EDIT) > 319 THEN x = 319 - DA(32 + EDIT)
 IF y + DA(33 + EDIT) > 191 THEN y = 191 - DA(33 + EDIT)
DA(34 + EDIT) = x
DA(35 + EDIT) = y

' Let it go through its zooming process
IF ZoomTrans THEN EXIT SUB

' Field coordinates mouse conversion
SELECT CASE DA(EDIT + 30)
 CASE 0: P = 1
 CASE 1: P = 2
 CASE 2: P = 4
 CASE 3: P = 8
END SELECT
' Coordinates
PMX = XXX
PMY = YYY
XXX = ((MX - 16) \ P) + DA(34 + EDIT)
YYY = ((MY - 16) \ P) + DA(35 + EDIT)
' Selecting size
SELECT CASE DA(EDIT + 29)
 CASE 0: Pn = 1
 CASE 1: Pn = 2
 CASE 2: Pn = 4
 CASE 3: Pn = 8
END SELECT

' Pointing
IF MRB = 1 AND Area = 1 THEN TCol = DQBpoint(DA(25) + 11, XXX, YYY)
' Mouse assignment
IF Area = Active THEN
 ' R-G-B assigning
 IF MLB2 THEN
 
  PALpcr TCol, RR, GG, BB
  Cly = DA(25) + 11
  x1 = DA(36 + EDIT)
  y1 = DA(37 + EDIT)
  x2 = DA(38 + EDIT)
  y2 = DA(39 + EDIT)
  DQBsetSolidPut

  SELECT CASE Area
   CASE 27: RR = RR + 10
   CASE 28: RR = RR + 1
   CASE 29: GG = GG + 10
   CASE 30: GG = GG + 1
   CASE 31: BB = BB + 10
   CASE 32: BB = BB + 1
   CASE 33: RR = RR - 10
   CASE 34: RR = RR - 1
   CASE 35: GG = GG - 10
   CASE 36: GG = GG - 1
   CASE 37: BB = BB - 10
   CASE 38: BB = BB - 1
   CASE 48
    DQBget Cly, x2, y1, x2, y2, VARSEG(EPut(0)), VARPTR(EPut(0))
    DQBscrollArea Cly, x1, y1, x2, y2, 3
    DQBput Cly, x1, y1, VARSEG(EPut(0)), VARPTR(EPut(0))
   CASE 49
    DQBget Cly, x1, y2, x2, y2, VARSEG(EPut(0)), VARPTR(EPut(0))
    DQBscrollArea Cly, x1, y1 - 1, x2, y2, 1
    DQBput Cly, x1, y1, VARSEG(EPut(0)), VARPTR(EPut(0))
   CASE 50
    DQBget Cly, x1, y1, x1, y2, VARSEG(EPut(0)), VARPTR(EPut(0))
    DQBscrollArea Cly, x1, y1, x2, y2, 2
    DQBput Cly, x2, y1, VARSEG(EPut(0)), VARPTR(EPut(0))
   CASE 51
    DQBget Cly, x1, y1, x2, y1, VARSEG(EPut(0)), VARPTR(EPut(0))
    DQBscrollArea Cly, x1, y1, x2, y2 + 1, 0
    DQBput Cly, x1, y2, VARSEG(EPut(0)), VARPTR(EPut(0))
   CASE 52
    Half = ABS(x2 - x1) \ 2
    FOR RN = 0 TO Half
     DQBget Cly, x2 - RN, y1, x2 - RN, y2, VARSEG(EPut(0)), VARPTR(EPut(0))
     DQBget Cly, x1 + RN, y1, x1 + RN, y2, VARSEG(QPut(0)), VARPTR(QPut(0))
     DQBput Cly, x2 - RN, y1, VARSEG(QPut(0)), VARPTR(QPut(0))
     DQBput Cly, x1 + RN, y1, VARSEG(EPut(0)), VARPTR(EPut(0))
    NEXT
   CASE 53
    Half = ABS(y2 - y1) \ 2
    FOR RN = 0 TO Half
     DQBget Cly, x1, y2 - RN, x2, y2 - RN, VARSEG(EPut(0)), VARPTR(EPut(0))
     DQBget Cly, x1, y1 + RN, x2, y1 + RN, VARSEG(QPut(0)), VARPTR(QPut(0))
     DQBput Cly, x1, y2 - RN, VARSEG(QPut(0)), VARPTR(QPut(0))
     DQBput Cly, x1, y1 + RN, VARSEG(EPut(0)), VARPTR(EPut(0))
    NEXT
  END SELECT
  DQBsetTransPut

  IF TCol THEN
   PALscw TCol, RR, GG, BB
   PALpcw TCol, RR, GG, BB
  END IF
 END IF

 ' Drawing
 IF MLB1 AND Area = 1 THEN
  
   ' Copy to buffer
   IF MLB1 = 1 THEN
    XHeld = XXX
    YHeld = YYY
    DQBcopyLayer 11 + DA(25), 17 + DA(25)
    IF DA(25) THEN
     UndoTiles = 1
    ELSE
     UndoBG = 1
    END IF
   END IF
  
   ' Tool
   Cly = DA(25) + 11
   Clr = DA(26 + EDIT)
   SELECT CASE DA(28 + EDIT)
   CASE 0
    FOR K = 0 TO 31
     TTX1 = Interpolate(XXX, PMX, K, 31)
     TTY1 = Interpolate(YYY, PMY, K, 31)
     DQBboxf Cly, TTX1, TTY1, TTX1 + Pn - 1, TTY1 + Pn - 1, Clr
    NEXT
   CASE 1
     IF MLB1 = -1 THEN
     DQBline Cly, XXX, YYY, XHeld, YHeld, Clr
     END IF
   CASE 2
     IF MLB1 = -1 THEN
       DQBline Cly, XXX, YYY, XXX, YHeld, Clr
       DQBline Cly, XXX, YYY, XHeld, YYY, Clr
       DQBline Cly, XHeld, YYY, XHeld, YHeld, Clr
       DQBline Cly, XXX, YHeld, XHeld, YHeld, Clr
      END IF
  CASE 3
     IF MLB1 = -1 THEN
       TTY1 = YYY
       TTY2 = YHeld
       IF TTY1 > TTY2 THEN SWAP TTY1, TTY2
       FOR YR1 = TTY1 TO TTY2
       DQBline Cly, XXX, YR1, XHeld, YR1, Clr
       NEXT
      END IF
  CASE 4
     IF MLB1 = -1 THEN
      DQBellipse Cly, XHeld, YHeld, ABS(XXX - XHeld), ABS(YYY - YHeld), Clr
     END IF
  CASE 5
     IF MLB1 = -1 THEN
      DQBpset Cly, XHeld, YHeld, DA(26 + EDIT)
      FOR YR1 = 1 TO ABS(XXX - XHeld)
      DQBellipse Cly, XHeld, YHeld, YR1, ABS(YYY - YHeld), Clr
      NEXT
      FOR YR1 = 1 TO ABS(YYY - YHeld)
      DQBellipse Cly, XHeld, YHeld, ABS(XXX - XHeld), YR1, Clr
      NEXT
     END IF
   CASE 6
     FOR I = 0 TO 4
     RN = Pn * 5
     Dst = INT(RND * RN)
     RN = INT(RND * 360)
     Xm = Dst * MyCOS(RN) \ 1024
     Ym = Dst * MySIN(RN) \ 1024
     DQBpset Cly, XXX + Xm, YYY + Ym, Clr
     NEXT
   CASE 7
     DQBpaint Cly, XXX, YYY, Clr
   CASE 8
     XR1 = XHeld
     YR1 = YHeld
     XR2 = XXX
     YR2 = YYY
     IF XR1 > XR2 THEN SWAP XR1, XR2
     IF YR1 > YR2 THEN SWAP YR1, YR2
     DA(36 + EDIT) = XR1
     DA(37 + EDIT) = YR1
     DA(38 + EDIT) = XR2
     DA(39 + EDIT) = YR2
   CASE 9
     IF Copy AND MLB1 = 1 AND Area = 1 THEN
       XR2 = (Copied(0) \ 8) + XXX - 1
       YR2 = (Copied(1) AND 255) + YYY - 1
       IF XR2 > 319 THEN XR2 = 319
       IF YR2 > 191 THEN YR2 = 191
       IF DA(27 + EDIT) = 0 THEN DQBboxf Cly, XXX, YYY, XR2, YR2, DA(26 + EDIT)
       DQBput Cly, XXX, YYY, VARSEG(Copied(0)), VARPTR(Copied(0))
     END IF
   END SELECT
 END IF

 ' One touch buttons
 IF MLB1 = 1 THEN
  SELECT CASE Area
   CASE 21: DA(25) = 0
   CASE 22: DA(25) = 1
   CASE 23: DA(27 + EDIT) = 0
   CASE 24: DA(27 + EDIT) = 1
   CASE 25: TCol = 0
   CASE 26
     x = ((MX - 16) \ 8)
     y = ((MY - 144) \ 8) * 16
     C = DA(25) * 64 + 64
     TCol = C + x + y
   CASE 39 TO 46: DA(EDIT + 28) = Area - 39 ' Tool select
   CASE 47: DA(EDIT + 28) = 8
  END SELECT
 END IF
END IF

' Right side buttons:
IF Area = Active AND MLB1 = -1 THEN
 SELECT CASE Area
  CASE 54
    Copy = 1
    XR1 = DA(36 + EDIT)
    YR1 = DA(37 + EDIT)
    XR2 = DA(38 + EDIT)
    YR2 = DA(39 + EDIT)
    DQBget DA(25) + 11, XR1, YR1, XR2, YR2, VARSEG(Copied(0)), VARPTR(Copied(0))
  CASE 55
    IF Copy THEN DA(28 + EDIT) = 9
  CASE 56
    IF DA(25) THEN
    UndoTiles = 0
    DQBcopyLayer 18, 12
    ELSE
    UndoBG = 0
    DQBcopyLayer 17, 11
    END IF
  CASE 57
    IF DA(25) THEN
    UndoTiles = 1
    DQBcopyLayer 12, 18
     FOR y = 0 TO 176 STEP 16
     FOR x = 0 TO 304 STEP 16
     DQBboxf 12, x + 1, y + 1, x + 14, y + 14, 22
     DQBbox 12, x, y, x + 15, y + 15, 0
     NEXT
     NEXT
    ELSE
    UndoBG = 1
    DQBcopyLayer 11, 17
     FOR y = 8 TO 184 STEP 16
     FOR x = 0 TO 304 STEP 16
     DQBboxf 11, x + 1, y + 1, x + 14, y + 14, 22
     DQBbox 11, x, y, x + 15, y + 15, 0
     NEXT
     NEXT
    END IF
 END SELECT
END IF

' Get back color
DA(26 + EDIT) = TCol

END SUB

SUB DrawTile (x, y, Index)

 ' Animation reference
 Value = Index
 SELECT CASE Value
  CASE 1 TO 216: C = Value
  CASE 217 TO 324: C = ((Value - 217) * 2) + (FrameTile AND 1) + 1
  CASE 325 TO 378: C = ((Value - 325) * 4) + (FrameTile \ 16) + 1
  CASE 379 TO 405: C = ((Value - 379) * 8) + (FrameTile \ 8) + 1
  CASE 406 TO 418: C = ((Value - 406) * 16) + (FrameTile \ 4) + 1
  CASE 420 TO 431: C = ((Value - 420) * 4) + ((FrameTile AND 1) * 16) + (FrameTile \ 16) + 1 + (((Value - 420) \ 4) * 16)
  CASE 432 TO 446: C = ((Value - 432) * 4) + ((FrameTile AND 1) * 20) + (FrameTile \ 16) + 97 + (((Value - 432) \ 5) * 20)
  CASE 447 TO 554: C = ((Value - 447) * 2) + (FrameTile \ 32) + 1
  CASE 555 TO 662: C = ((Value - 555) * 2) + ((FrameTile \ 8) AND 1) + 1
  CASE 663 TO 878: C = (Value - 662)
  CASE 879 TO 986: C = ((Value - 879) * 2) + (FrameTile \ 32) + 1
  CASE 987 TO 1040: C = ((Value - 987) * 4) + (FrameTile \ 16) + 1
  CASE 1041 TO 1067: C = ((Value - 1041) * 8) + (FrameTile \ 8) + 1
  CASE 1068 TO 1080: C = ((Value - 1068) * 16) + (FrameTile \ 4) + 1
  CASE 1081 TO 1296: C = (Value - 1080)
  CASE 1297 TO 1404: C = ((Value - 1297) * 2) + (FrameTile \ 32) + 1
  CASE 1405 TO 1458: C = ((Value - 1405) * 4) + (FrameTile \ 16) + 1
  CASE 1459 TO 1485: C = ((Value - 1459) * 8) + (FrameTile \ 8) + 1
  CASE 1486 TO 1498: C = ((Value - 1486) * 16) + (FrameTile \ 4) + 1
  CASE 1500 TO 1755: C = (Value - 1500)
  CASE ELSE: C = 1
 END SELECT

 SELECT CASE Index
  CASE 1 TO 662: DQBput B0, x, y, VARSEG(TPut(0, C)), VARPTR(TPut(0, C))
  CASE 663 TO 1080: MybPut x, y, VARSEG(TPut(0, C)), VARPTR(TPut(0, C))
  CASE 1081 TO 1498: DQBfPut B0, x, y, VARSEG(TPut(0, C)), VARPTR(TPut(0, C))
  CASE 1500 TO 1755: DQBboxf B0, x, y, x + 15, y + 15, C
 END SELECT

END SUB

REM $DYNAMIC
SUB EndProg

' Save settings
OPEN "CCLEVLED.INI" FOR BINARY AS #1
FOR I = 0 TO 63
A$ = A$ + MKI$(DA(I))
NEXT
PUT #1, , A$
CLOSE #1
StopMusic

' Graphic ending
DQBget 0, 0, 0, 319, 199, VARSEG(Array(0)), VARPTR(Array(0))
FOR K = 8 TO 71
 LX = 1280 \ K
 LY = 800 \ K
 DQBsPut B0, 160 - LX, 100 - LY, VARSEG(Array(0)), VARPTR(Array(0)), LX * 2, LY * 2
 PALfadeBlack K - 8, 0, 255
 DQBwait 1
 PALupdate
 DQBcopyLayer B0, 0
 DQBclearLayer B0
NEXT

' Text ending
DQBclose
 COLOR 10
 A$ = "Thank you for using Cyber Chick Level Editor v2"
  FOR L = 0 TO 1350 STEP 24
   DQBwait 1
   CLS
    FOR K = 1 TO LEN(A$)
     I$ = MID$(A$, K, 1)
     R = ((24 - K) / 2.2) * SIN(Rad2Deg * L)
     C = (24 - K) * COS(Rad2Deg * L) + (30 - (L \ 64))
     LOCATE R + 12, C + 16: PRINT I$;
    NEXT
  NEXT
  CLS
  LOCATE 14: PRINT A$
  FOR K = 1 TO 22: PRINT " ": DQBwait 1: NEXT
 Q& = SETMEM(84000)
END

END SUB

REM $STATIC
SUB FPSDisplay

' Frame Rate
Ticks = Ticks - (Ticks < 32760)
IF G! < TIMER THEN G! = TIMER + 1: FPS = Ticks: Ticks = 0
IF ABS(G! - TIMER) > 2 THEN G! = 0

' Flashing
IF (FrameTile AND 32) THEN
 PALfadeOut 224, 224, 16, 16, 16
 PALfadeOut 225, 225, 63, 33, 33
 PALfadeOut 226, 226, 0, 32, 63
 PALfadeOut 230, 230, 32, 32, 32
  ELSE
 PALfadeOut 224, 224, 47, 47, 47
 PALfadeOut 225, 225, 63, 63, 0
 PALfadeOut 226, 226, 0, 0, 63
 PALfadeOut 230, 230, 63, 63, 63
END IF

' Mouse always last
DQBput B0, MX, MY, VARSEG(MouseGFX(0)), VARPTR(MouseGFX(0))

END SUB

SUB GrabTiles

FOR y = 0 TO 80 STEP 16
FOR x = 0 TO 240 STEP 16
C = C + 1
DQBget 12, x, y, x + 15, y + 15, VARSEG(TPut(0, C)), VARPTR(TPut(0, C))
NEXT
NEXT

FOR y = 0 TO 80 STEP 16
FOR x = 0 TO 304 STEP 16
C = C + 1
DQBget 12, x, y + 96, x + 15, y + 111, VARSEG(TPut(0, C)), VARPTR(TPut(0, C))
NEXT
NEXT

END SUB

SUB Grid

IF DA(15) THEN
 x = DA(17) AND 15
 y = DA(18) AND 15
 FOR XX = 16 TO 304 STEP 16
 DQBbox B0, XX - x, 15, XX - x + 15, 176, 224
 NEXT
 FOR XX = 16 TO 176 STEP 16
 DQBbox B0, 15, XX - y, 304, XX - y + 15, 224
 NEXT
END IF

END SUB

REM $DYNAMIC
SUB IErrorEND (Text$)

DQBclose
COLOR 7
IF LEN(Text$) THEN PRINT Text$ ELSE PRINT DQBerror$
Q& = SETMEM(84000)
END

END SUB

REM $STATIC
SUB IInput

' Get our original input into variables
A1 = DQBmouseLB
A2 = DQBmouseRB
MX = DQBmouseX
MY = DQBmouseY
CH$ = INKEY$

' Mouse right button
IF MRB = -1 THEN MRB = 0
IF A2 THEN MRB = MRB - (MRB < 2) ELSE IF MRB THEN MRB = -1

' Mouse left button method one. (hold and release)
IF MLB1 = -1 THEN MLB1 = 0
IF A1 THEN MLB1 = MLB1 - (MLB1 < 2) ELSE IF MLB1 THEN MLB1 = -1

' Mouse left button method two. (behaving like INKEY$ input)
IF A1 THEN MDEL = MDEL + 1 ELSE MDEL = 0
SELECT CASE MDEL
  CASE 1: MLB2 = 1
  CASE 40: MLB2 = 1
  CASE 44: MLB2 = 1: MDEL = 40
  CASE ELSE: MLB2 = 0
END SELECT

' Counters
FrameTile = (FrameTile + 1) AND 63
Degrees = (Degrees + 1) MOD 360
LoJump = (LoJump + 1) MOD 126
HiJump = (HiJump + 1) MOD 166
IF LoJump < 63 THEN
 LY = LY + VAL(MID$(LowJump, LoJump + 1, 1))
 ELSE
 LY = LY - VAL(MID$(LowJump, 126 - LoJump, 1))
END IF
IF HiJump < 83 THEN
 HY = HY + VAL(MID$(HighJump, HiJump + 1, 1))
 ELSE
 HY = HY - VAL(MID$(HighJump, 166 - HiJump, 1))
END IF

' No mouse held, no active.
IF MLB1 = 0 THEN MainActive = 0: Active = 0
Area = 0
MainArea = 0

END SUB

REM $DYNAMIC
SUB Init
              
COM$ = COMMAND$
IF LEN(COM$) THEN
 IF INSTR(UCASE$(COM$), "NO") > 0 AND INSTR(UCASE$(COM$), "SOUND") > 0 THEN
 Lp = 1
 ELSE
 PRINT "Command line options:"
 PRINT "CCLEVLED /NOSOUND       To skip sound"
 END
 END IF
END IF

' Memory management
Q& = SETMEM(-84000)
IF DQBinit(18, 38, 0) THEN IErrorEND ""
 FOR I = 1 TO 18
 DQBclearLayer I
 NEXT
IF DQBsetBaseLayer(B0) = 0 THEN IErrorEND ""
IF DQBcreateBMap(1, 128, 137) THEN IErrorEND ""

' Most important input device needed
IF DQBmouseDetected = 0 THEN IErrorEND "Mouse is required for this level editor"

' Sound management
IF Lp THEN GOTO WithoutSound
OPEN "SOUND.INI" FOR INPUT AS #1
 INPUT #1, RR  ' On/Off
 INPUT #1, R   ' BaseAddr
 INPUT #1, G   ' IRQ
 INPUT #1, B   ' DMA
CLOSE #1
IF RR = 0 THEN GOTO WithoutSound
IF R > 0 THEN R = VAL("&H" + LTRIM$(STR$(R)))
IF DQBinstallSB(-1, 32, 22050, R, G, B) THEN GOTO WithoutSound

G! = 31183
FOR P = 30 TO 0 STEP -1
Pitch(P) = CINT(G!) AND 32767
G! = G! * .943875
NEXT
MasterSound = 1

WithoutSound:

' Make tables
FOR I = 0 TO 359
MyCOS(I) = COS(I * Rad2Deg) * 1024
MySIN(I) = SIN(I * Rad2Deg) * 1024
NEXT

RANDOMIZE TIMER
DQBinitVGA

END SUB

SUB Logo

' Load up logo
PALoff
LoadBSV 1, "MAINPAGE\L2.PAG"

' create palette for logo
FOR I = 0 TO 254
 PALpcw I, I \ 6, I \ 6, I \ 4
NEXT
PALpcw 255, 63, 63, 63

' Create translucent stuff
REDIM EPut2(0 TO 513) AS INTEGER
FOR I = 0 TO 15
 DQBellipse 0, 16, 15, I, I, 135 - (I \ 2)
 DQBellipse 0, 15, 16, I, I, 135 - (I \ 2)
 DQBellipse 0, 16, 16, I, I, 135 - (I \ 2)
NEXT
DQBget 0, 0, 0, 31, 31, VARSEG(EPut2(0)), VARPTR(EPut2(0))

FOR I = 0 TO 7
 FOR J = 0 TO 255
 DQBsetBMap 1, I + 128, J, ((I + 5) * J \ 4)
 NEXT
NEXT

' Logo loop
FOR I = 0 TO 463

 IF I < 64 THEN PALfadeBlack 63 - I, 0, 255
 IF I > 399 THEN PALfadeBlack I - 400, 0, 255
 ' Input
 IF DQBmouseLB OR DQBmouseRB OR LEN(INKEY$) THEN
  IF I > 64 AND I < 400 THEN I = 400
 END IF
 
  ' Wavey text
  FOR J = 0 TO 10
   DQBget B0, 179 + (J * 12), 72, 190 + (J * 12), 87, VARSEG(EPut(0)), VARPTR(EPut(0))
   F = MySIN((J * 60 + FF) MOD 360) \ 192
   DQBsPut B0, J * 12 + 94, 4 - F, VARSEG(EPut(0)), VARPTR(EPut(0)), 12, 30 + (F * 2)
  NEXT
  FF = (FF + 8) MOD 360
  DQBboxf B0, 179, 72, 319, 87, 0

 ' Shadows
 FFF = (FFF + 2) MOD 360
 x = 160 * MyCOS(FFF) \ 1024
 y = 40 * MySIN(FFF) \ 1024
 DQBbPut B0, 145 + x, 85 + y, VARSEG(EPut2(0)), VARPTR(EPut2(0)), 1
 DQBbPut B0, 145 - x, 85 - y, VARSEG(EPut2(0)), VARPTR(EPut2(0)), 1
 DQBbPut B0, 145 + (x \ 2), 85 + (y \ 2), VARSEG(EPut2(0)), VARPTR(EPut2(0)), 1
 DQBbPut B0, 145 - (x \ 2), 85 - (y \ 2), VARSEG(EPut2(0)), VARPTR(EPut2(0)), 1

 ' Update screen
 DQBwait 1
 PALupdate
 DQBcopyLayer B0, 0
 DQBcopyLayer 1, B0

NEXT
ERASE EPut2

END SUB

REM $STATIC
SUB MainDisp

' Print TOP row
PrintS "FPS:" + STR$(FPS), 4, 4, 6, 4
DQBget 5, 240, 0, 255, 15, VARSEG(QPut(0)), VARPTR(QPut(0))  ' Map icon
DQBfPut B0, 64, 0, VARSEG(QPut(0)), VARPTR(QPut(0))
DQBget 1, 256, 168, 271, 183, VARSEG(QPut(0)), VARPTR(QPut(0)) ' Music icon
DQBfPut B0, 240, 0, VARSEG(QPut(0)), VARPTR(QPut(0))
DQBget 1, 256, 16, 287, 23, VARSEG(QPut(0)), VARPTR(QPut(0))  ' Quit Icon
DQBfPut B0, 264, 4, VARSEG(QPut(0)), VARPTR(QPut(0))
FOR I = 0 TO 64 STEP 16
DQBget 1, 176 + I, 168, 191 + I, 183, VARSEG(QPut(0)), VARPTR(QPut(0))
DQBfPut B0, 96 + I, 0, VARSEG(QPut(0)), VARPTR(QPut(0))
 IF I < 48 THEN
  DQBget 1, 272 + I, 168, 287 + I, 183, VARSEG(QPut(0)), VARPTR(QPut(0))
  DQBfPut B0, 176 + I, 0, VARSEG(QPut(0)), VARPTR(QPut(0))
 END IF
NEXT

' Print pressed button
I = DA(0) * 16
SELECT CASE I
 CASE 0
   DQBget 5, 256, 0, 271, 15, VARSEG(QPut(0)), VARPTR(QPut(0))
   DQBfPut B0, 64, 0, VARSEG(QPut(0)), VARPTR(QPut(0))
 CASE 16 TO 80
   DQBget 1, 160 + I, 184, 175 + I, 199, VARSEG(QPut(0)), VARPTR(QPut(0))
   DQBfPut B0, 80 + I, 0, VARSEG(QPut(0)), VARPTR(QPut(0))
 CASE 96 TO 128
   DQBget 1, 176 + I, 184, 191 + I, 199, VARSEG(QPut(0)), VARPTR(QPut(0))
   DQBfPut B0, 80 + I, 0, VARSEG(QPut(0)), VARPTR(QPut(0))
END SELECT

' Is music playing?
IF MusicPlaying THEN
 DQBget 1, 256, 184, 271, 199, VARSEG(QPut(0)), VARPTR(QPut(0))
 DQBfPut B0, 240, 0, VARSEG(QPut(0)), VARPTR(QPut(0))
END IF

' Quit?
IF MainActive = 1 AND MainArea = 11 THEN
 DQBget 1, 288, 16, 319, 23, VARSEG(QPut(0)), VARPTR(QPut(0))
 DQBfPut B0, 264, 4, VARSEG(QPut(0)), VARPTR(QPut(0))
END IF

END SUB

SUB MainInp

' Mouse areas
IF MY < 16 THEN
 SELECT CASE MX \ 16
   CASE 4: MainArea = 1
   CASE 6 TO 13: MainArea = (MX \ 16) - 4
   CASE 15: MainArea = 10
 END SELECT
END IF

' Previous window
PDA = DA(0)

' Quit
IF MY > 3 AND MY < 12 AND MX > 263 AND MX < 296 THEN MainArea = 11
IF MainArea = 11 AND MLB1 = 1 THEN MainActive = 1
IF MainActive = 1 AND MainArea = 11 AND MLB1 = -1 THEN EndProg
IF CH$ = CHR$(27) THEN EndProg

' Keypress
SELECT CASE CH$
 CASE "~", "`": DA(0) = 0
 CASE CHR$(0) + CHR$(59): DA(0) = 1
 CASE CHR$(0) + CHR$(60): DA(0) = 2
 CASE CHR$(0) + CHR$(61): DA(0) = 3
 CASE CHR$(0) + CHR$(62): DA(0) = 4
 CASE CHR$(0) + CHR$(63): DA(0) = 5
 CASE CHR$(0) + CHR$(64): DA(0) = 6
 CASE CHR$(0) + CHR$(65): DA(0) = 7
 CASE CHR$(0) + CHR$(66): DA(0) = 8
 CASE CHR$(0) + CHR$(67)
   IF MasterSound = 1 THEN
    MusicPlaying = MusicPlaying XOR 1
    IF MusicPlaying = 0 THEN StopMusic
   END IF
 CASE CHR$(0) + CHR$(68): SaveEverything
END SELECT

' Music
IF MainArea AND MLB1 = 1 THEN
 IF MainArea < 10 THEN DA(0) = MainArea - 1
 IF MainArea = 10 THEN
   IF MasterSound = 1 THEN
    MusicPlaying = MusicPlaying XOR 1
    IF MusicPlaying = 0 THEN StopMusic
   END IF
 END IF
END IF

' Get Tile graphics
IF DA(0) <> 6 AND PDA = 6 THEN GrabTiles

END SUB

SUB PrintS (Text$, x, y, FC, BC)

DQBprint B0, Text$, x + 1, y + 1, BC
DQBprint B0, Text$, x, y, FC

END SUB

FUNCTION Zero$ (Number, Digits)

A$ = LTRIM$(STR$(Number))
A$ = STRING$(Digits - LEN(A$), "0") + A$
Zero$ = A$

END FUNCTION

