'$DYNAMIC
DEFINT A-Z

'DIRECTQB's stuff

DECLARE FUNCTION DQBError$ ()
DECLARE FUNCTION DQBInit (BYVAL NumLayers, BYVAL NumSounds, BYVAL MemSize)
DECLARE FUNCTION DQBInstallSB (BYVAL VolActive, BYVAL Channels, BYVAL Freq, BYVAL BaseAddr, BYVAL IRQ, BYVAL DMA)
DECLARE FUNCTION DQBInUse (BYVAL Voice)
DECLARE FUNCTION DQBKey (BYVAL ScanCode)
DECLARE FUNCTION DQBLoadImage (Layer, X, Y, FileName$, Pal$, imgWidth, imgHeight)
DECLARE FUNCTION DQBLoadSound (Slot, FileName$)
DECLARE FUNCTION DQBMapLayer (BYVAL Layer)
DECLARE FUNCTION DQBPoint (BYVAL Layer, BYVAL X, BYVAL Y)
DECLARE FUNCTION DQBSetBaseLayer (BYVAL Layer)

DECLARE SUB DQBBox (BYVAL Layer, BYVAL X1, BYVAL Y1, BYVAL X2, BYVAL Y2, BYVAL Col)
DECLARE SUB DQBBoxf (BYVAL Layer, BYVAL X1, BYVAL Y1, BYVAL X2, BYVAL Y2, BYVAL Col)
DECLARE SUB DQBbtPut (BYVAL Layer, BYVAL X, BYVAL Y, BYVAL BufSeg, BYVAL BufOff, BYVAL BTSeg)
DECLARE SUB DQBClearLayer (BYVAL Layer)
DECLARE SUB DQBClose ()
DECLARE SUB DQBCopyLayer (BYVAL SourceLayer, BYVAL DestLayer)
DECLARE SUB DQBcPut (BYVAL Layer, BYVAL X, BYVAL Y, BYVAL BufSeg, BYVAL BufOff)
DECLARE SUB DQBEllipse (BYVAL Layer, BYVAL X, BYVAL Y, BYVAL rx, BYVAL ry, BYVAL Col)
DECLARE SUB DQBfpu ()
DECLARE SUB DQBfPut (BYVAL Layer, BYVAL X, BYVAL Y, BYVAL BufSeg, BYVAL BufOff)
DECLARE SUB DQBGet (BYVAL Layer, BYVAL X1, BYVAL Y1, BYVAL X2, BYVAL Y2, BYVAL BufSeg, BYVAL BufOff)
DECLARE SUB DQBInitVGA ()
DECLARE SUB DQBInstallKeyboard ()
DECLARE SUB DQBLine (BYVAL Layer, BYVAL X1, BYVAL Y1, BYVAL X2, BYVAL Y2, BYVAL Col)
DECLARE SUB DQBPlaySound (BYVAL SoundNum, BYVAL Voice, BYVAL Freq, BYVAL LoopFlag)
DECLARE SUB DQBPset (BYVAL Layer, BYVAL X, BYVAL Y, BYVAL Col)
DECLARE SUB DQBPut (BYVAL Layer, BYVAL X, BYVAL Y, BYVAL BufSeg, BYVAL BufOff)
DECLARE SUB DQBrPut (BYVAL Layer, BYVAL X, BYVAL Y, BYVAL BufSeg, BYVAL BufOff, BYVAL Angle, BYVAL Zoom)
DECLARE SUB DQBScroll (BYVAL Layer, BYVAL dx, BYVAL dy)
DECLARE SUB DQBsetFreq (BYVAL Channel, BYVAL Frequency)
DECLARE SUB DQBSetSolidPut ()
DECLARE SUB DQBSetTransPut ()
DECLARE SUB DQBSetVoiceVol (BYVAL Voice, BYVAL Volume)
DECLARE SUB DQBSetVolume (BYVAL MasterVolume)
DECLARE SUB DQBsPut (BYVAL Layer, BYVAL X, BYVAL Y, BYVAL BufSeg, BYVAL BufOff, BYVAL NewWidth, BYVAL NewHeight)
DECLARE SUB DQBStopVoice (BYVAL Voice)
DECLARE SUB DQBWait (BYVAL Times)
DECLARE SUB DQBxPut (BYVAL SourceLayer, BYVAL X1, BYVAL Y1, BYVAL X2, BYVAL Y2, BYVAL DestLayer, BYVAL X, BYVAL Y)

CONST FALSE = 0, TRUE = NOT FALSE
CONST B0 = &H8000

' My stuff.
DECLARE FUNCTION AA (Value)
DECLARE FUNCTION ByteCode (Pointer&)
DECLARE FUNCTION Interpolate (Numb1, Numb2, Value, MaxValue)
DECLARE FUNCTION MyAngle (X1, Y1, X2, Y2)
DECLARE FUNCTION MyCollide (X1, WX1, Y1, WY1, X2, WX2, Y2, WY2)
DECLARE FUNCTION S2D16by16 (X, Y)
DECLARE FUNCTION SubDir$ (File$)

DECLARE SUB AlexaAction ()
DECLARE SUB AlexaPoint ()
DECLARE SUB AreaGET (AreaGrab)
DECLARE SUB BackGround ()
DECLARE SUB BremDraw ()
DECLARE SUB BremMath ()
DECLARE SUB BulBlit ()
DECLARE SUB CameraMath ()
DECLARE SUB CFPal (Value)
DECLARE SUB CheckULiq ()
DECLARE SUB ClearDATA ()
DECLARE SUB ClintDraw ()
DECLARE SUB ClintMath ()
DECLARE SUB CollideCorrect ()
DECLARE SUB Credits ()
DECLARE SUB CyberDraw ()
DECLARE SUB CyberMath ()
DECLARE SUB DemoKeyboard ()
DECLARE SUB DemoRecKey ()
DECLARE SUB Direct (DirCode, X, Y)
DECLARE SUB Display ()
DECLARE SUB DoorBULcol ()
DECLARE SUB DoorMath ()
DECLARE SUB DoorToDoor ()
DECLARE SUB DrawAlexa ()
DECLARE SUB DrawBUL ()
DECLARE SUB DrawCollide ()
DECLARE SUB DrawDoors ()
DECLARE SUB DrawExtraTiles ()
DECLARE SUB DrawTiles ()
DECLARE SUB EndLoop ()
DECLARE SUB EndProg ()
DECLARE SUB EnemFire (X, Y, Dir)
DECLARE SUB EnemyDraw ()
DECLARE SUB EnemyMath ()
DECLARE SUB EnemyStun ()
DECLARE SUB EnergyBall (X, Y)
DECLARE SUB EnvBULcol ()
DECLARE SUB ErrorEND ()
DECLARE SUB ExpFired (X, Y)
DECLARE SUB FadeBlack (Level, ColorA, ColorB)
DECLARE SUB FadeIN (Steps, ColorA, ColorB)
DECLARE SUB FadeOUT (Steps, ColorA, ColorB, R, G, B)
DECLARE SUB FPScountDisplay ()
DECLARE SUB GameOver ()
DECLARE SUB GotAnItem ()
DECLARE SUB GotSuit ()
DECLARE SUB GrabTiles ()
DECLARE SUB GunFired (X, Y, I)
DECLARE SUB ICUdraw ()
DECLARE SUB ICUmath ()
DECLARE SUB LoadB (Layer, File$)
DECLARE SUB LoadMusic (File$)
DECLARE SUB LoadSounds ()
DECLARE SUB Long2TempMap ()
DECLARE SUB Menu ()
DECLARE SUB MiscMath ()
DECLARE SUB Mosaic (Layer, Value)
DECLARE SUB MoveBUL ()
DECLARE SUB MusicLoop ()
DECLARE SUB MyKeyboard ()
DECLARE SUB NewBox (Layer, X1, Y1, X2, Y2, Col)
DECLARE SUB NewBox2 (X1, Y1, X2, Y2)
DECLARE SUB PalBitTil ()
DECLARE SUB PalOFF (ColorA, ColorB)
DECLARE SUB PalRotate (ColorA, ColorB, Direction)
DECLARE SUB PauseAndMap ()
DECLARE SUB PCR (Index, R, G, B)
DECLARE SUB PCW (Index, R, G, B)
DECLARE SUB Plat180Draw ()
DECLARE SUB Plat180Math ()
DECLARE SUB PlaySound (Snd)
DECLARE SUB Prepare ()
DECLARE SUB PrepareDemo ()
DECLARE SUB PrintB (Text$, L, X, Y)
DECLARE SUB PrintC (Text$, L, X, Y)
DECLARE SUB PrintS (Text$, L, X, Y)
DECLARE SUB Redir (Value)
DECLARE SUB SaveGame ()
DECLARE SUB SCR (Index, R, G, B)
DECLARE SUB SCW (Index, R, G, B)
DECLARE SUB SetMusicVolume (Value)
DECLARE SUB Shoot ()
DECLARE SUB SoundOption ()
DECLARE SUB StartUP ()
DECLARE SUB StopMusic ()
DECLARE SUB Story ()
DECLARE SUB Theme ()
DECLARE SUB VisitClinton ()
DECLARE SUB VMakeBorder ()
DECLARE SUB WaitWithMusic (Value)
DECLARE SUB WWdraw ()
DECLARE SUB WWmath ()
DECLARE SUB ZoneToZone ()

CONST CamY = "22222222121212121211110101001000100000010000000000000010"
CONST Gravity = "000100101010110111011111112121212112"
CONST HighJump = "44443434333332323232222222212121212112112112111111011010110101010100100010000100000"
CONST LAWBUG = "04040303030302020202010101010000000000-1-1-1-1-2-1-2-1-2-2-2-3"
CONST LowJump = "222222212121212112112112111111011010110101010100100010000100000"
CONST PI = 3.141593
CONST Rad2Deg = PI / 180
CONST Radian = 180 / PI
CONST ViewX = 288
CONST ViewY = 160

COMMON SHARED MasterSound
COMMON SHARED MasterVolume
COMMON SHARED MusicPlaying
COMMON SHARED MusicVolume
COMMON SHARED MVLoop
COMMON SHARED MVptr AS LONG
COMMON SHARED MVwait AS LONG

COMMON SHARED VirtX, VirtY
COMMON SHARED CameraX, CameraY, CameraTrans, CamAct
COMMON SHARED CenterX, CenterY, SubCentY
COMMON SHARED MaxX, MaxY
COMMON SHARED Player, Anything, EnemyCount, EBCycle
COMMON SHARED FrameTile, EarthQuake, Zone, SJump
COMMON SHARED GUNs, Energy, AskToSave, PauseVol
COMMON SHARED DemoRecord, DemoS, Demo, Scan
COMMON SHARED FPS, Ticks, Interval!, Energy2

COMMON SHARED VolTable() AS INTEGER
COMMON SHARED Pitch() AS INTEGER
COMMON SHARED BT() AS STRING * 1
COMMON SHARED CMap() AS STRING * 1
COMMON SHARED TMap() AS INTEGER
COMMON SHARED Header36() AS INTEGER
COMMON SHARED ET2() AS INTEGER
COMMON SHARED MyCOS() AS LONG
COMMON SHARED MySIN() AS LONG
COMMON SHARED EBall() AS INTEGER
COMMON SHARED THEPAL() AS INTEGER
COMMON SHARED THEPA2() AS INTEGER
COMMON SHARED MyKEYS() AS INTEGER
COMMON SHARED A() AS INTEGER
COMMON SHARED BulBits() AS INTEGER
COMMON SHARED Item() AS INTEGER
COMMON SHARED TPut() AS INTEGER
COMMON SHARED EN() AS INTEGER
COMMON SHARED EnFire() AS INTEGER
COMMON SHARED CCFire() AS INTEGER
COMMON SHARED Plat180() AS INTEGER
COMMON SHARED WPut() AS INTEGER
COMMON SHARED BPut() AS INTEGER
COMMON SHARED DisP() AS INTEGER
COMMON SHARED SPut() AS INTEGER
COMMON SHARED QPut() AS INTEGER
COMMON SHARED EPut() AS INTEGER
COMMON SHARED E() AS INTEGER
COMMON SHARED BulPoint() AS INTEGER
COMMON SHARED Doors() AS INTEGER
COMMON SHARED DoorUp() AS INTEGER
COMMON SHARED DoorTex() AS INTEGER
COMMON SHARED APs() AS INTEGER
COMMON SHARED FadeBegin() AS INTEGER
COMMON SHARED BRTs() AS INTEGER
COMMON SHARED ZD() AS INTEGER
COMMON SHARED CustPlat() AS INTEGER
COMMON SHARED MyEXP() AS INTEGER
COMMON SHARED Timing() AS INTEGER
COMMON SHARED GunSetG() AS INTEGER
COMMON SHARED GunSetB() AS INTEGER
COMMON SHARED EDEAD() AS INTEGER
COMMON SHARED ULiq() AS INTEGER
COMMON SHARED LiqB() AS INTEGER

DIM BT(2047) AS STRING * 1                              '  Blender Table
DIM CMap(-1 TO 72, -1 TO 40) AS STRING * 1              '  Collision Map
DIM TMap(-1 TO 72, -1 TO 40, 0 TO 1) AS INTEGER         '  Tile Maps
DIM TPut(0 TO 129, 1 TO 216) AS INTEGER                 '  Texture Tiles
DIM BPut(0 TO 129, 1 TO 6, 0 TO 3) AS INTEGER           '  Breakable Tiles
DIM Plat180(0 TO 3) AS INTEGER                          '  Dynamic Platforms
DIM Header36(1 TO 36) AS INTEGER                        '  36-Header
DIM ET2(0 TO 9) AS INTEGER                              '  Tile Map 2 Data
DIM VolTable(0 TO 15) AS INTEGER                        '  Volume Table
DIM Pitch(0 TO 30) AS INTEGER                           '  Frequency Table
DIM MyCOS(0 TO 359) AS LONG                             '  Faster COS Table
DIM MySIN(0 TO 359) AS LONG                             '  Faster SIN Table
DIM THEPAL(0 TO 255, 1 TO 3) AS INTEGER                 '  Palette Buffer
DIM THEPA2(0 TO 255, 1 TO 3) AS INTEGER                 '  Real Palette
DIM MyKEYS(1 TO 18) AS INTEGER                          '  Keyboard
DIM EBall(0 TO 5, 0 TO 5) AS INTEGER                    '  Energy balls
DIM A(1 TO 15) AS INTEGER                               '  Alexa Action
DIM Item(1 TO 50) AS INTEGER                            '  Inventory
DIM EN(1 TO 64, 1 TO 13) AS INTEGER                     '  Enemies Array
DIM EnFire(1 TO 8, 1 TO 4) AS INTEGER                   '  Enemy Fire!
DIM CCFire(1 TO 8, 1 TO 12) AS INTEGER                  '  Alexa's Bullets
DIM DisP(1 TO 8) AS INTEGER                             '  Keys Display
DIM SPut(0 TO 33) AS INTEGER                            '  64 Pixel PUT
DIM QPut(0 TO 129) AS INTEGER                           '  256 Pixel PUT
DIM EPut(0 TO 513) AS INTEGER                           '  1024 Pixel PUT
DIM E(1 TO 8, 1 TO 3) AS INTEGER                        '  Bullets Explode
DIM BulPoint(1 TO 4) AS INTEGER                         '  Bullets corners
DIM Doors(1 TO 8, 1 TO 5) AS INTEGER                    '  The doors Hor
DIM DoorUp(0 TO 5, 0 TO 3) AS INTEGER                   '  The doors Ver
DIM DoorTex(1 TO 8, 1 TO 4) AS INTEGER                  '  The door pipes
DIM APs(1 TO 24) AS INTEGER                             '  Alexa's points
DIM FadeBegin(1 TO 3) AS INTEGER                        '  Fade Switch
DIM BRTs(1 TO 6, 1 TO 4) AS INTEGER                     '  Breakable Tiles
DIM ZD(0 TO 19, 0 TO 19, 1 TO 5) AS INTEGER             '  Zone LUT DATA
DIM CustPlat(1 TO 6) AS INTEGER                         '  Custom Platform
DIM MyEXP(1 TO 8, 1 TO 3) AS INTEGER                    '  Big explosions
DIM Timing(0 TO 3) AS INTEGER                           '  Time-Elapse
DIM BulBits(0 TO 79, 0 TO 3) AS INTEGER                 '  Bullet pieces
DIM GunSetG(0 TO 2) AS INTEGER                          '  3 Guns
DIM GunSetB(0 TO 2) AS INTEGER                          '  3 Beams
DIM EDEAD(0 TO 4) AS INTEGER                            '  Boss enemies dead
DIM ULiq(0 TO 20) AS INTEGER                            '  Under liquid?
DIM LiqB(0 TO 15, 0 TO 2) AS INTEGER                    '  Liquid bubbles

