'$INCLUDE: 'DIRECTQB.BI'
DECLARE SUB PalRotate (ColorA, ColorB, Direction)
IF DQBinit(0, 0, 0) THEN DQBclose: PRINT DQBerror$: END
Q& = SETMEM(-64001)
IF DQBsetBaseLayer(B0) = 0 THEN DQBclose: PRINT DQBerror$: Q& = SETMEM(64001): END

DQBfpu
DQBinitVGA
RANDOMIZE TIMER
DIM MyCOS(359) AS LONG
DIM MySIN(359) AS LONG
CONST PI = 3.141593
CONST Rad2Deg = PI / 180
FOR I = 0 TO 359
MyCOS(I) = COS(I * Rad2Deg) * 1024
MySIN(I) = SIN(I * Rad2Deg) * 1024
NEXT

FOR I = 0 TO 31
OUT &H3C8, I + 1
OUT &H3C9, I * 2
OUT &H3C9, 0
OUT &H3C9, 0

OUT &H3C8, I + 33
OUT &H3C9, 63 - (I * 2)
OUT &H3C9, 0
OUT &H3C9, 0
NEXT

FOR I = 27 TO 31
OUT &H3C8, I
OUT &H3C9, 60
OUT &H3C9, (I - 27) * 10
OUT &H3C9, (I - 27) * 10

OUT &H3C8, I + 4
OUT &H3C9, 60
OUT &H3C9, (31 - I) * 10
OUT &H3C9, (31 - I) * 10
NEXT

DQBfpu

DO
T = T + 1: IF G! < TIMER THEN G! = TIMER + 1: FPS = T: T = 0
IF F = 0 THEN
Deg1 = (Deg1 + 721) MOD 360
Deg2 = (Deg2 + 719) MOD 360
END IF

FOR I = 1 TO 48
PG = G
PB = B
DC = ((MyCOS(Deg1) * (48 - I) \ 1024))
DS = ((MySIN(Deg2) * (48 - I) \ 1024))
G = (I * 32 \ (64 - I))
B = G * 1.5
C = (I + W) AND 63
DQBbox B0, (160 - B) - DC, (100 - G) - DS, (160 + B) - DC, (100 + G) - DS, C
IF PG <> G AND PB <> B THEN
FOR J = PG TO G
FOR K = PB TO B
DQBbox B0, (160 - K) - DC, (100 - J) - DS, (160 + K) - DC, (100 + J) - DS, C
NEXT
NEXT
END IF
NEXT

IF VSync THEN DQBwait 1
'PalRotate 1, 64, 0
F = (F + 1) MOD 3
W = (W - 1) AND 63
DQBCopyLayer B0, 0
DQBClearLayer B0

Ch$ = INKEY$
IF Ch$ = " " THEN VSync = VSync XOR 1
LOOP UNTIL Ch$ = CHR$(27)

DQBclose
PRINT DQBerror$
PRINT FPS

REM $DYNAMIC
SUB PalRotate (ColorA, ColorB, Direction)

IF Direction THEN
FOR A = ColorA TO ColorB
Switch = A
OUT &H3C7, Switch
R = INP(&H3C9)
G = INP(&H3C9)
B = INP(&H3C9)
Switch = A - 1: IF Switch < ColorA THEN Switch = ColorB
OUT &H3C8, Switch
OUT &H3C9, R
OUT &H3C9, G
OUT &H3C9, B
NEXT
EXIT SUB
END IF

FOR A = ColorB TO ColorA STEP -1
Switch = A
OUT &H3C7, Switch
R = INP(&H3C9)
G = INP(&H3C9)
B = INP(&H3C9)
Switch = A + 1: IF Switch > ColorB THEN Switch = ColorA
OUT &H3C8, Switch
OUT &H3C9, R
OUT &H3C9, G
OUT &H3C9, B
NEXT

END SUB

