'$INCLUDE: 'DIRECTQB.BI'
'$INCLUDE: 'CCLEV.BI'

REM $DYNAMIC
SUB CalcPalTrans.Disp

' Text and border
Border
DQBboxf B0, 16, 176, 303, 199, 0
PrintS "PALETTE EFFECTS AND TRANSLUCENCY:", 72, 20, 22, 20
PrintS "Background and tile palette:", 36, 170, 22, 50
PrintS "Background fading:", 48, 32, 55, 50
PrintS "Tiles/tiles fading:", 48, 72, 55, 50
PrintS "BG rotate:", 24, 112, 55, 50
PrintS "Tile rotate:", 96, 112, 55, 50

DrawButton "REFRESH ALL!", 70, 188, ((Area = 20) AND (Area = Active))

' Lines for testing blender
F = Degrees * .7111111
FOR I = 0 TO 127
 DQBbox B0, 256, I + 32, 287, I + 32, ((I + F) AND 255)
NEXT

' Blending puts
FOR I = 0 TO 7
 J = I * 16 + 32
 DQBboxf B0, 240, J, 255, J + 15, 129 + I
 DQBget B0, 240, J, 255, J + 15, VARSEG(QPut(0)), VARPTR(QPut(0))
 MybPut 256, J, VARSEG(QPut(0)), VARPTR(QPut(0))
NEXT

' Chosen translucency color
C = DA(57) * 16
DQBbox B0, 239, 31 + C, 288, 48 + C, 224
DQBbox B0, 238, 30 + C, 289, 49 + C, 224

' very bottom
PrintS "FCol A", 184, 192, 55, 50
PrintS "FCol B", 224, 192, 55, 50
PrintS "Opacity", 264, 192, 55, 50

' Bottom right
C = DA(57) * 3 + 46
OP1 = Header71(C)
FA1 = Header71(C + 1)
FB1 = Header71(C + 2)
PrintS Zero$(FA1, 3), 184, 167, 6, 4
PrintS Zero$(FB1, 3), 224, 167, 6, 4
PrintS Zero$(OP1, 3), 264, 167, 6, 4

' Palette
DQBboxf B0, 31, 180, 175, 185, 0
FOR X = 0 TO 63
 I = X \ 4
 G = X * 2 + 32 + I
 DQBboxf B0, G, 181, G + 1, 182, X + 64
 DQBboxf B0, G, 183, G + 1, 184, X + 128
NEXT

' Right list
FOR I = 0 TO 7
 OP1 = Header71(46 + (I * 3))
 FA1 = Header71(47 + (I * 3))
 FB1 = Header71(48 + (I * 3))
 PrintS Zero$(FA1, 3) + "---" + Zero$(FB1, 3), 180, I * 16 + 32, 6, 4
 PrintS "Opacity=" + Zero$(OP1, 3), 180, I * 16 + 40, 60, 57
NEXT

' Arrows
FOR X = 0 TO 80 STEP 40
FOR I = 0 TO 16 STEP 8
 DQBfPut B0, 184 + X + I, 176, VARSEG(Arrows(0, 2)), VARPTR(Arrows(0, 2))
 DQBfPut B0, 184 + X + I, 184, VARSEG(Arrows(0, 6)), VARPTR(Arrows(0, 6))
NEXT
NEXT
DQBget B0, 184, 176, 199, 191, VARSEG(EPut(0)), VARPTR(EPut(0))
DQBboxf B0, 96, 40, 151, 63, 227
DQBboxf B0, 96, 80, 151, 103, 228
DQBget 4, 144, 120, 151, 127, VARSEG(SPut(0)), VARPTR(SPut(0))
DQBfPut B0, 140, 32, VARSEG(SPut(0)), VARPTR(SPut(0))
DQBfPut B0, 140, 72, VARSEG(SPut(0)), VARPTR(SPut(0))
DQBfPut B0, 80, 112, VARSEG(SPut(0)), VARPTR(SPut(0))
DQBfPut B0, 152, 112, VARSEG(SPut(0)), VARPTR(SPut(0))
DQBfPut B0, 124, 48, VARSEG(EPut(0)), VARPTR(EPut(0))
DQBfPut B0, 132, 48, VARSEG(EPut(0)), VARPTR(EPut(0))
DQBfPut B0, 124, 88, VARSEG(EPut(0)), VARPTR(EPut(0))
DQBfPut B0, 132, 88, VARSEG(EPut(0)), VARPTR(EPut(0))
DQBget 4, 152, 120, 159, 127, VARSEG(SPut(0)), VARPTR(SPut(0))
IF Header71(18) THEN DQBfPut B0, 140, 32, VARSEG(SPut(0)), VARPTR(SPut(0))
IF Header71(23) THEN DQBfPut B0, 140, 72, VARSEG(SPut(0)), VARPTR(SPut(0))
IF Header71(28) THEN DQBfPut B0, 80, 112, VARSEG(SPut(0)), VARPTR(SPut(0))
IF Header71(32) THEN DQBfPut B0, 152, 112, VARSEG(SPut(0)), VARPTR(SPut(0))

' FADE stuff
FOR I = 0 TO 2
X = I * 24
DQBboxf B0, 24 + X, 40, 47 + X, 63, 253 + I
DQBboxf B0, 24 + X, 80, 47 + X, 103, 253 + I
DQBfPut B0, X + 32, 48, VARSEG(EPut(0)), VARPTR(EPut(0))
DQBfPut B0, X + 32, 88, VARSEG(EPut(0)), VARPTR(EPut(0))
NEXT
FOR I = 0 TO 40 STEP 40
PrintS "R", 24, 56 + I, 22, 0
PrintS "G", 48, 56 + I, 0, 22
PrintS "B", 72, 56 + I, 22, 0
PrintS "Steps:", 96, 56 + I, 224, 226
NEXT

' ROTATE stuff
DQBboxf B0, 24, 120, 87, 163, 8
DQBboxf B0, 96, 120, 159, 163, 8
PrintS "ColA:", 28, 157, 55, 50
PrintS "ColB:", 60, 157, 55, 50
PrintS "ColA:", 100, 157, 55, 50
PrintS "ColB:", 132, 157, 55, 50
PrintS "R:L", 36, 122, 55, 50
PrintS "R:L", 108, 122, 55, 50
DQBget 4, 144, 112, 151, 119, VARSEG(SPut(0)), VARPTR(SPut(0))
FOR I = 0 TO 8 STEP 8
DQBfPut B0, 28 + I, 140, VARSEG(EPut(0)), VARPTR(EPut(0))
DQBfPut B0, 60 + I, 140, VARSEG(EPut(0)), VARPTR(EPut(0))
DQBfPut B0, 100 + I, 140, VARSEG(EPut(0)), VARPTR(EPut(0))
DQBfPut B0, 132 + I, 140, VARSEG(EPut(0)), VARPTR(EPut(0))
DQBfPut B0, 52 + I, 121, VARSEG(SPut(0)), VARPTR(SPut(0))
DQBfPut B0, 124 + I, 121, VARSEG(SPut(0)), VARPTR(SPut(0))
NEXT
DQBget 4, 152, 112, 159, 119, VARSEG(SPut(0)), VARPTR(SPut(0))
DQBfPut B0, Header71(31) * 8 + 52, 121, VARSEG(SPut(0)), VARPTR(SPut(0))
DQBfPut B0, Header71(35) * 8 + 124, 121, VARSEG(SPut(0)), VARPTR(SPut(0))

' Pressed arrows
IF Area = Active THEN
SELECT CASE Area
  CASE 2: X = 184: Y = 176
  CASE 3: X = 192: Y = 176
  CASE 4: X = 200: Y = 176
  CASE 5: X = 224: Y = 176
  CASE 6: X = 232: Y = 176
  CASE 7: X = 240: Y = 176
  CASE 8: X = 264: Y = 176
  CASE 9: X = 272: Y = 176
  CASE 10: X = 280: Y = 176
  CASE 11: X = 184: Y = 184
  CASE 12: X = 192: Y = 184
  CASE 13: X = 200: Y = 184
  CASE 14: X = 224: Y = 184
  CASE 15: X = 232: Y = 184
  CASE 16: X = 240: Y = 184
  CASE 17: X = 264: Y = 184
  CASE 18: X = 272: Y = 184
  CASE 19: X = 280: Y = 184
  CASE 21: X = 32: Y = 48
  CASE 22: X = 40: Y = 48
  CASE 23: X = 56: Y = 48
  CASE 24: X = 64: Y = 48
  CASE 25: X = 80: Y = 48
  CASE 26: X = 88: Y = 48
  CASE 27: X = 124: Y = 48
  CASE 28: X = 132: Y = 48
  CASE 29: X = 140: Y = 48
  CASE 30: X = 32: Y = 56
  CASE 31: X = 40: Y = 56
  CASE 32: X = 56: Y = 56
  CASE 33: X = 64: Y = 56
  CASE 34: X = 80: Y = 56
  CASE 35: X = 88: Y = 56
  CASE 36: X = 124: Y = 56
  CASE 37: X = 132: Y = 56
  CASE 38: X = 140: Y = 56
  CASE 39: X = 32: Y = 88
  CASE 40: X = 40: Y = 88
  CASE 41: X = 56: Y = 88
  CASE 42: X = 64: Y = 88
  CASE 43: X = 80: Y = 88
  CASE 44: X = 88: Y = 88
  CASE 45: X = 124: Y = 88
  CASE 46: X = 132: Y = 88
  CASE 47: X = 140: Y = 88
  CASE 48: X = 32: Y = 96
  CASE 49: X = 40: Y = 96
  CASE 50: X = 56: Y = 96
  CASE 51: X = 64: Y = 96
  CASE 52: X = 80: Y = 96
  CASE 53: X = 88: Y = 96
  CASE 54: X = 124: Y = 96
  CASE 55: X = 132: Y = 96
  CASE 56: X = 140: Y = 96
  CASE 66: X = 28: Y = 140
  CASE 67: X = 36: Y = 140
  CASE 68: X = 44: Y = 140
  CASE 69: X = 60: Y = 140
  CASE 70: X = 68: Y = 140
  CASE 71: X = 76: Y = 140
  CASE 72: X = 100: Y = 140
  CASE 73: X = 108: Y = 140
  CASE 74: X = 116: Y = 140
  CASE 75: X = 132: Y = 140
  CASE 76: X = 140: Y = 140
  CASE 77: X = 148: Y = 140
  CASE 78: X = 28: Y = 148
  CASE 79: X = 36: Y = 148
  CASE 80: X = 44: Y = 148
  CASE 81: X = 60: Y = 148
  CASE 82: X = 68: Y = 148
  CASE 83: X = 76: Y = 148
  CASE 84: X = 100: Y = 148
  CASE 85: X = 108: Y = 148
  CASE 86: X = 116: Y = 148
  CASE 87: X = 132: Y = 148
  CASE 88: X = 140: Y = 148
  CASE 89: X = 148: Y = 148
 END SELECT
 SELECT CASE Area
 CASE 2 TO 10: DQBfPut B0, X, Y, VARSEG(Arrows(0, 3)), VARPTR(Arrows(0, 3))
 CASE 11 TO 19: DQBfPut B0, X, Y, VARSEG(Arrows(0, 7)), VARPTR(Arrows(0, 7))
 CASE 21 TO 29: DQBfPut B0, X, Y, VARSEG(Arrows(0, 3)), VARPTR(Arrows(0, 3))
 CASE 30 TO 38: DQBfPut B0, X, Y, VARSEG(Arrows(0, 7)), VARPTR(Arrows(0, 7))
 CASE 39 TO 47: DQBfPut B0, X, Y, VARSEG(Arrows(0, 3)), VARPTR(Arrows(0, 3))
 CASE 48 TO 56: DQBfPut B0, X, Y, VARSEG(Arrows(0, 7)), VARPTR(Arrows(0, 7))
 CASE 66 TO 77: DQBfPut B0, X, Y, VARSEG(Arrows(0, 3)), VARPTR(Arrows(0, 3))
 CASE 78 TO 89: DQBfPut B0, X, Y, VARSEG(Arrows(0, 7)), VARPTR(Arrows(0, 7))
 END SELECT
END IF

' Print numbers
PrintS Zero$(Header71(19), 3), 124, 41, 226, 224
PrintS Zero$(Header71(20), 2), 32, 41, 22, 0
PrintS Zero$(Header71(21), 2), 56, 41, 0, 22
PrintS Zero$(Header71(22), 2), 80, 41, 22, 0
PrintS Zero$(Header71(24), 3), 124, 81, 226, 224
PrintS Zero$(Header71(25), 2), 32, 81, 22, 0
PrintS Zero$(Header71(26), 2), 56, 81, 0, 22
PrintS Zero$(Header71(27), 2), 80, 81, 22, 0
PrintS Zero$(Header71(29), 3), 28, 132, 6, 4
PrintS Zero$(Header71(30), 3), 60, 132, 6, 4
PrintS Zero$(Header71(33), 3), 100, 132, 6, 4
PrintS Zero$(Header71(34), 3), 132, 132, 6, 4
      
END SUB

SUB CalcPalTrans.Inp

' Areas
IF MY >= 32 AND MY <= 159 AND MX >= 240 AND MX <= 287 THEN Area = 1
IF MY >= 176 AND MY <= 183 THEN
 SELECT CASE MX
  CASE 184 TO 191: Area = 2
  CASE 192 TO 199: Area = 3
  CASE 200 TO 207: Area = 4
  CASE 224 TO 231: Area = 5
  CASE 232 TO 239: Area = 6
  CASE 240 TO 247: Area = 7
  CASE 264 TO 271: Area = 8
  CASE 272 TO 279: Area = 9
  CASE 280 TO 287: Area = 10
 END SELECT
END IF
IF MY >= 184 AND MY <= 191 THEN
 SELECT CASE MX
  CASE 184 TO 191: Area = 11
  CASE 192 TO 199: Area = 12
  CASE 200 TO 207: Area = 13
  CASE 224 TO 231: Area = 14
  CASE 232 TO 239: Area = 15
  CASE 240 TO 247: Area = 16
  CASE 264 TO 271: Area = 17
  CASE 272 TO 279: Area = 18
  CASE 280 TO 287: Area = 19
 END SELECT
END IF
IF MX >= 70 AND MX <= 153 AND MY >= 188 AND MY <= 197 THEN Area = 20
SELECT CASE MX
 CASE 32 TO 39: X = 1
 CASE 40 TO 47: X = 2
 CASE 56 TO 63: X = 3
 CASE 64 TO 71: X = 4
 CASE 80 TO 87: X = 5
 CASE 88 TO 95: X = 6
 CASE 124 TO 131: X = 7
 CASE 132 TO 139: X = 8
 CASE 140 TO 147: X = 9
END SELECT
IF X THEN
 SELECT CASE MY
  CASE 48 TO 55: Y = 1
  CASE 56 TO 63: Y = 2
  CASE 88 TO 95: Y = 3
  CASE 96 TO 103: Y = 4
 END SELECT
END IF
IF X > 0 AND Y > 0 AND Area = 0 THEN Area = 20 + ((Y - 1) * 9) + X
IF MX > 139 AND MX < 148 THEN
 SELECT CASE MY
  CASE 32 TO 39: Area = 58
  CASE 72 TO 79: Area = 59
 END SELECT
END IF
IF MY > 111 AND MY < 120 THEN
 SELECT CASE MX
  CASE 80 TO 87: Area = 60
  CASE 152 TO 159: Area = 61
 END SELECT
END IF
IF MY > 120 AND MY < 129 THEN
 SELECT CASE MX
  CASE 52 TO 59: Area = 62
  CASE 60 TO 67: Area = 63
  CASE 124 TO 131: Area = 64
  CASE 132 TO 139: Area = 65
 END SELECT
END IF
IF MY > 139 AND MY < 155 THEN
 Y = (MY \ 148) * 12
 SELECT CASE MX
  CASE 28 TO 35: Area = 66
  CASE 36 TO 43: Area = 67
  CASE 44 TO 51: Area = 68
  CASE 60 TO 67: Area = 69
  CASE 68 TO 75: Area = 70
  CASE 76 TO 83: Area = 71
  CASE 100 TO 107: Area = 72
  CASE 108 TO 115: Area = 73
  CASE 116 TO 123: Area = 74
  CASE 132 TO 139: Area = 75
  CASE 140 TO 147: Area = 76
  CASE 148 TO 155: Area = 77
 END SELECT
 IF Area > 65 THEN Area = Area + Y
END IF

' Clicked an area
IF Area AND MLB1 = 1 THEN Active = Area

' if On area
IF Area = Active THEN
 IF Area = 20 AND MLB1 = -1 THEN CalcTrans
 IF Area = 1 THEN DA(57) = (MY - 32) \ 16
 IF MLB1 = 1 THEN
  SELECT CASE Area
   CASE 58: Header71(18) = Header71(18) XOR 1
   CASE 59: Header71(23) = Header71(23) XOR 1
   CASE 60: Header71(28) = Header71(28) XOR 1
   CASE 61: Header71(32) = Header71(32) XOR 1
   CASE 62: Header71(31) = 0
   CASE 63: Header71(31) = 1
   CASE 64: Header71(35) = 0
   CASE 65: Header71(35) = 1
  END SELECT
 END IF
 C = 46 + (DA(57) * 3)
 OP1 = Header71(C)
 FA1 = Header71(C + 1)
 FB1 = Header71(C + 2)
 R1 = Header71(20)
 G1 = Header71(21)
 BB1 = Header71(22)
 Step1 = Header71(19)
 R2 = Header71(25)
 G2 = Header71(26)
 BB2 = Header71(27)
 Step2 = Header71(24)
 BCA = Header71(29)
 BCB = Header71(30)
 FCA = Header71(33)
 FCB = Header71(34)
 IF MLB2 THEN
  SELECT CASE Area
   CASE 2: FA1 = FA1 + 100: IF FA1 > FB1 THEN FA1 = FB1
   CASE 3: FA1 = FA1 + 10: IF FA1 > FB1 THEN FA1 = FB1
   CASE 4: FA1 = FA1 + 1: IF FA1 > FB1 THEN FA1 = FB1
   CASE 5: FB1 = FB1 + 100
   CASE 6: FB1 = FB1 + 10
   CASE 7: FB1 = FB1 + 1
   CASE 8: OP1 = OP1 + 100
   CASE 9: OP1 = OP1 + 10
   CASE 10: OP1 = OP1 + 1
   CASE 11: FA1 = FA1 - 100
   CASE 12: FA1 = FA1 - 10
   CASE 13: FA1 = FA1 - 1
   CASE 14: FB1 = FB1 - 100: IF FB1 < FA1 THEN FB1 = FA1
   CASE 15: FB1 = FB1 - 10: IF FB1 < FA1 THEN FB1 = FA1
   CASE 16: FB1 = FB1 - 1: IF FB1 < FA1 THEN FB1 = FA1
   CASE 17: OP1 = OP1 - 100
   CASE 18: OP1 = OP1 - 10
   CASE 19: OP1 = OP1 - 1
   CASE 21: R1 = R1 + 10: CC = 1
   CASE 22: R1 = R1 + 1: CC = 1
   CASE 23: G1 = G1 + 10: CC = 1
   CASE 24: G1 = G1 + 1: CC = 1
   CASE 25: BB1 = BB1 + 10: CC = 1
   CASE 26: BB1 = BB1 + 1: CC = 1
   CASE 27: Step1 = Step1 + 100
   CASE 28: Step1 = Step1 + 10
   CASE 29: Step1 = Step1 + 1
   CASE 30: R1 = R1 - 10: CC = 1
   CASE 31: R1 = R1 - 1: CC = 1
   CASE 32: G1 = G1 - 10: CC = 1
   CASE 33: G1 = G1 - 1: CC = 1
   CASE 34: BB1 = BB1 - 10: CC = 1
   CASE 35: BB1 = BB1 - 1: CC = 1
   CASE 36: Step1 = Step1 - 100
   CASE 37: Step1 = Step1 - 10
   CASE 38: Step1 = Step1 - 1
   CASE 39: R2 = R2 + 10: CC = 1
   CASE 40: R2 = R2 + 1: CC = 1
   CASE 41: G2 = G2 + 10: CC = 1
   CASE 42: G2 = G2 + 1: CC = 1
   CASE 43: BB2 = BB2 + 10: CC = 1
   CASE 44: BB2 = BB2 + 1: CC = 1
   CASE 45: Step2 = Step2 + 100
   CASE 46: Step2 = Step2 + 10
   CASE 47: Step2 = Step2 + 1
   CASE 48: R2 = R2 - 10: CC = 1
   CASE 49: R2 = R2 - 1: CC = 1
   CASE 50: G2 = G2 - 10: CC = 1
   CASE 51: G2 = G2 - 1: CC = 1
   CASE 52: BB2 = BB2 - 10: CC = 1
   CASE 53: BB2 = BB2 - 1: CC = 1
   CASE 54: Step2 = Step2 - 100
   CASE 55: Step2 = Step2 - 10
   CASE 56: Step2 = Step2 - 1
   CASE 66: BCA = BCA + 100: IF BCA > BCB THEN BCA = BCB
   CASE 67: BCA = BCA + 10: IF BCA > BCB THEN BCA = BCB
   CASE 68: BCA = BCA + 1: IF BCA > BCB THEN BCA = BCB
   CASE 69: BCB = BCB + 100
   CASE 70: BCB = BCB + 10
   CASE 71: BCB = BCB + 1
   CASE 72: FCA = FCA + 100: IF FCA > FCB THEN FCA = FCB
   CASE 73: FCA = FCA + 10: IF FCA > FCB THEN FCA = FCB
   CASE 74: FCA = FCA + 1: IF FCA > FCB THEN FCA = FCB
   CASE 75: FCB = FCB + 100
   CASE 76: FCB = FCB + 10
   CASE 77: FCB = FCB + 1
   CASE 78: BCA = BCA - 100
   CASE 79: BCA = BCA - 10
   CASE 80: BCA = BCA - 1
   CASE 81: BCB = BCB - 100: IF BCB < BCA THEN BCB = BCA
   CASE 82: BCB = BCB - 10: IF BCB < BCA THEN BCB = BCA
   CASE 83: BCB = BCB - 1: IF BCB < BCA THEN BCB = BCA
   CASE 84: FCA = FCA - 100
   CASE 85: FCA = FCA - 10
   CASE 86: FCA = FCA - 1
   CASE 87: FCB = FCB - 100: IF FCB < FCA THEN FCB = FCA
   CASE 88: FCB = FCB - 10: IF FCB < FCA THEN FCB = FCA
   CASE 89: FCB = FCB - 1: IF FCB < FCA THEN FCB = FCA
  END SELECT
 END IF
  IF OP1 < 0 THEN OP1 = 0
  IF OP1 > 100 THEN OP1 = 100
  IF FA1 < 48 THEN FA1 = 48
  IF FA1 > 223 THEN FA1 = 223
  IF FB1 < 48 THEN FB1 = 48
  IF FB1 > 223 THEN FB1 = 223
  IF R1 > 63 THEN R1 = 63
  IF R2 > 63 THEN R2 = 63
  IF G1 > 63 THEN G1 = 63
  IF G2 > 63 THEN G2 = 63
  IF BB1 > 63 THEN BB1 = 63
  IF BB2 > 63 THEN BB2 = 63
  IF R1 < 0 THEN R1 = 0
  IF R2 < 0 THEN R2 = 0
  IF G1 < 0 THEN G1 = 0
  IF G2 < 0 THEN G2 = 0
  IF BB1 < 0 THEN BB1 = 0
  IF BB2 < 0 THEN BB2 = 0
  IF CC THEN
   PALscw 227, R1, G1, BB1
   PALpcw 227, R1, G1, BB1
   PALscw 228, R2, G2, BB2
   PALpcw 228, R2, G2, BB2
  END IF
  IF Step1 < 0 THEN Step1 = 0
  IF Step2 < 0 THEN Step2 = 0
  IF Step1 > 255 THEN Step1 = 255
  IF Step2 > 255 THEN Step2 = 255
  IF BCA < 64 THEN BCA = 64
  IF BCA > 127 THEN BCA = 127
  IF BCB < 64 THEN BCB = 64
  IF BCB > 127 THEN BCB = 127
  IF FCA < 128 THEN FCA = 128
  IF FCA > 191 THEN FCA = 191
  IF FCB < 128 THEN FCB = 128
  IF FCB > 191 THEN FCB = 191
  Header71(C) = OP1
  Header71(C + 1) = FA1
  Header71(C + 2) = FB1
 Header71(20) = R1
 Header71(21) = G1
 Header71(22) = BB1
 Header71(19) = Step1
 Header71(25) = R2
 Header71(26) = G2
 Header71(27) = BB2
 Header71(24) = Step2
 Header71(29) = BCA
 Header71(30) = BCB
 Header71(33) = FCA
 Header71(34) = FCB
END IF

END SUB

SUB DemoMisc.Disp

Border
PrintS "EDIT DEMO VARIABLES:", 114, 20, 22, 20
Demo = DA(58)

' Demo
DQBboxf B0, 36, 34, 105, 49, 1
PrintS "Demo #" + LTRIM$(STR$(Demo + 1)), 44, 38, 22, 3
DQBfPut B0, 106, 34, VARSEG(Arrows(0, 2)), VARPTR(Arrows(0, 2))
DQBfPut B0, 106, 42, VARSEG(Arrows(0, 6)), VARPTR(Arrows(0, 6))

' Draw Alexa
DQBboxf B0, 122, 28, 296, 128, 1
DQBget 4, 80, 128, 111, 159, VARSEG(EPut(0)), VARPTR(EPut(0))
DQBput B0, 176, 32, VARSEG(EPut(0)), VARPTR(EPut(0))
DQBget 4, 192, 128, 223, 159, VARSEG(EPut(0)), VARPTR(EPut(0))
DQBput B0, 176, 64, VARSEG(EPut(0)), VARPTR(EPut(0))
DQBget 4, 192, 160, 223, 191, VARSEG(EPut(0)), VARPTR(EPut(0))
DQBput B0, 176, 96, VARSEG(EPut(0)), VARPTR(EPut(0))
DQBget 4, 112, 128, 143, 159, VARSEG(EPut(0)), VARPTR(EPut(0))
DQBput B0, 208, 32, VARSEG(EPut(0)), VARPTR(EPut(0))
DQBget 4, 224, 128, 255, 159, VARSEG(EPut(0)), VARPTR(EPut(0))
DQBput B0, 208, 64, VARSEG(EPut(0)), VARPTR(EPut(0))
DQBget 4, 224, 160, 255, 191, VARSEG(EPut(0)), VARPTR(EPut(0))
DQBput B0, 208, 96, VARSEG(EPut(0)), VARPTR(EPut(0))

' CheckBox
DQBget 4, 144, 120, 151, 127, VARSEG(EPut(0)), VARPTR(EPut(0))
DQBfPut B0, 153, 39, VARSEG(EPut(0)), VARPTR(EPut(0))
DQBfPut B0, 124, 95, VARSEG(EPut(0)), VARPTR(EPut(0))
DQBfPut B0, 285, 32, VARSEG(EPut(0)), VARPTR(EPut(0))
DQBfPut B0, 269, 118, VARSEG(EPut(0)), VARPTR(EPut(0))
DQBget 4, 152, 120, 159, 127, VARSEG(EPut(0)), VARPTR(EPut(0))

' High Jump
IF Demos(7, Demo) THEN
DQBxPut 1, 120, 165, 160, 169, B0, 254, 112
DQBline B0, 226, 89, 246, 89, 4
DQBline B0, 246, 89, 266, 109, 4
DQBline B0, 226, 88, 246, 88, 6
DQBline B0, 246, 88, 266, 108, 6
DQBfPut B0, 269, 118, VARSEG(EPut(0)), VARPTR(EPut(0))
END IF

' Space Jump
IF Demos(8, Demo) THEN
DQBxPut 1, 120, 171, 164, 175, B0, 134, 97
DQBline B0, 182, 100, 204, 100, 4
DQBline B0, 182, 99, 204, 99, 6
DQBfPut B0, 124, 95, VARSEG(EPut(0)), VARPTR(EPut(0))
END IF

' Morph Jel
IF Demos(9, Demo) THEN
DQBxPut 1, 120, 159, 160, 163, B0, 242, 34
DQBline B0, 216, 63, 236, 43, 4
DQBline B0, 236, 43, 284, 43, 4
DQBline B0, 216, 62, 236, 42, 6
DQBline B0, 236, 42, 284, 42, 6
DQBfPut B0, 285, 32, VARSEG(EPut(0)), VARPTR(EPut(0))
END IF

' Weather suit
IF Demos(10, Demo) THEN
DQBxPut 1, 120, 153, 169, 157, B0, 135, 50
DQBline B0, 156, 58, 176, 78, 4
DQBline B0, 176, 78, 216, 78, 4
DQBline B0, 156, 57, 176, 77, 6
DQBline B0, 176, 77, 216, 77, 6
DQBfPut B0, 153, 39, VARSEG(EPut(0)), VARPTR(EPut(0))
 PALscw 28, 16, 16, 16
 PALscw 32, 32, 32, 32
 PALscw 35, 48, 48, 48
 PALscw 38, 63, 63, 63
ELSE
 PALscw 28, 24, 6, 20
 PALscw 32, 37, 10, 30
 PALscw 35, 51, 16, 41
 PALscw 38, 55, 37, 51
END IF

' Draw grey gun+beams
DQBboxf B0, 152, 134, 296, 167, 1
FOR X = 0 TO 2
CBNM = Demos(X * 2 + 11, Demo)
SELECT CASE CBNM
 CASE 0: DQBget 1, 40, 152, 55, 167, VARSEG(EPut(0)), VARPTR(EPut(0))
 CASE 1 TO 4: DQBget 1, 112 + (CBNM * 16), 120, 127 + (CBNM * 16), 135, VARSEG(EPut(0)), VARPTR(EPut(0))
END SELECT
DQBput B0, 160 + (X * 48), 148, VARSEG(EPut(0)), VARPTR(EPut(0))
CBNM = Demos(X * 2 + 12, Demo)
SELECT CASE CBNM
 CASE 0: DQBget 1, 40, 152, 55, 167, VARSEG(EPut(0)), VARPTR(EPut(0))
 CASE 1 TO 4: DQBget 1, 112 + (CBNM * 16), 136, 127 + (CBNM * 16), 151, VARSEG(EPut(0)), VARPTR(EPut(0))
END SELECT
DQBput B0, 176 + (X * 48), 148, VARSEG(EPut(0)), VARPTR(EPut(0))
NEXT

' Draw active gun+beam
X = Demos(17, Demo)
CBNM = Demos((X * 2 + 11), Demo)
SELECT CASE CBNM
CASE 0: DQBget 1, 56, 152, 71, 167, VARSEG(EPut(0)), VARPTR(EPut(0))
CASE 1 TO 4: DQBget 1, -16 + (CBNM * 16), 88, -1 + (CBNM * 16), 103, VARSEG(EPut(0)), VARPTR(EPut(0))
END SELECT
DQBput B0, 160 + (X * 48), 148, VARSEG(EPut(0)), VARPTR(EPut(0))
CBNM = Demos((X * 2 + 12), Demo)
SELECT CASE CBNM
CASE 0: DQBget 1, 56, 152, 71, 167, VARSEG(EPut(0)), VARPTR(EPut(0))
CASE 1 TO 4: DQBget 1, -16 + (CBNM * 16), 104, -1 + (CBNM * 16), 119, VARSEG(EPut(0)), VARPTR(EPut(0))
END SELECT
DQBput B0, 176 + (X * 48), 148, VARSEG(EPut(0)), VARPTR(EPut(0))

' Gun selection
X = Demos(17, Demo) * 48
DQBbox B0, X + 155, 145, X + 196, 167, 4
DQBbox B0, X + 156, 145, X + 195, 167, 5
DQBbox B0, X + 157, 145, X + 194, 167, 6

' Arrows
DQBfPut B0, 159, 136, VARSEG(Arrows(0, 0)), VARPTR(Arrows(0, 0))
DQBfPut B0, 167, 136, VARSEG(Arrows(0, 4)), VARPTR(Arrows(0, 4))
DQBget B0, 159, 136, 174, 143, VARSEG(EPut(0)), VARPTR(EPut(0))
DQBfPut B0, 177, 136, VARSEG(EPut(0)), VARPTR(EPut(0))
DQBfPut B0, 207, 136, VARSEG(EPut(0)), VARPTR(EPut(0))
DQBfPut B0, 225, 136, VARSEG(EPut(0)), VARPTR(EPut(0))
DQBfPut B0, 255, 136, VARSEG(EPut(0)), VARPTR(EPut(0))
DQBfPut B0, 273, 136, VARSEG(EPut(0)), VARPTR(EPut(0))

' Energy
DQBboxf B0, 26, 106, 113, 167, 1
PrintS "Energy = " + Zero$((Demos(0, Demo) + (Demos(1, Demo) * 256)), 3), 39, 128, 6, 4
PrintS "Tanks =" + STR$(Demos(6, Demo)), 39, 140, 6, 4
DQBfPut B0, 92, 139, VARSEG(EPut(0)), VARPTR(EPut(0))
HH = ((FrameTile AND 4) \ 4) * 16
DQBget 1, 128, 88 + HH, 143, 103 + HH, VARSEG(QPut(0)), VARPTR(QPut(0))
DQBfPut B0, 30, 110, VARSEG(QPut(0)), VARPTR(QPut(0))

' Energy Stat
DQBxPut 1, 120, 16, 151, 23, B0, 48, 150
PP = Demos(0, Demo) + (Demos(1, Demo) * 256)
PPP = Demos(6, Demo) * 100 + 99
IF PP > PPP THEN PP = PPP
PrintS Zero$(PP MOD 100, 2), 84, 150, 6, 4

' Arrows for Energy
FOR I = 0 TO 16 STEP 8
DQBfPut B0, 84 + I, 110, VARSEG(Arrows(0, 2)), VARPTR(Arrows(0, 2))
DQBfPut B0, 84 + I, 118, VARSEG(Arrows(0, 6)), VARPTR(Arrows(0, 6))
NEXT

' Energy Tanks
FOR I = 1 TO Demos(6, Demo)
IF Demos(0, Demo) + (Demos(1, Demo) * 256) < (I * 100) THEN
DQBget 1, 272, 88, 279, 95, VARSEG(EPut(0)), VARPTR(EPut(0))
ELSE
DQBget 1, 280, 88, 287, 95, VARSEG(EPut(0)), VARPTR(EPut(0))
END IF
DQBfPut B0, 34 + (I * 8), 160, VARSEG(EPut(0)), VARPTR(EPut(0))
NEXT

' Active arrows
IF Area = Active THEN
 SELECT CASE Area
  CASE 1: DQBfPut B0, 106, 34, VARSEG(Arrows(0, 3)), VARPTR(Arrows(0, 3))
  CASE 2: DQBfPut B0, 106, 42, VARSEG(Arrows(0, 7)), VARPTR(Arrows(0, 7))
  CASE 8: DQBfPut B0, 84, 110, VARSEG(Arrows(0, 3)), VARPTR(Arrows(0, 3))
  CASE 9: DQBfPut B0, 92, 110, VARSEG(Arrows(0, 3)), VARPTR(Arrows(0, 3))
  CASE 10: DQBfPut B0, 100, 110, VARSEG(Arrows(0, 3)), VARPTR(Arrows(0, 3))
  CASE 11: DQBfPut B0, 84, 118, VARSEG(Arrows(0, 7)), VARPTR(Arrows(0, 7))
  CASE 12: DQBfPut B0, 92, 118, VARSEG(Arrows(0, 7)), VARPTR(Arrows(0, 7))
  CASE 13: DQBfPut B0, 100, 118, VARSEG(Arrows(0, 7)), VARPTR(Arrows(0, 7))
  CASE 14: DQBfPut B0, 92, 139, VARSEG(Arrows(0, 1)), VARPTR(Arrows(0, 1))
  CASE 15: DQBfPut B0, 100, 139, VARSEG(Arrows(0, 5)), VARPTR(Arrows(0, 5))
  CASE 19: DQBfPut B0, 159, 136, VARSEG(Arrows(0, 1)), VARPTR(Arrows(0, 1))
  CASE 20: DQBfPut B0, 167, 136, VARSEG(Arrows(0, 5)), VARPTR(Arrows(0, 5))
  CASE 21: DQBfPut B0, 177, 136, VARSEG(Arrows(0, 1)), VARPTR(Arrows(0, 1))
  CASE 22: DQBfPut B0, 185, 136, VARSEG(Arrows(0, 5)), VARPTR(Arrows(0, 5))
  CASE 23: DQBfPut B0, 207, 136, VARSEG(Arrows(0, 1)), VARPTR(Arrows(0, 1))
  CASE 24: DQBfPut B0, 215, 136, VARSEG(Arrows(0, 5)), VARPTR(Arrows(0, 5))
  CASE 25: DQBfPut B0, 225, 136, VARSEG(Arrows(0, 1)), VARPTR(Arrows(0, 1))
  CASE 26: DQBfPut B0, 233, 136, VARSEG(Arrows(0, 5)), VARPTR(Arrows(0, 5))
  CASE 27: DQBfPut B0, 255, 136, VARSEG(Arrows(0, 1)), VARPTR(Arrows(0, 1))
  CASE 28: DQBfPut B0, 263, 136, VARSEG(Arrows(0, 5)), VARPTR(Arrows(0, 5))
  CASE 29: DQBfPut B0, 273, 136, VARSEG(Arrows(0, 1)), VARPTR(Arrows(0, 1))
  CASE 30: DQBfPut B0, 281, 136, VARSEG(Arrows(0, 5)), VARPTR(Arrows(0, 5))
 END SELECT
END IF

END SUB

SUB DemoMisc.Inp

' Variables
C = DA(58)
En = Demos(0, C) + (Demos(1, C) * 256)
Tank = Demos(6, C)

' Areas
IF MX > 105 AND MX < 114 THEN
 SELECT CASE MY
  CASE 34 TO 41: Area = 1
  CASE 42 TO 49: Area = 2
 END SELECT
END IF
IF MX >= 153 AND MY >= 39 AND MX <= 160 AND MY <= 46 THEN Area = 4
IF MX >= 285 AND MY >= 32 AND MX <= 292 AND MY <= 39 THEN Area = 5
IF MX >= 124 AND MY >= 95 AND MX <= 131 AND MY <= 102 THEN Area = 6
IF MX >= 269 AND MY >= 118 AND MX <= 276 AND MY <= 125 THEN Area = 7
IF MY > 109 AND MY < 118 THEN
 SELECT CASE MX
  CASE 84 TO 91: Area = 8
  CASE 92 TO 99: Area = 9
  CASE 100 TO 107: Area = 10
 END SELECT
END IF
IF MY > 117 AND MY < 126 THEN
 SELECT CASE MX
  CASE 84 TO 91: Area = 11
  CASE 92 TO 99: Area = 12
  CASE 100 TO 107: Area = 13
 END SELECT
END IF
IF MY > 138 AND MY < 147 THEN
 SELECT CASE MX
  CASE 92 TO 99: Area = 14
  CASE 100 TO 107: Area = 15
 END SELECT
END IF
IF MY >= 134 AND MY <= 167 THEN
 SELECT CASE MX
  CASE 152 TO 200: Area = 16
  CASE 201 TO 248: Area = 17
  CASE 249 TO 296: Area = 18
 END SELECT
END IF
IF MY > 135 AND MY < 144 THEN
 SELECT CASE MX
  CASE 159 TO 166: Area = 19
  CASE 167 TO 174: Area = 20
  CASE 177 TO 184: Area = 21
  CASE 185 TO 192: Area = 22
  CASE 207 TO 214: Area = 23
  CASE 215 TO 222: Area = 24
  CASE 225 TO 232: Area = 25
  CASE 233 TO 240: Area = 26
  CASE 255 TO 262: Area = 27
  CASE 263 TO 270: Area = 28
  CASE 273 TO 280: Area = 29
  CASE 281 TO 288: Area = 30
 END SELECT
END IF

' Demo select
IF MLB1 = 1 AND Area > 0 THEN Active = Area
IF Area = Active THEN
 IF MLB1 = 1 THEN
  SELECT CASE Area
   CASE 4: Demos(10, C) = Demos(10, C) XOR 1
   CASE 5: Demos(9, C) = Demos(9, C) XOR 1
   CASE 6: Demos(8, C) = Demos(8, C) XOR 1
   CASE 7: Demos(7, C) = Demos(7, C) XOR 1
   CASE 16 TO 18: Demos(17, C) = Area - 16
  END SELECT
 END IF
 IF MLB2 THEN
  SELECT CASE Area
   CASE 1: C = (C + 1) AND 3
   CASE 2: C = (C - 1) AND 3
   CASE 8: En = En + 100
   CASE 9: En = En + 10
   CASE 10: En = En + 1
   CASE 11: En = En - 100
   CASE 12: En = En - 10
   CASE 13: En = En - 1
   CASE 14: Tank = Tank + (Tank > 0)
   CASE 15: Tank = Tank - (Tank < 8)
   CASE 19
     Rp = Demos(11, C)
     Rp = Rp + (Rp > 0)
     Demos(11, C) = Rp
   CASE 20
     Rp = Demos(11, C)
     Rp = Rp - (Rp < 4)
     Demos(11, C) = Rp
   CASE 21
     Rp = Demos(12, C)
     Rp = Rp + (Rp > 0)
     Demos(12, C) = Rp
   CASE 22
     Rp = Demos(12, C)
     Rp = Rp - (Rp < 4)
     Demos(12, C) = Rp
   CASE 23
     Rp = Demos(13, C)
     Rp = Rp + (Rp > 0)
     Demos(13, C) = Rp
   CASE 24
     Rp = Demos(13, C)
     Rp = Rp - (Rp < 4)
     Demos(13, C) = Rp
   CASE 25
     Rp = Demos(14, C)
     Rp = Rp + (Rp > 0)
     Demos(14, C) = Rp
   CASE 26
     Rp = Demos(14, C)
     Rp = Rp - (Rp < 4)
     Demos(14, C) = Rp
   CASE 27
     Rp = Demos(15, C)
     Rp = Rp + (Rp > 0)
     Demos(15, C) = Rp
   CASE 28
     Rp = Demos(15, C)
     Rp = Rp - (Rp < 4)
     Demos(15, C) = Rp
   CASE 29
     Rp = Demos(16, C)
     Rp = Rp + (Rp > 0)
     Demos(16, C) = Rp
   CASE 30
     Rp = Demos(16, C)
     Rp = Rp - (Rp < 4)
     Demos(16, C) = Rp
  END SELECT
 END IF
END IF

DA(58) = C
IF En < 0 THEN En = 0
IF En > 899 THEN En = 899
Demos(0, C) = En AND 255
Demos(1, C) = En \ 256
Demos(6, C) = Tank

END SUB

SUB DrawButton (Text$, X, Y, Pressed)

C = DQBlen(Text$)
X2 = X + C + 16
Y2 = Y + 9

DQBboxf B0, X, Y, X2, Y2, 4
IF Pressed THEN
 DQBline B0, X, Y, X2, Y, 7
 DQBline B0, X, Y, X, Y2, 7
 DQBline B0, X2, Y, X2, Y2, 23
 DQBline B0, X, Y2, X2, Y2, 23
 DQBprint B0, Text$, X + 9, Y + 2, 6
  ELSE
 DQBline B0, X, Y, X2, Y, 23
 DQBline B0, X, Y, X, Y2, 23
 DQBline B0, X2, Y, X2, Y2, 7
 DQBline B0, X, Y2, X2, Y2, 7
 DQBprint B0, Text$, X + 8, Y + 1, 6
END IF

END SUB

SUB DrawObj (X, Y, Index, Special)

' Special is used for dynamic coordinates on map

IF Index < 48 AND DA(0) <> 2 THEN EXIT SUB
HH = (FrameTile AND 4) \ 4
H = ((FrameTile \ 8) AND 3) * 16
P = (FrameTile AND 3) * 16
C = Index

SELECT CASE C
  CASE 1
    IF X > 0 AND Y > 0 THEN DQBboxf B0, X, Y, X + 15, Y + 15, 1
  CASE 2, 3
    IF X > 0 AND Y > 0 THEN
    DQBboxf B0, X, Y + 1, X + 15, Y + 15, 1
    DQBline B0, X, Y, X + 15, Y, C
    END IF
  CASE 4
    IF X > 0 AND Y > 0 THEN DQBboxf B0, X, Y, X + 15, Y + 2, 4
  CASE 5
    IF X > 0 AND Y > 0 THEN
    DQBboxf B0, X, Y, X + 15, Y + 15, 1
    DQBboxf B0, X + 5, Y, X + 10, Y + 15, 20
    END IF
  CASE 6
    IF X > 0 AND Y > 0 THEN DQBboxf B0, X + 5, Y, X + 10, Y + 15, 20
  CASE 7
    IF X > 0 AND Y > 0 THEN
    DQBboxf B0, X, Y, X + 15, Y + 15, 1
    DQBline B0, X + 12, Y, X + 15, Y, 9
    END IF
  CASE 8
    IF X > 0 AND Y > 0 THEN
    DQBboxf B0, X, Y, X + 15, Y + 15, 1
    DQBline B0, X, Y, X + 2, Y, 9
    END IF
  CASE 9
    FOR XX = 0 TO 15
    DQBline B0, XX + X, Y, X, XX + Y, 1
    NEXT
  CASE 10
    FOR XX = 0 TO 15
    DQBline B0, (15 - XX) + X, Y, X + 15, XX + Y, 1
    NEXT
  CASE 11
    FOR XX = 0 TO 15
    DQBline B0, X, (15 - XX) + Y, XX + X, Y + 15, 1
    NEXT
  CASE 12
    FOR XX = 0 TO 15
    DQBline B0, XX + X, Y + 15, X + 15, XX + Y, 1
    NEXT
  CASE 13
    IF X > 0 AND Y > 0 THEN
    FOR XX = 0 TO 7
    DQBbox B0, (XX * 2) + X, XX + Y, (XX * 2) + X + 1, Y + 8, 1
    NEXT
    DQBboxf B0, X, Y + 9, X + 15, Y + 15, 1
    END IF
  CASE 14
    IF X > 0 AND Y > 0 THEN
    FOR XX = 0 TO 7
    DQBbox B0, (XX * 2) + X, XX + Y + 8, (XX * 2) + X + 1, Y + 15, 1
    NEXT
    END IF
  CASE 15
    IF X > 0 AND Y > 0 THEN
    FOR XX = 0 TO 7
    DQBbox B0, (XX * 2) + X, (7 - XX) + Y, (XX * 2) + X + 1, Y + 8, 1
    NEXT
    DQBboxf B0, X, Y + 9, X + 15, Y + 15, 1
    END IF
  CASE 16
    IF X > 0 AND Y > 0 THEN
    FOR XX = 0 TO 7
    DQBbox B0, (XX * 2) + X, (7 - XX) + Y + 8, (XX * 2) + X + 1, Y + 15, 1
    NEXT
    END IF
  CASE 17
    DQBline B0, X, Y, X + 15, Y + 7, 4
    DQBline B0, X, Y + 1, X + 15, Y + 8, 4
    DQBline B0, X, Y + 2, X + 15, Y + 9, 4
  CASE 18
    DQBline B0, X, Y + 8, X + 15, Y + 15, 4
    DQBline B0, X, Y + 9, X + 15, Y + 16, 4
    DQBline B0, X, Y + 10, X + 15, Y + 17, 4
  CASE 19
    DQBline B0, X, Y + 7, X + 15, Y, 4
    DQBline B0, X, Y + 8, X + 15, Y + 1, 4
    DQBline B0, X, Y + 9, X + 15, Y + 2, 4
  CASE 20
    DQBline B0, X, Y + 15, X + 15, Y + 8, 4
    DQBline B0, X, Y + 16, X + 15, Y + 9, 4
    DQBline B0, X, Y + 17, X + 15, Y + 10, 4
  CASE 21
    IF X > 0 AND Y > 0 THEN DQBboxf B0, X, Y, X + 15, Y + 7, 1
  CASE 22
    IF X > 0 AND Y > 0 THEN DQBboxf B0, X, Y + 8, X + 15, Y + 15, 1
  CASE 23
    IF X > 0 AND Y > 0 THEN DQBboxf B0, X, Y, X + 7, Y + 15, 1
  CASE 24
    IF X > 0 AND Y > 0 THEN DQBboxf B0, X + 8, Y, X + 15, Y + 15, 1
  CASE 25
    IF X > 0 AND Y > 0 THEN DQBboxf B0, X + 4, Y + 4, X + 11, Y + 11, 1
  CASE 26
    IF X > 0 AND Y > 0 THEN DQBboxf B0, X + 12, Y, X + 15, Y + 15, 55
  CASE 27
    IF X > 0 AND Y > 0 THEN DQBboxf B0, X, Y + 12, X + 15, Y + 15, 56
  CASE 28
    IF X > 0 AND Y > 0 THEN DQBboxf B0, X, Y, X + 3, Y + 15, 57
  CASE 29
    IF X > 0 AND Y > 0 THEN DQBboxf B0, X, Y, X + 15, Y + 3, 58
  CASE 30 TO 36
    IF X > 0 AND Y > 0 THEN DQBboxf B0, X + 4, Y + 4, X + 11, Y + 11, C - 9
  CASE 37
    DQBline B0, X, Y + 15, X + 15, Y, 4
    DQBline B0, X, Y + 16, X + 15, Y + 1, 4
    DQBline B0, X, Y + 17, X + 15, Y + 2, 4
    DQBline B0, X, Y + 18, X + 15, Y + 3, 4
  CASE 38
    DQBline B0, X, Y, X + 15, Y + 15, 4
    DQBline B0, X, Y + 1, X + 15, Y + 16, 4
    DQBline B0, X, Y + 2, X + 15, Y + 17, 4
    DQBline B0, X, Y + 3, X + 15, Y + 18, 4
  CASE 39 TO 44
    IF X > 0 AND Y > 0 THEN DQBboxf B0, X + 1, Y + 1, X + 14, Y + 14, C - 25
  CASE 49 TO 54
    J = FrameTile \ 8
    I = Index - 49
    IF FrameTile < 32 THEN
    DQBget 12, J * 16 + 256, I * 16, J * 16 + 271, I * 16 + 15, VARSEG(QPut(0)), VARPTR(QPut(0))
    DQBput B0, X, Y, VARSEG(QPut(0)), VARPTR(QPut(0))
    END IF
  CASE 55 TO 57
    I = (Index - 55) * 8
    DQBget 1, 144 + I, 88, 151 + I, 119, VARSEG(QPut(0)), VARPTR(QPut(0))
    DQBput B0, X, Y, VARSEG(QPut(0)), VARPTR(QPut(0))
    DQBget 1, 256, 120, 263, 151, VARSEG(QPut(0)), VARPTR(QPut(0))
    DQBput B0, X + 8, Y, VARSEG(QPut(0)), VARPTR(QPut(0))
  CASE 58 TO 60
    I = (Index - 58) * 8
    DQBget 1, 176, 88 + I, 207, 95 + I, VARSEG(QPut(0)), VARPTR(QPut(0))
    DQBput B0, X, Y, VARSEG(QPut(0)), VARPTR(QPut(0))
    DQBget 1, 288, 120, 319, 127, VARSEG(QPut(0)), VARPTR(QPut(0))
    DQBput B0, X, Y + 8, VARSEG(QPut(0)), VARPTR(QPut(0))
  CASE 61 TO 63
    I = (Index - 61) * 8
    DQBget 1, 208 + I, 88, 215 + I, 119, VARSEG(QPut(0)), VARPTR(QPut(0))
    DQBput B0, X + 8, Y, VARSEG(QPut(0)), VARPTR(QPut(0))
    DQBget 1, 280, 120, 287, 151, VARSEG(QPut(0)), VARPTR(QPut(0))
    DQBput B0, X, Y, VARSEG(QPut(0)), VARPTR(QPut(0))
  CASE 64 TO 66
    I = (Index - 64) * 8
    DQBget 1, 240, 88 + I, 271, 95 + I, VARSEG(QPut(0)), VARPTR(QPut(0))
    DQBput B0, X, Y + 8, VARSEG(QPut(0)), VARPTR(QPut(0))
    DQBget 1, 288, 144, 319, 151, VARSEG(QPut(0)), VARPTR(QPut(0))
    DQBput B0, X, Y, VARSEG(QPut(0)), VARPTR(QPut(0))
  CASE 67
    DQBget 1, 256, 120, 263, 151, VARSEG(QPut(0)), VARPTR(QPut(0))
    DQBput B0, X + 8, Y, VARSEG(QPut(0)), VARPTR(QPut(0))
  CASE 68
    DQBget 1, 288, 120, 319, 127, VARSEG(QPut(0)), VARPTR(QPut(0))
    DQBput B0, X, Y + 8, VARSEG(QPut(0)), VARPTR(QPut(0))
  CASE 69
    DQBget 1, 280, 120, 287, 151, VARSEG(QPut(0)), VARPTR(QPut(0))
    DQBput B0, X, Y, VARSEG(QPut(0)), VARPTR(QPut(0))
  CASE 70
    DQBget 1, 288, 144, 319, 151, VARSEG(QPut(0)), VARPTR(QPut(0))
    DQBput B0, X, Y, VARSEG(QPut(0)), VARPTR(QPut(0))
  CASE 71
    DQBget 4, 0, 112 + P, 15, 127 + P, VARSEG(QPut(0)), VARPTR(QPut(0))
    DQBput B0, X, Y, VARSEG(QPut(0)), VARPTR(QPut(0))
  CASE 72
    DQBget 4, 16, 96 + P, 47, 111 + P, VARSEG(EPut(0)), VARPTR(EPut(0))
    DQBput B0, X, Y, VARSEG(EPut(0)), VARPTR(EPut(0))
  CASE 73
    DQBget 4, H + 80, 80, H + 95, 95, VARSEG(QPut(0)), VARPTR(QPut(0))
    DQBput B0, X, Y, VARSEG(QPut(0)), VARPTR(QPut(0))
  CASE 74
    DQBget 4, H + 80, 96, H + 95, 111, VARSEG(QPut(0)), VARPTR(QPut(0))
    DQBput B0, X, Y, VARSEG(QPut(0)), VARPTR(QPut(0))
  CASE 75 TO 78
    I = (Index - 75) * 16
    R = Degrees MOD 24
    DQBget 4, (R \ 12) * 16, I, (R \ 12) * 16 + 15, I + 15, VARSEG(QPut(0)), VARPTR(QPut(0))
    DQBput B0, X, Y, VARSEG(QPut(0)), VARPTR(QPut(0))
  CASE 79 TO 82
    I = (Index - 79) * 16
    R = Degrees MOD 24
    DQBget 4, (R \ 12) * 16 + 32, I, (R \ 12) * 16 + 47, I + 15, VARSEG(QPut(0)), VARPTR(QPut(0))
    DQBput B0, X, Y, VARSEG(QPut(0)), VARPTR(QPut(0))
  CASE 83 TO 84
    I = (Index - 83) * 16
    P = (FrameTile \ 8) * 16
    DQBget 4, P + 64, I, P + 79, I + 15, VARSEG(QPut(0)), VARPTR(QPut(0))
    DQBput B0, X, Y, VARSEG(QPut(0)), VARPTR(QPut(0))
  CASE 85 TO 88
    I = (Index - 85) * 16
    R = Degrees MOD 24
    H = (FrameTile * 2) AND 15
    DQBget 4, 64 + ((R \ 6) * 16), 32, 79 + ((R \ 6) * 16), 47, VARSEG(QPut(0)), VARPTR(QPut(0))
    DQBput B0, X, Y, VARSEG(QPut(0)), VARPTR(QPut(0))
    SELECT CASE I
     CASE 0: DQBput B0, X - H, Y - H, VARSEG(QPut(0)), VARPTR(QPut(0))
     CASE 16: DQBput B0, X - H, Y + H, VARSEG(QPut(0)), VARPTR(QPut(0))
     CASE 32: DQBput B0, X + H, Y - H, VARSEG(QPut(0)), VARPTR(QPut(0))
     CASE 48: DQBput B0, X + H, Y + H, VARSEG(QPut(0)), VARPTR(QPut(0))
    END SELECT
  CASE 89
    IF FrameTile < 16 THEN R = 0 ELSE R = 16
    DQBget 4, 64 + R, 48, 79 + R, 63, VARSEG(QPut(0)), VARPTR(QPut(0))
    DQBput B0, X, Y, VARSEG(QPut(0)), VARPTR(QPut(0))
  CASE 90
    R = (FrameTile \ 8) AND 3
    IF FrameTile AND 32 THEN R = 3 - R
    R = R * 16
    DQBget 4, 128 + R, 48, 143 + R, 63, VARSEG(QPut(0)), VARPTR(QPut(0))
    DQBput B0, X, Y, VARSEG(QPut(0)), VARPTR(QPut(0))
  CASE 91
    R = FrameTile AND 15
    IF FrameTile AND 16 THEN R = 15 - R
    I = (FrameTile AND 32) \ 2
    DQBget 4, 192 + ((R \ 4) * 16), 16 + I, 207 + ((R \ 4) * 16), 31 + I, VARSEG(QPut(0)), VARPTR(QPut(0))
    DQBput B0, X, Y - R, VARSEG(QPut(0)), VARPTR(QPut(0))
    DQBget 4, 208, 64, 223, 79, VARSEG(QPut(0)), VARPTR(QPut(0))
    DQBput B0, X, Y, VARSEG(QPut(0)), VARPTR(QPut(0))
  CASE 92
    R = ((Degrees MOD 24) \ 6) * 16
    DQBget 4, 192 + R, 0, 207 + R, 15, VARSEG(QPut(0)), VARPTR(QPut(0))
    DQBput B0, X, Y, VARSEG(QPut(0)), VARPTR(QPut(0))
  CASE 93 TO 94
    R = ((FrameTile \ 4) AND 3) * 16
    DQBget 4, 192 + R, 48, 207 + R, 63, VARSEG(QPut(0)), VARPTR(QPut(0))
    DQBput B0, X, Y, VARSEG(QPut(0)), VARPTR(QPut(0))
    IF Index - 93 = 1 THEN A$ = "H" ELSE A$ = "L"
    DQBprint B0, A$, X + 4, Y + 4, 0
    DQBprint B0, A$, X + 3, Y + 3, 23
     IF Special AND (FrameTile AND 1) = 1 THEN
       I = Index - 93
       IF I THEN
       DQBput B0, X, Y - HY, VARSEG(QPut(0)), VARPTR(QPut(0))
       ELSE
       DQBput B0, X, Y - LY, VARSEG(QPut(0)), VARPTR(QPut(0))
       END IF
     END IF
  CASE 95 TO 96
    I = ((96 - Index) * 16)
    R = ((FrameTile \ 4) AND 3) * 16
    DQBget 4, R, 64 + I, 15 + R, 79 + I, VARSEG(QPut(0)), VARPTR(QPut(0))
    DQBput B0, X, Y, VARSEG(QPut(0)), VARPTR(QPut(0))
  CASE 97
    I = FrameTile AND 15
    R = (FrameTile AND 32) \ 2
    DQBget 4, 64, 64 + R, 79, 79 + R, VARSEG(QPut(0)), VARPTR(QPut(0))
    DQBput B0, X, Y + I, VARSEG(QPut(0)), VARPTR(QPut(0))
  CASE 98 TO 113
    DQBget 4, 144, 80 + BB, 159, 95 + BB, VARSEG(QPut(0)), VARPTR(QPut(0))
    DQBput B0, X, Y, VARSEG(QPut(0)), VARPTR(QPut(0))
    DQBget 4, 80 + ((FrameTile \ 8) * 16), 64, 95 + ((FrameTile \ 8) * 16), 79, VARSEG(QPut(0)), VARPTR(QPut(0))
    DQBput B0, X, Y, VARSEG(QPut(0)), VARPTR(QPut(0))
    A$ = LTRIM$(STR$(Index - 97))
    DQBprint B0, A$, X + 1, Y + 1, 0
    DQBprint B0, A$, X, Y, 23
     IF Special AND (FrameTile AND 1) = 1 THEN
      I = (((C - 98) \ 4) AND 1) * 3 + 3
      IF ((C - 98) AND 1) THEN D = ((359 - Degrees) * I) ELSE D = Degrees * I
      P = (((C - 98) \ 2) AND 1) * 180
      R = ((C - 98) \ 8) * 25 + 25
      XX = R * MyCOS((P + D) MOD 360) \ 1024 + X
      YY = R * MySIN((P + D) MOD 360) \ 1024 + Y
      BB = (FrameTile AND 2) * 8
      DQBget 4, 144, 80 + BB, 159, 95 + BB, VARSEG(QPut(0)), VARPTR(QPut(0))
      DQBput B0, XX, YY, VARSEG(QPut(0)), VARPTR(QPut(0))
      DQBget 4, 80 + ((FrameTile \ 8) * 16), 64, 95 + ((FrameTile \ 8) * 16), 79, VARSEG(QPut(0)), VARPTR(QPut(0))
      DQBput B0, XX, YY, VARSEG(QPut(0)), VARPTR(QPut(0))
     END IF
  CASE 114 TO 116
      P = ((FrameTile \ 4) AND 3) * 16
      R = FrameTile AND 240
      I = ((C - 114) * 64) + R
      DQBget 4, 256 + P, I, 271 + P, I + 15, VARSEG(QPut(0)), VARPTR(QPut(0))
      DQBput B0, X, Y, VARSEG(QPut(0)), VARPTR(QPut(0))
  CASE 117 TO 124
      DQBget 1, 128, 88 + (HH * 16), 143, 103 + (HH * 16), VARSEG(QPut(0)), VARPTR(QPut(0))
      DQBput B0, X, Y, VARSEG(QPut(0)), VARPTR(QPut(0))
      DQBprint B0, LTRIM$(STR$(C - 116)), X + 4, Y + 4, 0
      DQBprint B0, LTRIM$(STR$(C - 116)), X + 3, Y + 3, 23
  CASE 125 TO 128
      DQBget 1, 64 + ((C - 125) * 16), 104 + (HH * 32), 79 + ((C - 125) * 16), 119 + (HH * 32), VARSEG(QPut(0)), VARPTR(QPut(0))
      DQBput B0, X, Y, VARSEG(QPut(0)), VARPTR(QPut(0))
  CASE 129 TO 132
      DQBget 1, 64 + ((C - 129) * 16), 88 + (HH * 32), 79 + ((C - 129) * 16), 103 + (HH * 32), VARSEG(QPut(0)), VARPTR(QPut(0))
      DQBput B0, X, Y, VARSEG(QPut(0)), VARPTR(QPut(0))
  CASE 133 TO 136
      DQBget 1, 128 + (HH * 64) + ((C - 133) * 16), 120, 143 + (HH * 64) + ((C - 133) * 16), 135, VARSEG(QPut(0)), VARPTR(QPut(0))
      DQBput B0, X, Y, VARSEG(QPut(0)), VARPTR(QPut(0))
  CASE 137 TO 140
      DQBget 1, 128 + (HH * 64) + ((C - 137) * 16), 136, 143 + (HH * 64) + ((C - 137) * 16), 151, VARSEG(QPut(0)), VARPTR(QPut(0))
      DQBput B0, X, Y, VARSEG(QPut(0)), VARPTR(QPut(0))
  CASE 141 TO 144
      R = (Index - 141) * 32: F = 0
      IF FrameTile AND 32 THEN F = 32
      DQBget 3, 192 + R, F, 223 + R, F + 31, VARSEG(EPut(0)), VARPTR(EPut(0))
      DQBput B0, X, Y, VARSEG(EPut(0)), VARPTR(EPut(0))
  CASE 146 TO 150
      I = (Index - 146) * 16
      DQBget 3, 192 + I, 64, 207 + I, 79, VARSEG(QPut(0)), VARPTR(QPut(0))
      DQBput B0, X, Y, VARSEG(QPut(0)), VARPTR(QPut(0))
  CASE 151 TO 154
        SELECT CASE Index
         CASE 151: A$ = "HOT"
         CASE 152: A$ = "COLD"
         CASE 153: A$ = "REG"
         CASE 154: A$ = "BURN"
        END SELECT
       PrintS A$, X, Y, 6, 4
      IF DA(0) <> 2 THEN EXIT SUB
      IF Special THEN
        I = FrameTile AND 15
        R = (FrameTile + 8) AND 15
        DQBline B0, 16, Y + I, 303, Y + I, 6
        DQBline B0, 16, Y + R, 303, Y + R, 6
        SELECT CASE Index
         CASE 151: A$ = "HOT LIQUID"
         CASE 152: A$ = "FREEZING WATER"
         CASE 153: A$ = "REGULAR WATER"
         CASE 154: A$ = "BURNING LIQUID"
        END SELECT
        PrintS A$, 122 + FrameTile, Y + 4, 6, 4
       END IF
  CASE 155 TO 157
       SELECT CASE Index
        CASE 155: A$ = "SS"
        CASE 156: A$ = "OV"
        CASE 157: A$ = "SW"
       END SELECT
       DQBprint B0, A$, X, Y, 6
       IF DA(0) <> 2 THEN EXIT SUB
       IF Special THEN
         SELECT CASE Index
         CASE 155: A$ = "SEE-SAW PLATFORM"
         CASE 156: A$ = "OVAL PLATFORM"
         CASE 157: A$ = "SWING PLATFORM"
         END SELECT
        IF FrameTile AND 32 THEN DQBprint B0, A$, 32 + FrameTile, 32 + ((Index - 155) * 10), 6
       END IF
  CASE 160 TO 163
    I = Index - 160
    DQBget 3, 192, 80, 207, 95, VARSEG(QPut(0)), VARPTR(QPut(0))
    DQBput B0, X, Y, VARSEG(QPut(0)), VARPTR(QPut(0))
    J = ((FrameTile \ 4) AND 1) * 8
    DQBget 3, 288 + J, 72, 295 + J, 79, VARSEG(SPut(0)), VARPTR(SPut(0))
     FOR R = 0 TO 240 STEP 120
     IF (Index AND 1) = 1 THEN P = 4 ELSE P = 2
     D = Degrees
     IF Index > 161 THEN D = 359 - D
     XX = MyCOS(((D * P) + R) MOD 360) \ 80 + 4
     YY = MySIN(((D * P) + R) MOD 360) \ 80 + 4
     DQBput B0, XX + X, YY + Y, VARSEG(SPut(0)), VARPTR(SPut(0))
     NEXT
  CASE 164
     SELECT CASE FrameTile
        CASE 0 TO 15, 32 TO 47
          DQBget 3, 176, 96, 191, 127, VARSEG(EPut(0)), VARPTR(EPut(0))
          DQBput B0, X + 8, Y, VARSEG(EPut(0)), VARPTR(EPut(0))
        CASE 16 TO 31
          DQBget 3, 0, 176, 15, 191, VARSEG(QPut(0)), VARPTR(QPut(0))
          DQBput B0, X + 8, Y, VARSEG(QPut(0)), VARPTR(QPut(0))
          DQBget 3, 16, 192, 31, 199, VARSEG(QPut(0)), VARPTR(QPut(0))
          DQBput B0, X + 8, Y + 16, VARSEG(QPut(0)), VARPTR(QPut(0))
          DQBget 3, 176, 192, 191, 199, VARSEG(QPut(0)), VARPTR(QPut(0))
          DQBput B0, X + 8, Y + 24, VARSEG(QPut(0)), VARPTR(QPut(0))
          DQBget 3, 184, 32, 191, 63, VARSEG(EPut(0)), VARPTR(EPut(0))
          DQBput B0, X + 24, Y, VARSEG(EPut(0)), VARPTR(EPut(0))
        CASE 48 TO 63
          DQBget 3, 48, 176, 63, 191, VARSEG(QPut(0)), VARPTR(QPut(0))
          DQBput B0, X + 8, Y, VARSEG(QPut(0)), VARPTR(QPut(0))
          DQBget 3, 16, 192, 31, 199, VARSEG(QPut(0)), VARPTR(QPut(0))
          DQBput B0, X + 8, Y + 16, VARSEG(QPut(0)), VARPTR(QPut(0))
          DQBget 3, 176, 192, 191, 199, VARSEG(QPut(0)), VARPTR(QPut(0))
          DQBput B0, X + 8, Y + 24, VARSEG(QPut(0)), VARPTR(QPut(0))
          DQBget 3, 176, 32, 183, 63, VARSEG(EPut(0)), VARPTR(EPut(0))
          DQBput B0, X, Y, VARSEG(EPut(0)), VARPTR(EPut(0))
     END SELECT
  CASE 165
     F = FrameTile AND 240
     DQBget 3, 64 + F, 176, 79 + F, 191, VARSEG(QPut(0)), VARPTR(QPut(0))
     DQBput B0, X, Y, VARSEG(QPut(0)), VARPTR(QPut(0))
  CASE 166 TO 181
     I = Index - 166
     IF (I AND 4) THEN J = 6 ELSE J = 4
     D = (Degrees * J) MOD 360  '    ((-((NX AND 4) = 4) + 1)*2)+2
     P = (I \ 8) + 1
     F = FrameTile AND 32
     DQBget 5, 240 + F, 80, 271 + F, 111, VARSEG(EPut(0)), VARPTR(EPut(0))
     SELECT CASE I AND 3
      CASE 0: R = 24
      CASE 1: R = 40
      CASE 2: R = 56
      CASE 3: R = 64
     END SELECT
     YY = R * MySIN(D) \ 1024
      IF Special AND (FrameTile AND 1) = 1 THEN
      DQBput B0, X, Y + YY, VARSEG(EPut(0)), VARPTR(EPut(0))
      END IF
      DQBput B0, X, Y, VARSEG(EPut(0)), VARPTR(EPut(0))
      DQBprint B0, "Ra=" + LTRIM$(STR$(R)), X + 3, Y + 3, 23
      DQBprint B0, "DS=" + LTRIM$(STR$(J)), X + 3, Y + 13, 23
      DQBprint B0, "XS=" + LTRIM$(STR$(P)), X + 3, Y + 23, 23
  CASE 200 TO 207
     SELECT CASE C
      CASE 200: A$ = "SLf"
      CASE 201: A$ = "SRf"
      CASE 202: A$ = "BLf"
      CASE 203: A$ = "BRf"
      CASE 204: A$ = "SLs"
      CASE 205: A$ = "SRs"
      CASE 206: A$ = "BLs"
      CASE 207: A$ = "BRs"
     END SELECT
      DQBprint B0, A$, X + 1, Y + 1, 0
      DQBprint B0, A$, X, Y, 23
      DQBprint B0, STR$(C), X + 1, Y + 9, 0
      DQBprint B0, STR$(C), X, Y + 8, 23
       IF Special THEN

  IncT = 30
  Widt = 35
  Max = 30
  IF (C AND 1) THEN S = GearInc ELSE S = GearDec
  IF (C AND 2) THEN IncT = 15: Widt = 67: Max = 15
  IF (C AND 4) THEN S = S \ 2
  S = S MOD Max

  FOR IIs = 0 TO 359 STEP IncT
  SD = IIs + S
  ST = ((SD + 109) \ 23) AND 15
  CXs = Widt * MyCOS(SD) \ 1024 + X
  CYs = Widt * MySIN(SD) \ 1024 + Y
  DQBput B0, CXs - 4, CYs - 4, VARSEG(Teeth(0, ST)), VARPTR(Teeth(0, ST))
  NEXT IIs
      
       END IF
  CASE 224 TO 229
    IF DA(0) <> 2 THEN EXIT SUB
    I = Index - 223
      DQBline B0, X, Y, X + 31, Y, 6
      DQBline B0, X, Y, X, Y + 31, 6
      DQBline B0, X + 31, Y, X + 31, Y + 31, 6
      DQBline B0, X, Y + 31, X + 31, Y + 31, 6
      DQBprint B0, "ID=" + LTRIM$(STR$(I)), X + 7, Y + 7, 0
      DQBprint B0, "ID=" + LTRIM$(STR$(I)), X + 6, Y + 6, 23
  CASE 230 TO 255
      DQBget 1, 128 + (HH * 16), 176, 143 + (HH * 16), 191, VARSEG(QPut(0)), VARPTR(QPut(0))
      DQBput B0, X, Y, VARSEG(QPut(0)), VARPTR(QPut(0))
      DQBprint B0, CHR$(C - 165), X + 4, Y + 4, 0
      DQBprint B0, CHR$(C - 165), X + 3, Y + 3, 23
END SELECT

END SUB

SUB LoadBSV (DestLayer, File$)

IF DQBloadImage(DestLayer, 0, 0, File$, "", 320, 200) THEN
IErrorEND "Unable to open file: " + File$
END IF

END SUB

SUB MusicLoop

IF MusicPlaying <> 1 OR MasterSound <> 1 THEN EXIT SUB
IF MVwait& > 0 THEN MVwait& = MVwait& - 1: EXIT SUB

BackAgain:
Byte1 = ByteCode(MVptr&)

IF Byte1 = 0 THEN StopMusic: EXIT SUB
MVptr& = MVptr& + 1
IF Byte1 > 84 THEN Byte2 = ByteCode(MVptr&): MVptr& = MVptr& + 1
IF Byte1 > 122 THEN Byte3 = ByteCode(MVptr&): MVptr& = MVptr& + 1
IF Byte1 > 140 THEN Byte4 = ByteCode(MVptr&): MVptr& = MVptr& + 1
IF Byte1 > 190 THEN Byte5 = ByteCode(MVptr&): MVptr& = MVptr& + 1

SELECT CASE Byte1
'       1 Byte
CASE 1 TO 32: MVwait& = Byte1 - 1: EXIT SUB
CASE 33: FOR I = 13 TO 28: DQBstopVoice I: NEXT
CASE 34: MVLoop = 0: MVptr& = 0
CASE 35: MVLoop = (MVLoop + 1) AND 255
CASE 36: MVLoop = (MVLoop - 1) AND 255
CASE 37 TO 52: DQBplaySound Byte1 - 15, Byte1 - 24, 22050, 0
CASE 53 TO 68: DQBplaySound Byte1 - 31, Byte1 - 40, 11025, 0
CASE 69 TO 84: DQBplaySound Byte1 - 47, Byte1 - 56, 5513, 0
'       2 Bytes
CASE 85: MVLoop = Byte2 AND 255
CASE 86: MVLoop = (MVLoop + Byte2) AND 255
CASE 87: MVLoop = (MVLoop - Byte2) AND 255
CASE 88
FOR I = 0 TO 15: DQBsetVoiceVol I + 13, Byte2 AND 63: NEXT
CASE 89: DQBstopVoice 13 + (Byte2 AND 15)
CASE 90 TO 105: DQBsetVoiceVol Byte1 - 77, (Byte2 AND 63)
CASE 106: MVwait& = Byte2: EXIT SUB
CASE 107 TO 122: DQBplaySound Byte1 - 85, Byte1 - 94, Pitch(Byte2 AND 31), Byte2 \ 32
'       3 Bytes
CASE 123: DQBplaySound 22 + (Byte2 AND 15), (Byte2 \ 16) + 13, Pitch(Byte3 AND 31), Byte3 \ 32
CASE 124: MVwait& = (Byte3 * 256) + Byte2: EXIT SUB
CASE 125 TO 140: DQBsetFreq Byte1 - 112, (Byte3 * 256) + Byte2
'       4 Bytes
CASE 141: MVwait& = (Byte4 * 65536) + (Byte3 * 256) + Byte2: EXIT SUB
CASE 142 TO 157: IF MVLoop < (Byte1 - 142) THEN MVptr& = (Byte4 * 65536) + (Byte3 * 256) + Byte2
CASE 158 TO 173: IF MVLoop > (Byte1 - 158) THEN MVptr& = (Byte4 * 65536) + (Byte3 * 256) + Byte2
CASE 174 TO 189: IF MVLoop = (Byte1 - 174) THEN MVptr& = (Byte4 * 65536) + (Byte3 * 256) + Byte2
CASE 190: MVptr& = (Byte4 * 65536) + (Byte3 * 256) + Byte2
'       5 Bytes
CASE 191: IF MVLoop < Byte2 THEN MVptr& = (Byte5 * 65536) + (Byte4 * 256) + Byte3
CASE 192: IF MVLoop > Byte2 THEN MVptr& = (Byte5 * 65536) + (Byte4 * 256) + Byte3
CASE 193: IF MVLoop = Byte2 THEN MVptr& = (Byte5 * 65536) + (Byte4 * 256) + Byte3
END SELECT
GOTO BackAgain

END SUB

SUB PalBitTil

' Background stuff
'    Fade
'18) FADEbackground
IF Header71(18) THEN
IF Header71(17) = 0 THEN Header71(16) = Header71(16) + 1: IF Header71(16) > Header71(19) THEN Header71(17) = 1
IF Header71(17) THEN Header71(16) = Header71(16) - 1: IF Header71(16) < 0 THEN Header71(17) = 0: Header71(16) = 0
IF Header71(17) = 0 THEN PALfadeOut 64, 127, Header71(20), Header71(21), Header71(22)
IF Header71(17) THEN PALfadeIn 64, 127
END IF
'    Rotate
IF Header71(28) THEN PALrotate Header71(29), Header71(30), Header71(31)
'    Auto scroll
IF Header71(10) = 0 THEN Header71(12) = 0
IF Header71(11) THEN
Header71(12) = Header71(12) - Header71(10)
IF Header71(12) < 0 THEN Header71(12) = Header71(12) + 5120
ELSE
Header71(12) = (Header71(12) + Header71(10)) MOD 5120
END IF

' Tiles palette stuff

' Palette fading
IF Header71(23) THEN
IF Header71(15) = 0 THEN Header71(14) = Header71(14) + 1: IF Header71(14) > Header71(24) THEN Header71(15) = 1
IF Header71(15) THEN Header71(14) = Header71(14) - 1: IF Header71(14) < 0 THEN Header71(15) = 0: Header71(14) = 0
IF Header71(15) = 0 THEN PALfadeOut 128, 191, Header71(25), Header71(26), Header71(27)
IF Header71(15) THEN PALfadeIn 128, 191
END IF

' Rotate
IF Header71(32) THEN PALrotate Header71(33), Header71(34), Header71(35)
' Auto scroll for extra tiles
IF Header71(36) = 3 THEN
Header71(37) = Header71(37) AND 255
IF Header71(38) = 0 THEN Header71(38) = 1
IF Header71(39) = 0 THEN Header71(39) = 1
IF Header71(40) = 0 THEN Header71(44) = 0
IF Header71(41) = 0 THEN Header71(45) = 0
WX = 4608 * Header71(38)
 IF Header71(42) THEN
  Header71(44) = (Header71(44) - ABS(Header71(40))): IF Header71(44) < 0 THEN Header71(44) = Header71(44) + WX
  ELSE
  Header71(44) = (Header71(44) + Header71(40)) MOD WX
 END IF
WY = 2560 * Header71(39)
 IF Header71(43) THEN
  Header71(45) = (Header71(45) - ABS(Header71(41))): IF Header71(45) < 0 THEN Header71(45) = Header71(45) + WY
  ELSE
  Header71(45) = (Header71(45) + Header71(41)) MOD WY
 END IF
END IF

END SUB

SUB SaveEverything

MyMsg 1
PALoff
DEF SEG = &HA000

 ' Maps
 P = LEN(Desc$)
 FOR WY = 0 TO Header71(3) - 1    ' Header
 FOR WX = 0 TO Header71(2) - 1
  C = 0
  FOR Y1 = 0 TO 1
  FOR X1 = 0 TO 17
   XX1 = X1 + (Header71(0) * 18) + (WX * 18)
   YY1 = Y1 + (Header71(1) * 2) + (WY * 2) + 160
   DQBpset 6, XX1, YY1, Header71(C)
   DQBpset 7, XX1, YY1, Header71(C + 36)
   IF C < P THEN
   DQBpset 8, XX1, YY1, ASC(MID$(Desc$, C + 1, 1))
   ELSE
   DQBpset 8, XX1, YY1, 0
   END IF
   C = C + 1
  NEXT
  NEXT
 NEXT
 NEXT
 
  FOR Y1 = 0 TO (Header71(3) * 10) - 1   ' DATA
  FOR X1 = 0 TO (Header71(2) * 18) - 1
   XX1 = X1 + (Header71(0) * 18)
   YY1 = Y1 + (Header71(1) * 10)
   DQBpset 6, XX1, YY1, ASC(CMap(X1, Y1))
   DQBpset 7, XX1, YY1, TMap(X1, Y1, 0) AND 255
   DQBpset 8, XX1, YY1, TMap(X1, Y1, 0) \ 256
   DQBpset 9, XX1, YY1, TMap(X1, Y1, 1) AND 255
   DQBpset 10, XX1, YY1, TMap(X1, Y1, 1) \ 256
  NEXT
  NEXT
   FOR I = 0 TO 4
    DQBcopyLayer I + 6, 0
    BSAVE "MAPS\" + CHR$(DA(3) + 65) + LTRIM$(STR$(I)) + ".MAP", 0, 64000
   NEXT

 ' Background
 BIT$ = CHR$(Header71(4)) + CHR$(Header71(5))
 FOR I = 0 TO 63
 PALpcr I + 64, R, G, B
 DQBpset 11, I, 197, R
 DQBpset 11, I, 198, G
 DQBpset 11, I, 199, B
 NEXT
 DQBcopyLayer 11, 0
 BSAVE "BITS\" + BIT$ + ".BIT", 0, 64000

 ' Tileset
 TIL$ = CHR$(Header71(6)) + CHR$(Header71(7))
 FOR I = 0 TO 63
 PALpcr I + 128, R, G, B
 DQBpset 12, I, 197, R
 DQBpset 12, I, 198, G
 DQBpset 12, I, 199, B
 NEXT
 DQBcopyLayer 12, 0
 BSAVE "TILES\" + TIL$ + ".TIL", 0, 64000

 ' Demo data
 FOR Y = 0 TO 3
 FOR X = 0 TO 17
 DQBpset 5, X + 302, Y, Demos(X, Y)
 NEXT
 NEXT
 DQBcopyLayer 5, 0
 BSAVE "SAVEDATA.SAV", 0, 64000

PALreset

END SUB

SUB StopMusic

FOR I = 13 TO 28
DQBstopVoice I
DQBsetVoiceVol I, 63
NEXT
MVptr& = 0
MVLoop = 0
MVwait& = 0
MusicPlaying = 0

END SUB

SUB Tile.Disp

' Coors
X = DA(17)
Y = DA(18)
dx = X \ 16
dy = Y \ 16
PX = X AND 15
PY = Y AND 15

' Display tiles
FOR XX = 0 TO 18
 FOR YY = 0 TO 10
  DrawTile XX * 16 - PX + 16, YY * 16 - PY + 16, TMap(dx + XX, dy + YY, 0)
 NEXT
NEXT

' Snap
IF Area = 18 THEN
 FX = ((MX - 16 + PX) AND 32752) - PX
 FY = ((MY - 16 + PY) AND 32752) - PY
 DrawTile FX + 16, FY + 16, DA(22)
END IF

' Grid + Border
Grid
TTX1 = TTileX1 - DA(17)
TTY1 = TTileY1 - DA(18)
TTX2 = TTileX2 - DA(17)
TTY2 = TTileY2 - DA(18)
DQBline B0, TTX1, TTY1, TTX2, TTY1, 225
DQBline B0, TTX2, TTY1, TTX2, TTY2, 225
DQBline B0, TTX1, TTY2, TTX2, TTY2, 225
DQBline B0, TTX1, TTY1, TTX1, TTY2, 225
Border

' Buttons
DrawButton "TILES", 24, 178, ((Area = 29) AND (Area = Active))
DrawButton "GRID", 145, 178, ((Area = 30) AND (Area = Active))
DrawButton "SCROLL", 224, 178, ((Area = 31) AND (Area = Active))
DQBboxf B0, 24, 190, 127, 198, 7
PrintS "Draw over objects:", 25, 191, 6, 4
C = Header71(13) * 8 + 144
DQBget 4, C, 120, C + 7, 127, VARSEG(SPut(0)), VARPTR(SPut(0))
DQBfPut B0, 118, 191, VARSEG(SPut(0)), VARPTR(SPut(0))

' Tiles
IF DA(21) THEN WTileDraw
WScrollDisp

END SUB

SUB Tile.Inp

' Scroll window?
IF DA(16) AND MX >= 221 AND MX <= 298 AND MY >= 93 AND MY <= 170 THEN
 Area = WScrollInp
 Active = Area
 EXIT SUB
END IF

WTileInp

IF MY >= 178 AND MY <= 187 THEN
 SELECT CASE MX
  CASE 24 TO 68: Area = 29
  CASE 145 TO 183: Area = 30
  CASE 224 TO 276: Area = 31
 END SELECT
END IF
IF MX >= 118 AND MX <= 125 THEN
 IF MY >= 191 AND MY <= 198 THEN Area = 32
END IF

IF MLB1 = 1 THEN
 SELECT CASE Area
 CASE 29: DA(21) = DA(21) XOR 1: Active = 29
 CASE 30: DA(15) = DA(15) XOR 1: Active = 30
 CASE 31: DA(16) = DA(16) XOR 1: Active = 31
 CASE 32: Header71(13) = Header71(13) XOR 1: Active = 32
 END SELECT
END IF

END SUB

