'$INCLUDE: 'DIRECTQB.BI'
'$INCLUDE: 'CCLEV.BI'

REM $DYNAMIC
SUB BG.Disp

SELECT CASE Header71(9)
CASE 0
  DQBcopyLayer 11, B0
CASE 1
  DQBcopyLayer 11, B0
  DQBscroll B0, Header71(12) \ 16, 0
CASE 2
  C = Header71(10)
  DQBcopyLayer 11, B0
  IF C THEN DQBscroll B0, -(DA(17) \ C), -(DA(18) \ 32)
END SELECT

' Grid + Border
Grid
Border

' Buttons
DrawButton "OPTIONS", 97, 178, ((Area = 20) AND (Area = Active))
DrawButton "GRID", 175, 178, ((Area = 19) AND (Area = Active))
DrawButton "SCROLL", 224, 178, ((Area = 18) AND (Area = Active))

' Options
IF DA(24) THEN
 DQBboxf B0, 96, 64, 187, 167, 7
 FOR X = 0 TO 2
 DQBbox B0, 95 - X, 63 - X, 185 + X, 168 + X, 6 - X
 NEXT
 C = (Header71(9) * 10)
  DQBbox B0, 96, 64 + C, 184, 73 + C, 0
  DQBboxf B0, 97, 65 + C, 183, 72 + C, 226
 PrintS "NO SCROLL", 100, 65, 6, 4
 PrintS "AUTO SCROLL", 100, 75, 6, 4
 PrintS "DEPTH SCROLL", 100, 85, 6, 4
 PrintS "Depth/Auto-Speed:", 100, 100, 55, 50
 PrintS Zero$(Header71(10), 3), 124, 112, 6, 4
  FOR I = 0 TO 16 STEP 8
  DQBfPut B0, I + 124, 120, VARSEG(Arrows(0, 2)), VARPTR(Arrows(0, 2))
  DQBfPut B0, I + 124, 128, VARSEG(Arrows(0, 6)), VARPTR(Arrows(0, 6))
  NEXT
  IF Area = Active THEN
  SELECT CASE Area
   CASE 21: DQBfPut B0, 124, 120, VARSEG(Arrows(0, 3)), VARPTR(Arrows(0, 3))
   CASE 22: DQBfPut B0, 132, 120, VARSEG(Arrows(0, 3)), VARPTR(Arrows(0, 3))
   CASE 23: DQBfPut B0, 140, 120, VARSEG(Arrows(0, 3)), VARPTR(Arrows(0, 3))
   CASE 24: DQBfPut B0, 124, 128, VARSEG(Arrows(0, 7)), VARPTR(Arrows(0, 7))
   CASE 25: DQBfPut B0, 132, 128, VARSEG(Arrows(0, 7)), VARPTR(Arrows(0, 7))
   CASE 26: DQBfPut B0, 140, 128, VARSEG(Arrows(0, 7)), VARPTR(Arrows(0, 7))
  END SELECT
  END IF
 PrintS "Right:", 112, 140, 55, 50
 PrintS "Left:", 112, 148, 55, 50
 DQBget 4, 144, 112, 151, 119, VARSEG(SPut(0)), VARPTR(SPut(0))
 DQBfPut B0, 140, 139, VARSEG(SPut(0)), VARPTR(SPut(0))
 DQBfPut B0, 140, 147, VARSEG(SPut(0)), VARPTR(SPut(0))
 DQBget 4, 152, 112, 159, 119, VARSEG(SPut(0)), VARPTR(SPut(0))
 DQBfPut B0, 140, 139 + (Header71(11) * 8), VARSEG(SPut(0)), VARPTR(SPut(0))
END IF

WScrollDisp

END SUB

SUB BG.Inp

' Scroll window?
IF DA(16) AND MX >= 221 AND MX <= 298 AND MY >= 93 AND MY <= 170 THEN
 Area = WScrollInp
 Active = Area
 EXIT SUB
END IF

' Areas
IF MY >= 178 AND MY <= 187 THEN
 SELECT CASE MX
  CASE 97 TO 153: Area = 20
  CASE 175 TO 213: Area = 19
  CASE 224 TO 276: Area = 18
 END SELECT
END IF
IF MY >= 120 AND MY <= 127 THEN
 SELECT CASE MX
  CASE 124 TO 131: Area = 21
  CASE 132 TO 139: Area = 22
  CASE 140 TO 147: Area = 23
 END SELECT
END IF
IF MY >= 128 AND MY <= 135 THEN
 SELECT CASE MX
  CASE 124 TO 131: Area = 24
  CASE 132 TO 139: Area = 25
  CASE 140 TO 147: Area = 26
 END SELECT
END IF
IF MX >= 140 AND MX <= 147 THEN
 SELECT CASE MY
  CASE 139 TO 146: Area = 27
  CASE 147 TO 154: Area = 28
 END SELECT
END IF

' Choose scroll mode
IF MLB1 AND DA(24) > 0 AND MX >= 96 AND MX <= 184 AND MY >= 64 AND MY <= 93 THEN
Header71(9) = ((MY - 64) \ 10)
END IF

X = Header71(10)
IF Area AND MLB1 = 1 THEN Active = Area
IF Active = Area THEN
 IF MLB1 = 1 THEN
 SELECT CASE Area
  CASE 18: DA(16) = DA(16) XOR 1
  CASE 19: DA(15) = DA(15) XOR 1
  CASE 20: DA(24) = DA(24) XOR 1
 END SELECT
 END IF
 IF DA(24) AND MLB2 = 1 THEN
  SELECT CASE Area
  CASE 21: X = X + 100
  CASE 22: X = X + 10
  CASE 23: X = X + 1
  CASE 24: X = X - 100
  CASE 25: X = X - 10
  CASE 26: X = X - 1
  CASE 27: Header71(11) = 0
  CASE 28: Header71(11) = 1
 END SELECT
 END IF
END IF
IF X < 0 THEN X = 0
IF X > 255 THEN X = 255
Header71(10) = X

END SUB

FUNCTION CheckPixel (Value)

' Is it necessary for a Faster put or not?
C = Value
IF C = 0 OR C > 216 THEN CheckPixel = Value: EXIT FUNCTION
DEF SEG = VARSEG(TPut(0, C))
V = VARPTR(TPut(0, C)) + 4
FOR J = 0 TO 255
IF PEEK(V + J) THEN M = M + 1
NEXT

' Full of pixels? Some pixels? No pixels?
SELECT CASE M
 CASE 0: C = 0
 CASE 256: IF C > 0 AND C <= 216 THEN C = C + 1080
 CASE ELSE: C = Value
END SELECT
CheckPixel = C

END FUNCTION

REM $STATIC
SUB ExtraTile.Disp

' Coors
X = DA(17)
Y = DA(18)
DX = X \ 16
DY = Y \ 16
PX = X AND 15
PY = Y AND 15

' Display tiles
FOR XX = 0 TO 18
 FOR YY = 0 TO 10
  DrawTile XX * 16 - PX + 16, YY * 16 - PY + 16, TMap(DX + XX, DY + YY, 1)
 NEXT
NEXT

' Snap
IF Area = 18 THEN
 FX = ((MX - 16 + PX) AND 32752) - PX
 FY = ((MY - 16 + PY) AND 32752) - PY
 DrawTile FX + 16, FY + 16, DA(22)
END IF

' Grid + Border
Grid
TTX1 = TTileX1 - DA(17)
TTY1 = TTileY1 - DA(18)
TTX2 = TTileX2 - DA(17)
TTY2 = TTileY2 - DA(18)
DQBline B0, TTX1, TTY1, TTX2, TTY1, 225
DQBline B0, TTX2, TTY1, TTX2, TTY2, 225
DQBline B0, TTX1, TTY2, TTX2, TTY2, 225
DQBline B0, TTX1, TTY1, TTX1, TTY2, 225
Border

' Buttons
DrawButton "TILES", 24, 178, ((Area = 29) AND (Area = Active))
DrawButton "OPTIONS", 97, 178, ((Area = 30) AND (Area = Active))
DrawButton "GRID", 175, 178, ((Area = 31) AND (Area = Active))
DrawButton "SCROLL", 224, 178, ((Area = 32) AND (Area = Active))

' Tiles
IF DA(21) THEN WTileDraw
WScrollDisp

' Options
IF DA(23) THEN
 DQBboxf B0, 96, 64, 187, 167, 7
 FOR X = 0 TO 2
 DQBbox B0, 95 - X, 63 - X, 185 + X, 168 + X, 6 - X
 NEXT
 C = (Header71(36) * 10)
  DQBbox B0, 96, 64 + C, 184, 73 + C, 0
  DQBboxf B0, 97, 65 + C, 183, 72 + C, 226
 PrintS "MODE 0: NONE", 100, 65, 6, 4
 PrintS "MODE 1: BackG", 100, 75, 6, 4
 PrintS "MODE 2: Normal", 100, 85, 6, 4
 PrintS "MODE 3: ForeG", 100, 95, 6, 4
  IF C = 10 THEN
   PrintS "0 = Deep Far", 117, 108, 55, 50
   PrintS "16 = Normal", 117, 118, 55, 50
   PrintS "Depth:", 117, 130, 55, 50
   PrintS Zero$(Header71(37), 2), 120, 140, 6, 4
   FOR I = 0 TO 8 STEP 8
   DQBfPut B0, 120 + I, 150, VARSEG(Arrows(0, 2)), VARPTR(Arrows(0, 2))
   DQBfPut B0, 120 + I, 158, VARSEG(Arrows(0, 6)), VARPTR(Arrows(0, 6))
   NEXT
   IF Area = Active THEN
    SELECT CASE Area
     CASE 34: DQBfPut B0, 120, 150, VARSEG(Arrows(0, 3)), VARPTR(Arrows(0, 3))
     CASE 35: DQBfPut B0, 128, 150, VARSEG(Arrows(0, 3)), VARPTR(Arrows(0, 3))
     CASE 36: DQBfPut B0, 120, 158, VARSEG(Arrows(0, 7)), VARPTR(Arrows(0, 7))
     CASE 37: DQBfPut B0, 128, 158, VARSEG(Arrows(0, 7)), VARPTR(Arrows(0, 7))
    END SELECT
   END IF
  END IF
  IF C = 30 THEN
   FOR I = 0 TO 16 STEP 8
   DQBfPut B0, 160 + I, 122, VARSEG(Arrows(0, 2)), VARPTR(Arrows(0, 2))
   DQBfPut B0, 160 + I, 130, VARSEG(Arrows(0, 6)), VARPTR(Arrows(0, 6))
   DQBfPut B0, 100 + I, 150, VARSEG(Arrows(0, 2)), VARPTR(Arrows(0, 2))
   DQBfPut B0, 100 + I, 158, VARSEG(Arrows(0, 6)), VARPTR(Arrows(0, 6))
   DQBfPut B0, 128 + I, 150, VARSEG(Arrows(0, 2)), VARPTR(Arrows(0, 2))
   DQBfPut B0, 128 + I, 158, VARSEG(Arrows(0, 6)), VARPTR(Arrows(0, 6))
   NEXT
   DQBfPut B0, 128, 108, VARSEG(Arrows(0, 0)), VARPTR(Arrows(0, 0))
   DQBfPut B0, 136, 108, VARSEG(Arrows(0, 4)), VARPTR(Arrows(0, 4))
   DQBfPut B0, 128, 116, VARSEG(Arrows(0, 0)), VARPTR(Arrows(0, 0))
   DQBfPut B0, 136, 116, VARSEG(Arrows(0, 4)), VARPTR(Arrows(0, 4))
   PrintS "Depth:", 157, 105, 55, 50
   PrintS Zero$(Header71(37), 3), 160, 113, 6, 4
   PrintS "WX=", 100, 108, 55, 50
   PrintS Zero$(Header71(38), 1), 118, 108, 6, 4
   PrintS "WY=", 100, 116, 55, 50
   PrintS Zero$(Header71(39), 1), 118, 116, 6, 4
   PrintS "IncX:", 100, 132, 55, 50
   PrintS Zero$(Header71(40), 3), 100, 142, 6, 4
   PrintS "IncY:", 128, 132, 55, 50
   PrintS Zero$(Header71(41), 3), 128, 142, 6, 4
   PrintS "L:R", 154, 145, 55, 50
   PrintS "U:D", 154, 153, 55, 50
   DQBget 4, 144, 112, 151, 119, VARSEG(SPut(0)), VARPTR(SPut(0))
   DQBfPut B0, 168, 144, VARSEG(SPut(0)), VARPTR(SPut(0))
   DQBfPut B0, 168, 152, VARSEG(SPut(0)), VARPTR(SPut(0))
   DQBfPut B0, 176, 144, VARSEG(SPut(0)), VARPTR(SPut(0))
   DQBfPut B0, 176, 152, VARSEG(SPut(0)), VARPTR(SPut(0))
   DQBget 4, 152, 112, 159, 119, VARSEG(SPut(0)), VARPTR(SPut(0))
   DQBfPut B0, 168 + (Header71(42) * 8), 144, VARSEG(SPut(0)), VARPTR(SPut(0))
   DQBfPut B0, 168 + (Header71(43) * 8), 152, VARSEG(SPut(0)), VARPTR(SPut(0))
    IF Area = Active THEN
    SELECT CASE Area
     CASE 38: DQBfPut B0, 128, 108, VARSEG(Arrows(0, 1)), VARPTR(Arrows(0, 1))
     CASE 39: DQBfPut B0, 136, 108, VARSEG(Arrows(0, 5)), VARPTR(Arrows(0, 5))
     CASE 40: DQBfPut B0, 128, 116, VARSEG(Arrows(0, 1)), VARPTR(Arrows(0, 1))
     CASE 41: DQBfPut B0, 136, 116, VARSEG(Arrows(0, 5)), VARPTR(Arrows(0, 5))
     CASE 42: DQBfPut B0, 160, 122, VARSEG(Arrows(0, 3)), VARPTR(Arrows(0, 3))
     CASE 43: DQBfPut B0, 168, 122, VARSEG(Arrows(0, 3)), VARPTR(Arrows(0, 3))
     CASE 44: DQBfPut B0, 176, 122, VARSEG(Arrows(0, 3)), VARPTR(Arrows(0, 3))
     CASE 45: DQBfPut B0, 160, 130, VARSEG(Arrows(0, 7)), VARPTR(Arrows(0, 7))
     CASE 46: DQBfPut B0, 168, 130, VARSEG(Arrows(0, 7)), VARPTR(Arrows(0, 7))
     CASE 47: DQBfPut B0, 176, 130, VARSEG(Arrows(0, 7)), VARPTR(Arrows(0, 7))
     CASE 52: DQBfPut B0, 100, 150, VARSEG(Arrows(0, 3)), VARPTR(Arrows(0, 3))
     CASE 53: DQBfPut B0, 108, 150, VARSEG(Arrows(0, 3)), VARPTR(Arrows(0, 3))
     CASE 54: DQBfPut B0, 116, 150, VARSEG(Arrows(0, 3)), VARPTR(Arrows(0, 3))
     CASE 55: DQBfPut B0, 128, 150, VARSEG(Arrows(0, 3)), VARPTR(Arrows(0, 3))
     CASE 56: DQBfPut B0, 136, 150, VARSEG(Arrows(0, 3)), VARPTR(Arrows(0, 3))
     CASE 57: DQBfPut B0, 144, 150, VARSEG(Arrows(0, 3)), VARPTR(Arrows(0, 3))
     CASE 58: DQBfPut B0, 100, 158, VARSEG(Arrows(0, 7)), VARPTR(Arrows(0, 7))
     CASE 59: DQBfPut B0, 108, 158, VARSEG(Arrows(0, 7)), VARPTR(Arrows(0, 7))
     CASE 60: DQBfPut B0, 116, 158, VARSEG(Arrows(0, 7)), VARPTR(Arrows(0, 7))
     CASE 61: DQBfPut B0, 128, 158, VARSEG(Arrows(0, 7)), VARPTR(Arrows(0, 7))
     CASE 62: DQBfPut B0, 136, 158, VARSEG(Arrows(0, 7)), VARPTR(Arrows(0, 7))
     CASE 63: DQBfPut B0, 144, 158, VARSEG(Arrows(0, 7)), VARPTR(Arrows(0, 7))
    END SELECT
    END IF
  END IF
END IF

END SUB

SUB ExtraTile.Inp

' Scroll window?
IF DA(16) AND MX >= 221 AND MX <= 298 AND MY >= 93 AND MY <= 170 THEN
 Area = WScrollInp
 Active = Area
 EXIT SUB
END IF

' Options window
IF DA(23) AND MX >= 93 AND MX <= 187 AND MY >= 61 AND MY <= 170 THEN
 Area = 33
 IF MLB1 > 0 AND MX >= 96 AND MX <= 184 AND MY >= 64 AND MY <= 103 THEN
 Header71(36) = (MY - 64) \ 10
 END IF

  ' Back
  IF Header71(36) = 1 THEN
   IF MX >= 120 AND MX <= 135 AND MY >= 150 AND MY <= 165 THEN
    Area = 34 + ((MY \ 158) * 2)
    Area = Area + (MX \ 128)
   END IF
  END IF
    
  ' Foreground
  IF Header71(36) = 3 THEN
    IF MX >= 128 AND MX <= 143 AND MY >= 108 AND MY <= 123 THEN
    Area = 38 + ((MY \ 116) * 2)
    Area = Area + (MX \ 136)
    END IF
   IF MY >= 122 AND MY <= 129 THEN
   SELECT CASE MX
   CASE 160 TO 167: Area = 42
   CASE 168 TO 175: Area = 43
   CASE 176 TO 183: Area = 44
   END SELECT
   END IF
    IF MY >= 130 AND MY <= 137 THEN
    SELECT CASE MX
    CASE 160 TO 167: Area = 45
    CASE 168 TO 175: Area = 46
    CASE 176 TO 183: Area = 47
    END SELECT
    END IF
   IF MY >= 144 AND MY <= 151 THEN
   SELECT CASE MX
   CASE 168 TO 175: Area = 48
   CASE 176 TO 183: Area = 49
   END SELECT
   END IF
    IF MY >= 152 AND MY <= 159 THEN
    SELECT CASE MX
    CASE 168 TO 175: Area = 50
    CASE 176 TO 183: Area = 51
    END SELECT
    END IF
   IF MY >= 150 AND MY <= 157 THEN
   SELECT CASE MX
   CASE 100 TO 107: Area = 52
   CASE 108 TO 115: Area = 53
   CASE 116 TO 123: Area = 54
   CASE 128 TO 135: Area = 55
   CASE 136 TO 143: Area = 56
   CASE 144 TO 151: Area = 57
   END SELECT
   END IF
    IF MY >= 158 AND MY <= 165 THEN
    SELECT CASE MX
    CASE 100 TO 107: Area = 58
    CASE 108 TO 115: Area = 59
    CASE 116 TO 123: Area = 60
    CASE 128 TO 135: Area = 61
    CASE 136 TO 143: Area = 62
    CASE 144 TO 151: Area = 63
    END SELECT
    END IF
  END IF
  IF MLB1 = 1 THEN Active = Area

  ' Choice for L:R D:U
  IF MLB1 = 1 THEN
   SELECT CASE Area
    CASE 48: Header71(42) = 0
    CASE 49: Header71(42) = 1
    CASE 50: Header71(43) = 0
    CASE 51: Header71(43) = 1
   END SELECT
  END IF

  ' Arrow mouses
  I = Header71(37)
  IF MLB2 AND Area = Active THEN
    X = Header71(38)
    Y = Header71(39)
    IX = Header71(40)
    IY = Header71(41)
    SELECT CASE Area
     CASE 34: I = I + 10
     CASE 35: I = I + 1
     CASE 36: I = I - 10
     CASE 37: I = I - 1
     CASE 38: X = X + (X > 1)
     CASE 39: X = X - (X < 4)
     CASE 40: Y = Y + (Y > 1)
     CASE 41: Y = Y - (Y < 4)
     CASE 42: I = I + 100
     CASE 43: I = I + 10
     CASE 44: I = I + 1
     CASE 45: I = I - 100
     CASE 46: I = I - 10
     CASE 47: I = I - 1
     CASE 52: IX = IX + 100
     CASE 53: IX = IX + 10
     CASE 54: IX = IX + 1
     CASE 55: IY = IY + 100
     CASE 56: IY = IY + 10
     CASE 57: IY = IY + 1
     CASE 58: IX = IX - 100
     CASE 59: IX = IX - 10
     CASE 60: IX = IX - 1
     CASE 61: IY = IY - 100
     CASE 62: IY = IY - 10
     CASE 63: IY = IY - 1
    END SELECT
    Header71(38) = X
    Header71(39) = Y
    IF IX < 0 THEN IX = 0
    IF IX > 255 THEN IX = 255
    IF IY < 0 THEN IY = 0
    IF IY > 255 THEN IY = 255
    Header71(40) = IX
    Header71(41) = IY
    END IF
   IF Header71(36) = 1 THEN
   IF I < 0 THEN I = 0
   IF I > 16 THEN I = 16
   END IF
   IF Header71(36) = 3 THEN
   IF I < 16 THEN I = 16
   IF I > 255 THEN I = 255
   END IF
   Header71(37) = I
 EXIT SUB
END IF

WTileInp

IF MY >= 178 AND MY <= 187 THEN
 SELECT CASE MX
  CASE 24 TO 68: Area = 29
  CASE 97 TO 153: Area = 30
  CASE 175 TO 213: Area = 31
  CASE 224 TO 276: Area = 32
 END SELECT
END IF

IF MLB1 = 1 THEN
 SELECT CASE Area
  CASE 29: DA(21) = DA(21) XOR 1: Active = 29
  CASE 30: DA(23) = DA(23) XOR 1: Active = 30
  CASE 31: DA(15) = DA(15) XOR 1: Active = 31
  CASE 32: DA(16) = DA(16) XOR 1: Active = 32
 END SELECT
END IF

END SUB

REM $DYNAMIC
FUNCTION Interpolate (Number1, Number2, Value, MaxValue)

IF Number1 = Number2 THEN Interpolate = Number1: EXIT FUNCTION

IF Number1 < Number2 THEN
 Dist& = Number2 - Number1
 Interpolate = (Value * Dist& / MaxValue) + Number1
ELSE
 Dist& = Number1 - Number2
 Interpolate = Number1 - (Value * Dist& / MaxValue)
END IF

END FUNCTION

REM $STATIC
FUNCTION MyAngle (X1, Y1, X2, Y2)

IF Y1 = Y2 AND X1 < X2 THEN MyAngle = 0: EXIT FUNCTION
IF X1 = X2 AND Y1 < Y2 THEN MyAngle = 90: EXIT FUNCTION
IF Y1 = Y2 AND X1 > X2 THEN MyAngle = 180: EXIT FUNCTION
IF X1 = X2 AND Y1 > Y2 THEN MyAngle = 270: EXIT FUNCTION
IF X1 = X2 AND Y1 = Y2 THEN MyAngle = 0: EXIT FUNCTION

DistX = ABS(X2 - X1)
DistY = ABS(Y2 - Y1)
IF DistY THEN Slope! = DistX / DistY

IF X1 <= X2 AND Y1 <= Y2 THEN MyAngle = 90 - (ATN(Slope!) * Radian): EXIT FUNCTION
IF X1 > X2 AND Y1 <= Y2 THEN MyAngle = ATN(Slope!) * Radian + 90: EXIT FUNCTION
IF X1 > X2 AND Y1 > Y2 THEN MyAngle = (90 - (ATN(Slope!) * Radian)) + 180: EXIT FUNCTION
IF X1 <= X2 AND Y1 > Y2 THEN MyAngle = (ATN(Slope!) * Radian) + 270: EXIT FUNCTION

END FUNCTION

SUB MybPut (X, Y, SSeg, SOff)

 SO = SOff
 FOR YY = 0 TO 15
  DEF SEG = SSeg
  S0 = PEEK(SO + 4)
  S1 = PEEK(SO + 5)
  S2 = PEEK(SO + 6)
  S3 = PEEK(SO + 7)
  S4 = PEEK(SO + 8)
  S5 = PEEK(SO + 9)
  S6 = PEEK(SO + 10)
  S7 = PEEK(SO + 11)
  S8 = PEEK(SO + 12)
  S9 = PEEK(SO + 13)
  SA = PEEK(SO + 14)
  SB = PEEK(SO + 15)
  SC = PEEK(SO + 16)
  SD = PEEK(SO + 17)
  SE = PEEK(SO + 18)
  SF = PEEK(SO + 19)
  SO = SO + 16
  DEF SEG = DQBmapLayer(B0) + ((Y + YY) * 20)
  BB0 = PEEK(X)
  BB1 = PEEK(X + 1)
  BB2 = PEEK(X + 2)
  BB3 = PEEK(X + 3)
  BB4 = PEEK(X + 4)
  BB5 = PEEK(X + 5)
  BB6 = PEEK(X + 6)
  BB7 = PEEK(X + 7)
  BB8 = PEEK(X + 8)
  BB9 = PEEK(X + 9)
  BBA = PEEK(X + 10)
  BBB = PEEK(X + 11)
  BBC = PEEK(X + 12)
  BBD = PEEK(X + 13)
  BBE = PEEK(X + 14)
  BBF = PEEK(X + 15)
  IF S0 > 128 AND S0 < 137 THEN S0 = BMap((S0 - 129) * 256 + BB0)
  IF S1 > 128 AND S1 < 137 THEN S1 = BMap((S1 - 129) * 256 + BB1)
  IF S2 > 128 AND S2 < 137 THEN S2 = BMap((S2 - 129) * 256 + BB2)
  IF S3 > 128 AND S3 < 137 THEN S3 = BMap((S3 - 129) * 256 + BB3)
  IF S4 > 128 AND S4 < 137 THEN S4 = BMap((S4 - 129) * 256 + BB4)
  IF S5 > 128 AND S5 < 137 THEN S5 = BMap((S5 - 129) * 256 + BB5)
  IF S6 > 128 AND S6 < 137 THEN S6 = BMap((S6 - 129) * 256 + BB6)
  IF S7 > 128 AND S7 < 137 THEN S7 = BMap((S7 - 129) * 256 + BB7)
  IF S8 > 128 AND S8 < 137 THEN S8 = BMap((S8 - 129) * 256 + BB8)
  IF S9 > 128 AND S9 < 137 THEN S9 = BMap((S9 - 129) * 256 + BB9)
  IF SA > 128 AND SA < 137 THEN SA = BMap((SA - 129) * 256 + BBA)
  IF SB > 128 AND SB < 137 THEN SB = BMap((SB - 129) * 256 + BBB)
  IF SC > 128 AND SC < 137 THEN SC = BMap((SC - 129) * 256 + BBC)
  IF SD > 128 AND SD < 137 THEN SD = BMap((SD - 129) * 256 + BBD)
  IF SE > 128 AND SE < 137 THEN SE = BMap((SE - 129) * 256 + BBE)
  IF SF > 128 AND SF < 137 THEN SF = BMap((SF - 129) * 256 + BBF)
  IF S0 THEN POKE X, S0
  IF S1 THEN POKE X + 1, S1
  IF S2 THEN POKE X + 2, S2
  IF S3 THEN POKE X + 3, S3
  IF S4 THEN POKE X + 4, S4
  IF S5 THEN POKE X + 5, S5
  IF S6 THEN POKE X + 6, S6
  IF S7 THEN POKE X + 7, S7
  IF S8 THEN POKE X + 8, S8
  IF S9 THEN POKE X + 9, S9
  IF SA THEN POKE X + 10, SA
  IF SB THEN POKE X + 11, SB
  IF SC THEN POKE X + 12, SC
  IF SD THEN POKE X + 13, SD
  IF SE THEN POKE X + 14, SE
  IF SF THEN POKE X + 15, SF
 NEXT

END SUB

SUB MyMsg (Code)

' Ticks
IF Code THEN
MsgDel = 200
Msg = Code
ELSE
MsgDel = MsgDel + (MsgDel > 0)
END IF

' Delay position
SELECT CASE MsgDel
 CASE 0 TO 32: Y = (32 - MsgDel) + 168
 CASE 33 TO 167: Y = 168
 CASE 168 TO 200: Y = MsgDel
END SELECT

' Messages
SELECT CASE Msg
 CASE 1: A$ = "Level design and graphics are saved"
END SELECT

' PRINT message
X = 160 - (DQBlen(A$) \ 2)
C = ((FrameTile AND 31) \ 8) + 14
FOR YY = 3 TO 5
FOR XX = -1 TO 1
DQBprint B0, A$, X + XX, Y + YY, 0
NEXT
NEXT
DQBprint B0, A$, X, Y + 4, C

END SUB

SUB Object.Disp

' Coors
X = DA(17)
Y = DA(18)
DX = X \ 16
DY = Y \ 16
PX = X AND 15
PY = Y AND 15

' Objects on map
FOR XX = -1 TO 18
 FOR YY = -1 TO 10
  DrawObj XX * 16 - PX + 16, YY * 16 - PY + 16, ASC(CMap(DX + XX, DY + YY)), 1
 NEXT
NEXT

' Snap
IF Area = 18 THEN
 FX = ((MX - 16 + PX) AND 32752) - PX
 FY = ((MY - 16 + PY) AND 32752) - PY
 DrawObj FX + 16, FY + 16, DA(20), 1
END IF

' Grid + Border
Grid
Border

' Buttons
DrawButton "OBJECTS", 24, 184, ((Area = 25) AND (Area = Active))
DrawButton "GRID", 145, 184, ((Area = 26) AND (Area = Active))
DrawButton "SCROLL", 224, 184, ((Area = 27) AND (Area = Active))

IF DA(19) THEN
 DQBboxf B0, 24, 96, 71, 143, 224
 DQBboxf B0, 24, 144, 71, 167, 7
 FOR X = 0 TO 2
 DQBbox B0, 23 - X, 95 - X, 72 + X, 168 + X, 6 - X
 NEXT
 PrintS Zero$(DA(20), 3), 36, 144, 23, 0
 DrawObj 40, 112, DA(20), 0
 DQBline B0, 40, 112, 38, 112, 23
 DQBline B0, 40, 112, 40, 110, 23
 DQBline B0, 40, 127, 38, 127, 23
 DQBline B0, 40, 127, 40, 129, 23
 DQBline B0, 55, 112, 55, 110, 23
 DQBline B0, 55, 112, 57, 112, 23
 DQBline B0, 55, 127, 55, 129, 23
 DQBline B0, 55, 127, 57, 127, 23
  FOR I = 0 TO 16 STEP 8
  DQBfPut B0, 36 + I, 152, VARSEG(Arrows(0, 2)), VARPTR(Arrows(0, 2))
  DQBfPut B0, 36 + I, 160, VARSEG(Arrows(0, 6)), VARPTR(Arrows(0, 6))
  NEXT
   IF Area > 18 AND Area < 25 AND Area = Active THEN
    IF Area < 22 THEN DQBfPut B0, 36 + ((Area - 19) * 8), 152, VARSEG(Arrows(0, 5)), VARPTR(Arrows(0, 3))
    IF Area > 21 THEN DQBfPut B0, 36 + ((Area - 22) * 8), 160, VARSEG(Arrows(0, 7)), VARPTR(Arrows(0, 7))
   END IF
END IF

WScrollDisp

END SUB

SUB Object.Inp

' Input from keys
C = DA(20)
SELECT CASE CH$
 CASE CHR$(0) + CHR$(72): C = C - 10
 CASE CHR$(0) + CHR$(75): C = C - 1
 CASE CHR$(0) + CHR$(77): C = C + 1
 CASE CHR$(0) + CHR$(80): C = C + 10
END SELECT
IF C < 0 THEN C = 0
IF C > 255 THEN C = 255
DA(20) = C

' Scroll window?
IF DA(16) AND MX >= 221 AND MX <= 298 AND MY >= 93 AND MY <= 170 THEN
 Area = WScrollInp
 Active = Area
 EXIT SUB
END IF

' Object window?
IF DA(19) AND MX >= 21 AND MX <= 74 AND MY >= 93 AND MY <= 170 THEN
 IF MY >= 152 AND MY <= 167 AND MX >= 36 AND MX <= 59 AND MLB1 > 0 THEN
   K = (MY \ 160) * 3
   K = K + ((MX - 28) \ 8)
    C = DA(20)
    Area = K + 18
    IF MLB1 = 1 THEN Active = Area
    IF MLB2 = 1 AND Active = Area THEN
    SELECT CASE K
     CASE 1: C = C + 100
     CASE 2: C = C + 10
     CASE 3: C = C + 1
     CASE 4: C = C - 100
     CASE 5: C = C - 10
     CASE 6: C = C - 1
    END SELECT
    END IF
    IF C > 255 THEN C = 255
    IF C < 0 THEN C = 0
    DA(20) = C
  END IF
 EXIT SUB
END IF

' Get and put objects
IF MX > 15 AND MY > 15 AND MY < 176 AND MX < 304 THEN
 Area = 18  ' Field
 X = DA(17)
 Y = DA(18)
 PX = X AND 15
 PY = Y AND 15
 DX = X \ 16
 DY = Y \ 16
 FX = (MX - 16 + PX) \ 16 + DX
 FY = (MY - 16 + PY) \ 16 + DY
 IF MRB = 1 OR MLB1 = 1 THEN Active = Area
 IF Area = Active THEN
  IF MRB > 0 THEN DA(20) = ASC(CMap(FX, FY))
  IF MLB1 > 0 THEN CMap(FX, FY) = CHR$(DA(20))
 END IF
END IF

IF MY >= 184 AND MY <= 193 THEN
 SELECT CASE MX
  CASE 24 TO 82: Area = 25
  CASE 145 TO 183: Area = 26
  CASE 224 TO 276: Area = 27
 END SELECT
END IF

IF MLB1 = 1 THEN
 SELECT CASE Area
 CASE 25: DA(19) = DA(19) XOR 1: Active = 25
 CASE 26: DA(15) = DA(15) XOR 1: Active = 26
 CASE 27: DA(16) = DA(16) XOR 1: Active = 27
 END SELECT
END IF

END SUB

SUB Preview.Disp

' Order of drawing:
 '1) BG                         One BITMAP of background
 '2) ExtraTiles  IF EMODE = 1   Tiled Background scrolling
 '3) ExtraTiles  IF EMODE = 2   Behaves like a normal tile map
 '4) Tiles       IF MODE = 0    Normal Tile map / mapbased objects
 '5) Objects                    All objects
 '6) Tiles       IF MODE = 1    Normal Tile map drawing over objects
 '7) ExtraTiles  IF EMODE = 3   Tiled foreground scrolling


' Coordinates
CameraX = DA(59) \ 16
CameraY = DA(60) \ 16
IF Header71(0) > 1 AND Header71(0) < 10 THEN
IF Header71(1) > 3 AND Header71(1) < 6 AND DA(3) = 0 THEN
FFF = 1
END IF
END IF

' Background
SELECT CASE Header71(9)
CASE 0
 DQBcopyLayer 11, B0
CASE 1
 DQBcopyLayer 11, B0
 DQBscroll B0, Header71(12) \ 16, 0
CASE 2
 C = Header71(10)
 DQBcopyLayer 11, B0
 IF C THEN DQBscroll B0, -(CameraX \ C), -(CameraY \ 32)
END SELECT

' Extra Tile Mode #1
IF Header71(36) = 1 THEN
 Header71(37) = (Header71(37) + 68) MOD 17
 RA& = Header71(37)
 MoverX = CameraX * RA& \ 16
 MoverY = CameraY * RA& \ 16
 CX = MoverX \ 16
 CY = MoverY \ 16
 PX = MoverX AND 15
 PY = MoverY AND 15
  FOR Y = 0 TO 10
   FOR X = 0 TO 18
    R = TMap(X + CX, Y + CY, 1)
    DrawTile X * 16 + 16 - PX, Y * 16 + 16 - PY, R
   NEXT
  NEXT
END IF

' Extra Tile Mode #2
IF Header71(36) = 2 THEN
 CX = CameraX \ 16
 CY = CameraY \ 16
 PX = CameraX AND 15
 PY = CameraY AND 15
  FOR Y = 0 TO 10
   FOR X = 0 TO 18
     R = TMap(X + CX, Y + CY, 1)
     DrawTile X * 16 + 16 - PX, Y * 16 + 16 - PY, R
   NEXT
  NEXT
END IF

' Tile layer mode #0
IF Header71(13) = 0 THEN
 CX = CameraX \ 16
 CY = CameraY \ 16
 PX = CameraX AND 15
 PY = CameraY AND 15
 FOR Y = 0 TO 10
 FOR X = 0 TO 18
 R = TMap(X + CX, Y + CY, 0)
 DrawTile X * 16 + 16 - PX, Y * 16 + 16 - PY, R
 NEXT
 NEXT
END IF

' Mpabased Objects
X = CameraX
Y = CameraY
DX = CameraX \ 16
DY = CameraY \ 16
PX = CameraX AND 15
PY = CameraY AND 15
FOR X = -1 TO 18
 FOR Y = -1 TO 10
  DrawObj X * 16 - PX + 16, Y * 16 - PY + 16, ASC(CMap(DX + X, DY + Y)), 1
 NEXT
NEXT

' Alexa for DEMO
IF FFF THEN
FF = FrameTile \ 8
SELECT CASE FF
 CASE 0 TO 3: C = FF
 CASE 4 TO 7: C = 7 - FF
END SELECT
SELECT CASE C
 CASE 0: DQBget 2, 160, 160, 191, 191, VARSEG(EPut(0)), VARPTR(EPut(0))
 CASE 1: DQBget 2, 64, 0, 95, 31, VARSEG(EPut(0)), VARPTR(EPut(0))
 CASE 2: DQBget 2, 64, 160, 95, 191, VARSEG(EPut(0)), VARPTR(EPut(0))
 CASE 3: DQBget 2, 160, 0, 191, 31, VARSEG(EPut(0)), VARPTR(EPut(0))
END SELECT
 C = Header71(0) \ 2 - 1
 IF Demos(10, Demo) THEN
  PALscw 28, 16, 16, 16
  PALscw 32, 32, 32, 32
  PALscw 35, 48, 48, 48
  PALscw 38, 63, 63, 63
 ELSE
  PALscw 28, 24, 6, 20
  PALscw 32, 37, 10, 30
  PALscw 35, 51, 16, 41
  PALscw 38, 55, 37, 51
 END IF
 X = Demos(4, C) + (Demos(5, C) * 256)
 Y = Demos(2, C) + (Demos(3, C) * 256)
 DQBput B0, X - CameraX - 8, Y - CameraY, VARSEG(EPut(0)), VARPTR(EPut(0))
END IF

' Tile layer mode #1 (Draw over tiles)
IF Header71(13) = 1 THEN
 CX = CameraX \ 16
 CY = CameraY \ 16
 PX = CameraX AND 15
 PY = CameraY AND 15
 FOR Y = 0 TO 10
 FOR X = 0 TO 18
 R = TMap(X + CX, Y + CY, 0)
 DrawTile X * 16 + 16 - PX, Y * 16 + 16 - PY, R
 NEXT
 NEXT
END IF

' Extra Tile Mode #3      ' Most foreground of all layers
IF Header71(36) = 3 THEN
 RA& = Header71(37)
 WX = Header71(38) * 18
 WY = Header71(39) * 10
 MoverX = (CameraX * RA& \ 16) + (Header71(44) \ 16)
 MoverY = (CameraY * RA& \ 16) + (Header71(45) \ 16)
 CX = MoverX \ 16 MOD WX
 CY = MoverY \ 16 MOD WY
 PX = MoverX AND 15
 PY = MoverY AND 15
IF CX + 18 >= WX AND CY + 10 >= WY THEN
  FOR Y = 0 TO (WY - CY) - 1
   FOR X = 0 TO (WX - CX) - 1
    R = TMap(X + CX, Y + CY, 1)
    DrawTile X * 16 + 16 - PX, Y * 16 + 16 - PY, R
    NEXT
   FOR X = 0 TO (CX MOD 18)
    XL = ((WX - CX) * 16) + (X * 16) + 16 - PX
     R = TMap(X, Y + CY, 1)
     DrawTile XL, Y * 16 + 16 - PY, R
    NEXT
   NEXT
  FOR Y = 0 TO (CY MOD 10)
   FOR X = 0 TO (WX - CX) - 1
    YL = ((WY - CY) * 16) + (Y * 16) + 16 - PY
    R = TMap(X + CX, Y, 1)
    DrawTile X * 16 + 16 - PX, YL, R
   NEXT
   FOR X = 0 TO (CX MOD 18)
    XL = ((WX - CX) * 16) + (X * 16) + 16 - PX
    YL = ((WY - CY) * 16) + (Y * 16) + 16 - PY
    R = TMap(X, Y, 1)
    DrawTile XL, YL, R
   NEXT
  NEXT
GOTO DonePrev
END IF
IF CX + 18 >= WX THEN
  FOR Y = 0 TO 10
   FOR X = 0 TO (WX - CX) - 1
    R = TMap(X + CX, Y + CY, 1)
    DrawTile X * 16 + 16 - PX, Y * 16 + 16 - PY, R
   NEXT
   FOR X = 0 TO (CX MOD 18)
    XL = ((WX - CX) * 16) + (X * 16) + 16 - PX
    R = TMap(X, Y + CY, 1)
    DrawTile XL, Y * 16 + 16 - PY, R
  NEXT
 NEXT
GOTO DonePrev
END IF
IF CY + 10 >= WY THEN
  FOR X = 0 TO 18
   FOR Y = 0 TO (WY - CY) - 1
    R = TMap(X + CX, Y + CY, 1)
    DrawTile X * 16 + 16 - PX, Y * 16 + 16 - PY, R
   NEXT Y
   FOR Y = 0 TO (CY MOD 10)
    YL = ((WY - CY) * 16) + (Y * 16) + 16 - PY
    R = TMap(X + CX, Y, 1)
    DrawTile X * 16 + 16 - PX, YL, R
   NEXT
  NEXT
GOTO DonePrev
END IF
FOR Y = 0 TO 10
 FOR X = 0 TO 18
  R = TMap(X + CX, Y + CY, 1)
  DrawTile X * 16 + 16 - PX, Y * 16 + 16 - PY, R
  NEXT
 NEXT
END IF

DonePrev:

Border

PrintS "PREVIEW OF SECTOR", 40, 176, 22, 20
PrintS "(Drag mouse w/ left button on field to scroll)", 40, 184, 55, 50
IF FFF THEN
PrintS "(Right-click for Alexa's DEMO coordinates)", 40, 192, 55, 50
END IF

END SUB

SUB Preview.Inp

IF MX > 15 AND MY > 15 AND MX < 304 AND MY < 176 THEN Area = 1
IF Area = 1 AND MLB1 = 1 THEN Active = Area
IF Header71(0) > 1 AND Header71(0) < 10 THEN
IF Header71(1) > 3 AND Header71(1) < 6 AND DA(3) = 0 THEN
FFF = 1
END IF
END IF

' Get mouse to move camera
IF Area = Active AND Area = 1 THEN
 X = DA(59)
 Y = DA(60)
 XX = ABS(160 - MX)
 YY = ABS(96 - MY)
 A = MyAngle(160, 96, MX, MY)
 D = SQR(XX * XX + YY * YY)
 X = D * MyCOS(A) \ 1024 + X
 Y = D * MySIN(A) \ 1024 + Y
 XX1 = (Header71(2) - 1) * 4608
 YY1 = (Header71(3) - 1) * 2560
 IF X < 0 THEN X = 0
 IF Y < 0 THEN Y = 0
 IF X > XX1 THEN X = XX1
 IF Y > YY1 THEN Y = YY1
 DA(59) = X
 DA(60) = Y
END IF

' Alexa DEMO coordinates
IF FFF AND MRB = 1 AND Area = 1 THEN
 C = Header71(0) \ 2 - 1
 X = (DA(59) \ 16 + MX) AND 32752
 Demos(4, C) = X AND 255
 Demos(5, C) = X \ 256
 X = (DA(60) \ 16 + MY) AND 32752
 Demos(2, C) = X AND 255
 Demos(3, C) = X \ 256
END IF

END SUB

SUB Tile2Map

EDIT = (DA(25) * 14)
IF EDIT AND DA(0) = 6 THEN
 '''' Get box position
 XR1 = DA(36 + EDIT)
 YR1 = DA(37 + EDIT)
 XR2 = DA(38 + EDIT)
 YR2 = DA(39 + EDIT)
 '''' Correct coordinates
 IF XR1 > XR2 THEN SWAP XR1, XR2
 IF YR1 > YR2 THEN SWAP YR1, YR2
 IF XR2 > 319 THEN XR2 = 319
 IF YR2 < 96 THEN
  IF XR2 > 255 THEN XR2 = 255
  IF XR1 > 255 THEN XR1 = 255
 END IF
 IF YR2 > 191 THEN YR2 = 191
 XR1 = (XR1 + 8) \ 16
 YR1 = (YR1 + 8) \ 16
 XR2 = (XR2 + 8) \ 16
 YR2 = (YR2 + 8) \ 16
 MapCX = XR2 - XR1 - 1
 MapCY = YR2 - YR1 - 1
 '''' Put stuff on map
 FOR Y = YR1 TO YR2
 FOR X = XR1 TO XR2
  IF Y < 6 THEN
  TCMap(XX, YY) = Y * 16 + X + 1
  ELSE
  TCMap(XX, YY) = ((Y - 6) * 20) + X + 97
  END IF
  XX = XX + 1
 NEXT
  XX = 0
  YY = YY + 1
 NEXT
END IF

END SUB

SUB WScrollDisp

 IF DA(16) = 0 THEN EXIT SUB

 ' Static display
 FOR X = 0 TO 2
 DQBbox B0, 223 - X, 95 - X, 296 + X, 168 + X, 6 - X
 NEXT
 DQBboxf B0, 224, 96, 295, 167, 7
 FOR I = 0 TO 24 STEP 8
  DQBfPut B0, 224 + I, 160, VARSEG(Arrows(0, 0)), VARPTR(Arrows(0, 0))
  DQBfPut B0, 256 + I, 160, VARSEG(Arrows(0, 4)), VARPTR(Arrows(0, 4))
 NEXT
 FOR I = 0 TO 24 STEP 8
  DQBfPut B0, 288, 96 + I, VARSEG(Arrows(0, 2)), VARPTR(Arrows(0, 2))
  DQBfPut B0, 288, 128 + I, VARSEG(Arrows(0, 6)), VARPTR(Arrows(0, 6))
 NEXT

 SELECT CASE Area
  CASE 1 TO 4
    DQBfPut B0, Area * 8 + 216, 160, VARSEG(Arrows(0, 1)), VARPTR(Arrows(0, 1))
  CASE 5 TO 8
    DQBfPut B0, Area * 8 + 216, 160, VARSEG(Arrows(0, 5)), VARPTR(Arrows(0, 5))
  CASE 9 TO 12
    DQBfPut B0, 288, Area * 8 + 24, VARSEG(Arrows(0, 3)), VARPTR(Arrows(0, 3))
  CASE 13 TO 16
    DQBfPut B0, 288, Area * 8 + 24, VARSEG(Arrows(0, 7)), VARPTR(Arrows(0, 7))
 END SELECT

 PrintS "Pixel X=" + LTRIM$(STR$(DA(17))), 229, 109, 54, 48
 PrintS "Pixel Y=" + LTRIM$(STR$(DA(18))), 229, 119, 54, 48
 PrintS "Tile X=" + LTRIM$(STR$(DA(17) \ 16)), 229, 129, 54, 48
 PrintS "Tile Y=" + LTRIM$(STR$(DA(18) \ 16)), 229, 139, 54, 48

END SUB

FUNCTION WScrollInp

' Scroll box area
K = 17

 ' Input in the scroll field
IF MX >= 224 AND MX <= 287 THEN
 IF MY >= 160 AND MY <= 167 THEN
  IF MLB1 = 2 THEN K = ((MX - 216) \ 8)
 END IF
END IF

 ' Input in the scroll field
IF MX >= 288 AND MX <= 295 THEN
 IF MY >= 96 AND MY <= 159 THEN
  IF MLB1 = 2 THEN K = ((MY - 88) \ 8) + 8
 END IF
END IF

' Scroll!
XX = DA(17)
YY = DA(18)
SELECT CASE K
 CASE 1 TO 4: XX = XX - (5 - K)
 CASE 5 TO 8: XX = XX + K - 4
 CASE 9 TO 12: YY = YY - (13 - K)
 CASE 13 TO 16: YY = YY + K - 12
END SELECT

' Border length for scrolling
X = (Header71(2) - 1) * 288
Y = (Header71(3) - 1) * 160
IF XX > X THEN XX = X
IF YY > Y THEN YY = Y
IF XX < 0 THEN XX = 0
IF YY < 0 THEN YY = 0
DA(17) = XX
DA(18) = YY
WScrollInp = K

END FUNCTION

SUB WTileDraw

 DQBboxf B0, 24, 64, 71, 143, 224
 DQBboxf B0, 24, 144, 71, 167, 7
 FOR X = 0 TO 2
 DQBbox B0, 23 - X, 63 - X, 72 + X, 168 + X, 6 - X
 NEXT
 PrintS Zero$(DA(22), 4), 28, 144, 23, 0
 FOR X = 0 TO 32 STEP 16
 FOR I = 0 TO 32 STEP 16
 DrawTile 24 + X, 64 + I, DA(22)
 NEXT
 NEXT
 DrawTile 40, 120, DA(22)
  FOR I = 0 TO 24 STEP 8
  DQBfPut B0, 24 + I, 152, VARSEG(Arrows(0, 2)), VARPTR(Arrows(0, 2))
  DQBfPut B0, 24 + I, 160, VARSEG(Arrows(0, 6)), VARPTR(Arrows(0, 6))
  NEXT
   DQBfPut B0, 60, 148, VARSEG(Arrows(0, 2)), VARPTR(Arrows(0, 2))
   DQBfPut B0, 60, 156, VARSEG(Arrows(0, 6)), VARPTR(Arrows(0, 6))
   IF Area = Active THEN
    IF Area > 18 AND Area < 29 THEN
     IF Area < 23 THEN DQBfPut B0, 24 + ((Area - 19) * 8), 152, VARSEG(Arrows(0, 3)), VARPTR(Arrows(0, 3))
     IF Area = 27 THEN DQBfPut B0, 60, 148, VARSEG(Arrows(0, 3)), VARPTR(Arrows(0, 3))
     IF Area > 22 AND Area < 27 THEN DQBfPut B0, 24 + ((Area - 23) * 8), 160, VARSEG(Arrows(0, 7)), VARPTR(Arrows(0, 7))
     IF Area = 28 THEN DQBfPut B0, 60, 156, VARSEG(Arrows(0, 7)), VARPTR(Arrows(0, 7))
    END IF
   END IF
    SELECT CASE DA(22)
     CASE 1 TO 216: A$ = "Put non-animated"
     CASE 217 TO 324: A$ = "Put FT=1 Speed=2 (SP)"
     CASE 325 TO 378: A$ = "Put FT=4 Speed=16"
     CASE 379 TO 405: A$ = "Put FT=8 Speed=8"
     CASE 406 TO 418: A$ = "Put FT=16 Speed=4"
     CASE 420 TO 431: A$ = "Put FT=4 Speed=16 (SP)"
     CASE 432 TO 446: A$ = "Put FT=5 Speed=16 (SP)"
     CASE 447 TO 554: A$ = "Put FT=2 Speed=32"
     CASE 555 TO 662: A$ = "Put FT=2 Speed=8"
     CASE 663 TO 878: A$ = "Blend non-animated"
     CASE 879 TO 986: A$ = "Blend FT=2 Speed=32"
     CASE 987 TO 1040: A$ = "Blend FT=4 Speed=16"
     CASE 1041 TO 1067: A$ = "Blend FT=8 Speed=8"
     CASE 1068 TO 1080: A$ = "Blend FT=16 Speed=4"
     CASE 1081 TO 1296: A$ = "FastPut non-animated"
     CASE 1297 TO 1404: A$ = "FastPut FT=2 Speed=32"
     CASE 1405 TO 1458: A$ = "FastPut FT=4 Speed=16"
     CASE 1459 TO 1485: A$ = "FastPut FT=8 Speed=8"
     CASE 1486 TO 1498: A$ = "FastPut FT=16 Speed=4"
     CASE 1500 TO 1755: A$ = "BoxFill"
    END SELECT
    DQBboxf B0, 176, 191, 292, 199, 0
    PrintS A$, 180, 192, 54, 50

END SUB

SUB WTileInp

' Input from keys
C = DA(22)
SELECT CASE CH$
 CASE CHR$(0) + CHR$(72): C = C - 10
 CASE CHR$(0) + CHR$(75): C = C - 1
 CASE CHR$(0) + CHR$(77): C = C + 1
 CASE CHR$(0) + CHR$(80): C = C + 10
END SELECT
IF C < 0 THEN C = 0
IF C > 1755 THEN C = 1755
DA(22) = C

' Tiles window?
IF DA(21) AND MX >= 21 AND MX <= 74 AND MY >= 61 AND MY <= 170 AND MLB1 > 0 THEN
   IF MY >= 152 AND MY <= 167 AND MX >= 24 AND MX <= 55 THEN
    K = (MY \ 160) * 4
    K = K + ((MX - 16) \ 8)
   END IF
   IF MX >= 60 AND MX <= 67 THEN
    SELECT CASE MY
     CASE 148 TO 155: K = 9
     CASE 156 TO 163: K = 10
    END SELECT
   END IF
    Area = K + 18
    IF MLB1 = 1 THEN Active = Area
    IF MLB2 = 1 AND Active = Area THEN
    C = DA(22)
    SELECT CASE K
     CASE 1: C = C + 1000
     CASE 2: C = C + 100
     CASE 3: C = C + 10
     CASE 4: C = C + 1
     CASE 5: C = C - 1000
     CASE 6: C = C - 100
     CASE 7: C = C - 10
     CASE 8: C = C - 1
     CASE 9
        SELECT CASE DA(22)
         CASE 0: C = 1
         CASE 1 TO 216: C = 217
         CASE 217 TO 324: C = 325
         CASE 325 TO 378: C = 379
         CASE 379 TO 405: C = 406
         CASE 406 TO 418: C = 420
         CASE 420 TO 431: C = 432
         CASE 432 TO 446: C = 447
         CASE 447 TO 554: C = 555
         CASE 555 TO 662: C = 663
         CASE 663 TO 878: C = 879
         CASE 879 TO 986: C = 987
         CASE 987 TO 1040: C = 1041
         CASE 1041 TO 1067: C = 1068
         CASE 1068 TO 1080: C = 1081
         CASE 1081 TO 1296: C = 1297
         CASE 1297 TO 1404: C = 1405
         CASE 1405 TO 1458: C = 1459
         CASE 1459 TO 1485: C = 1486
         CASE 1486 TO 1498: C = 1500
        END SELECT
     CASE 10
        SELECT CASE DA(22)
         CASE 1 TO 216: C = 0
         CASE 217 TO 324: C = 1
         CASE 325 TO 378: C = 217
         CASE 379 TO 405: C = 325
         CASE 406 TO 418: C = 379
         CASE 420 TO 431: C = 406
         CASE 432 TO 446: C = 420
         CASE 447 TO 554: C = 432
         CASE 555 TO 662: C = 447
         CASE 663 TO 878: C = 555
         CASE 879 TO 986: C = 663
         CASE 987 TO 1040: C = 879
         CASE 1041 TO 1067: C = 987
         CASE 1068 TO 1080: C = 1041
         CASE 1081 TO 1296: C = 1068
         CASE 1297 TO 1404: C = 1081
         CASE 1405 TO 1458: C = 1297
         CASE 1459 TO 1485: C = 1405
         CASE 1486 TO 1498: C = 1459
         CASE 1500 TO 1755: C = 1486
        END SELECT
    END SELECT
    END IF
   IF C > 1755 THEN C = 1755
   IF C < 0 THEN C = 0
   DA(22) = C
EXIT SUB
END IF

' Get and put tiles
IF MX > 15 AND MY > 15 AND MY < 176 AND MX < 304 THEN
 Area = 18  ' Field
 X = DA(17)
 Y = DA(18)
 PX = X AND 15
 PY = Y AND 15
 DX = X \ 16
 DY = Y \ 16
 FX = (MX - 16 + PX) \ 16 + DX
 FY = (MY - 16 + PY) \ 16 + DY

 IF MRB = 1 THEN TTileX1 = X + MX: TTileY1 = Y + MY
 IF MRB THEN TTileX2 = X + MX: TTileY2 = Y + MY
 IF TTileX1 > TTileX2 THEN SWAP TTileX1, TTileX2
 IF TTileY1 > TTileY2 THEN SWAP TTileY1, TTileY2

 IF UCASE$(CH$) = "Z" THEN
  TTX1 = (TTileX1 - 8) \ 16
  TTY1 = (TTileY1 - 8) \ 16
  TTX2 = (TTileX2 - 8) \ 16
  TTY2 = (TTileY2 - 8) \ 16
  MapCX = TTX2 - TTX1 - 1
  MapCY = TTY2 - TTY1 - 1
  FOR Y = TTY1 TO TTY2
  FOR X = TTX1 TO TTX2
  TCMap(KX, KY) = TMap(X, Y, DA(0) - 3)
  KX = KX + 1
  NEXT
  KX = 0: KY = KY + 1
  NEXT
 END IF

 IF UCASE$(CH$) = "X" THEN
  C = DA(0) - 3
  FOR Y = 0 TO MapCY
  FOR X = 0 TO MapCX
   XR1 = X + FX
   YR1 = Y + FY
   IF XR1 > 71 THEN EXIT FOR
   IF YR1 > 39 THEN EXIT FOR
   TMap(XR1, YR1, C) = CheckPixel(TCMap(X, Y))
  NEXT
  NEXT
 END IF

 IF MRB = 1 OR MLB1 = 1 THEN Active = Area
 IF Area = Active THEN
  C = DA(0) - 3
  IF MRB > 0 THEN DA(22) = CheckPixel(TMap(FX, FY, C))
  IF MLB1 > 0 THEN
  TMap(FX, FY, C) = CheckPixel(DA(22))
  END IF
 END IF
END IF

END SUB

