'$DYNAMIC
'$INCLUDE: 'DIRECTQB.BI'
'$INCLUDE: 'CCMUSIC.BI'

SUB ActionPlace

IF AWindow THEN EXIT SUB
SELECT CASE Anything
 CASE 1
    A$ = Program$
    IF INSTR(Program$, ".") = 0 THEN A$ = A$ + "."
    CAS.TO.CXE Program$, LEFT$(A$, INSTR(A$, ".") - 1) + ".CXE"
    AWindow = 6
 CASE 2: ClearProg
 CASE 3: EndProg
 CASE 4: AWindow = 8
END SELECT
Anything = 0

END SUB

FUNCTION ByteCode (Pointer&)

X = Pointer& MOD 320
Y = Pointer& \ 320 MOD 200
L = Pointer& \ 64000 + 20
ByteCode = DQBpoint(L, X, Y)

END FUNCTION

FUNCTION ByteGet4 (Track, Event)

JX = (Event * 8&) MOD 320
JY = (Event \ 40)
ByteGet4 = DQBpoint(Track + 1, JX + 3, JY)

END FUNCTION

FUNCTION ByteGet5 (Track, Event)

JX = (Event * 8&) MOD 320
JY = (Event \ 40)
ByteGet5 = DQBpoint(Track + 1, JX + 4, JY)

END FUNCTION

FUNCTION ByteGet6 (Track, Event)

JX = (Event * 8&) MOD 320
JY = (Event \ 40)
ByteGet6 = DQBpoint(Track + 1, JX + 5, JY)

END FUNCTION

FUNCTION ByteGet7 (Track, Event)

JX = (Event * 8&) MOD 320
JY = (Event \ 40)
ByteGet7 = DQBpoint(Track + 1, JX + 6, JY)

END FUNCTION

FUNCTION ByteGet8 (Track, Event)

JX = (Event * 8&) MOD 320
JY = (Event \ 40)
ByteGet8 = DQBpoint(Track + 1, JX + 7, JY)

END FUNCTION

REM $STATIC
SUB CAS.GOTO.Measure (MeasNumb)

' Change values according to their new positions
FOR I = 0 TO 16
TrackPTR(I) = MeasCAS(MeasNumb, I)    ' New track pointers ready
NEXT
Ticks& = TTE&(0, TrackPTR(0))         ' Ticks& gets arranged as well

END SUB

SUB CAS.Sort.Track (Track)

' Speed up track sorting by scattering it
IF TrackLen(Track) >= 1024 THEN
FOR I = 0 TO (TrackLen(Track) - 500) STEP 15
JX1 = ((I + 211) * 8&) MOD 320: JY1 = ((I + 211) \ 40)
JX2 = (I * 8&) MOD 320: JY2 = (I \ 40)
 DQBget 0, JX1, JY1, JX1 + 7, JY1, VARSEG(SortBuff(0, 0)), VARPTR(SortBuff(0, 0))
 DQBget 0, JX2, JY2, JX2 + 7, JY2, VARSEG(SortBuff(0, 1)), VARPTR(SortBuff(0, 1))
 DQBfPut 0, JX1, JY1, VARSEG(SortBuff(0, 1)), VARPTR(SortBuff(0, 1))
 DQBfPut 0, JX2, JY2, VARSEG(SortBuff(0, 0)), VARPTR(SortBuff(0, 0))
NEXT
END IF

' Quicksort our music data
REDIM SL(-1 TO 63) AS INTEGER
REDIM SR(-1 TO 63) AS INTEGER
SP = 0
I = 0
J = 0
L = 0
R = 0

IF TrackLen(Track) THEN
SL(0) = 0
SR(0) = TrackLen(Track) - 1
BackAgain:
L = SL(SP)
R = SR(SP)
SP = SP - 1
IF L >= R THEN
 IF SP >= 0 THEN GOTO BackAgain ELSE GOTO Finished
END IF
IF I >= TrackLen(Track) THEN GOTO Finished
I = L
J = R + 1
P& = TTE&(Track, L)
ScanLeft:
J = J - 1: IF TTE&(Track, J) > P& THEN GOTO ScanLeft
ScanRight:
I = I + 1: IF (TTE&(Track, I) < P&) AND (I < R) THEN GOTO ScanRight
IF I < J THEN
 JX1 = (I * 8&) MOD 320: JY1 = (I \ 40)
 JX2 = (J * 8&) MOD 320: JY2 = (J \ 40)
  DQBget Track + 1, JX1, JY1, JX1 + 7, JY1, VARSEG(SortBuff(0, 0)), VARPTR(SortBuff(0, 0))
  DQBget Track + 1, JX2, JY2, JX2 + 7, JY2, VARSEG(SortBuff(0, 1)), VARPTR(SortBuff(0, 1))
  DQBfPut Track + 1, JX1, JY1, VARSEG(SortBuff(0, 1)), VARPTR(SortBuff(0, 1))
  DQBfPut Track + 1, JX2, JY2, VARSEG(SortBuff(0, 0)), VARPTR(SortBuff(0, 0))
 GOTO ScanLeft
END IF
JX1 = (L * 8&) MOD 320: JY1 = (L \ 40)
JX2 = (J * 8&) MOD 320: JY2 = (J \ 40)
 DQBget Track + 1, JX1, JY1, JX1 + 7, JY1, VARSEG(SortBuff(0, 0)), VARPTR(SortBuff(0, 0))
 DQBget Track + 1, JX2, JY2, JX2 + 7, JY2, VARSEG(SortBuff(0, 1)), VARPTR(SortBuff(0, 1))
 DQBfPut Track + 1, JX1, JY1, VARSEG(SortBuff(0, 1)), VARPTR(SortBuff(0, 1))
 DQBfPut Track + 1, JX2, JY2, VARSEG(SortBuff(0, 0)), VARPTR(SortBuff(0, 0))
SP = SP + 1: SL(SP) = J + 1: SR(SP) = R
SP = SP + 1: SR(SP) = J - 1: SL(SP) = L
GOTO BackAgain
END IF
Finished:

' Sorting measure breaks for proper sequential numbers.
JY = 0
IF Track = 0 THEN
 FOR I = 0 TO (TrackLen(0) - 1)
  IF ByteGet4(0, I) = 14 THEN
   PutByte5 Track, I, JY
   JY = JY + 1
  END IF
 NEXT
END IF

' Giving Pointers for tracks using GOTOs
FOR I = 0 TO (TrackLen(0) - 1)
 IF ByteGet4(0, I) = 14 THEN
  MeasCAS(IncMes, 0) = I
  MNM& = TTE&(0, I)
   FOR JX = 0 TO 16
    FOR JY = 0 TO (TrackLen(JX) - 1)
     IF TTE&(JX, JY) >= MNM& THEN
      MeasCAS(IncMes, JX) = JY
      EXIT FOR
     END IF
    NEXT
   NEXT
  IncMes = IncMes + 1
 END IF
NEXT
MeasUsed = IncMes

END SUB

SUB CAS.TO.CXE (CAS$, CXE$)

CAS.Save CAS$
IF CXE$ = "(UNTITLED).CXE" THEN AWindow = 2: EXIT SUB
IF CXE$ = "" THEN AWindow = 2: EXIT SUB
OPEN CXE$ FOR BINARY AS #1
IF LOF(1) THEN CLOSE #1: KILL CXE$: OPEN CXE$ FOR BINARY AS #1
CASPlaying = 0
CAS.Stop

'CXE Header
  A$ = "CCMusic"
  PUT #1, 1, A$

'Samples
 FOR I = 0 TO 15
  A$ = Samples(I)
  PUT #1, 9 + (I * 12), A$
 NEXT
 SEEK #1, 201  ' Start off of files
 Prev& = 0
 Tim& = 0

' Keep scanning for more coming events until we're done.

DO

 'Scan which track has next timing event
 IF FP& > 192000 THEN CLOSE #1: AWindow = 3: EXIT SUB

 Prev& = Tim&
 PLowest = Lowest
 Lowest = 0
 Q& = 2000000000

IF PLowest THEN
 I = PLowest - 1
 TP = TrackPTR(I)
 TL = TrackLen(I)
 ID = ByteGet4(I, TP)
 IF TL > 0 AND TP < TL AND ID > 0 THEN
  IF Prev& = TTE&(I, TP) THEN
   Tim& = TTE&(I, TP)
   Lowest = PLowest
   GOTO PrevStart
  END IF
 END IF
END IF

FOR I = 0 TO 16
 TP = TrackPTR(I)
 TL = TrackLen(I)
 ID = ByteGet4(I, TP)
 IF TL > 0 AND TP < TL AND ID > 0 THEN
   IF TTE&(I, TP) < Q& THEN
    Tim& = TTE&(I, TP)
    Q& = Tim&
    Lowest = I + 1
   END IF
  END IF
NEXT

PrevStart:

'Now we have the track and event... let's analyze event, ELSE DONE! :)
IF Lowest THEN
  Del& = (Tim& - Prev&)

  'Delay?
  IF Del& THEN
   SELECT CASE Del&
    CASE 1 TO 32
      A$ = CHR$(Del&)
      PUT #1, , A$
    CASE 33 TO 255
      A$ = CHR$(106) + CHR$(Del&)
      PUT #1, , A$
    CASE 256 TO 65535
      A$ = CHR$(124) + CHR$((Del& AND 255)) + CHR$((Del& \ 256))
      PUT #1, , A$
    CASE IS > 65535
      A$ = CHR$(141) + CHR$((Del& AND 255))
      A$ = A$ + CHR$(((Del& \ 256) AND 255)) + CHR$((Del& \ 65536))
      PUT #1, , A$
    END SELECT
   END IF

  L = Lowest - 1
  TP = TrackPTR(L)
  TrackPTR(L) = TrackPTR(L) + 1
  ID = ByteGet4(L, TP)
  Byte5 = ByteGet5(L, TP)
  Byte6 = ByteGet6(L, TP)
  Byte7 = ByteGet7(L, TP)
  Byte8 = ByteGet8(L, TP)

  'Master track, or music track?
   IF L THEN  ' music
    SELECT CASE ID
     CASE 1
      IF Byte5 = Byte6 THEN
          IF Byte8 = 0 AND (Byte7 MOD 12) = 0 THEN
            SELECT CASE Byte7
              CASE 0: A$ = CHR$(69 + Byte5)
              CASE 12: A$ = CHR$(53 + Byte5)
              CASE 24: A$ = CHR$(37 + Byte5)
             END SELECT
            PUT #1, , A$
          ELSE
           A$ = CHR$(107 + Byte5) + CHR$(Byte7 + (Byte8 * 32))
           PUT #1, , A$
          END IF
       ELSE
        A$ = CHR$(123) + CHR$(Byte5 + (Byte6 * 16)) + CHR$(Byte7 + (Byte8 * 32))
        PUT #1, , A$
       END IF
     CASE 2
      A$ = CHR$(90 + Byte5) + CHR$(Byte6)
      PUT #1, , A$
     CASE 3
      A$ = CHR$(89) + CHR$(Byte5)
      PUT #1, , A$
     CASE 4
      A$ = CHR$(125 + Byte5) + CHR$(Byte6) + CHR$(Byte7)
      PUT #1, , A$
    END SELECT
   ELSE       ' master
    SELECT CASE ID
     CASE 1
      A$ = CHR$(0)
      PUT #1, , A$
     CASE 2 TO 5
      A$ = CHR$(31 + ID)
      PUT #1, , A$
     CASE 6 TO 8
      A$ = CHR$(79 + ID) + CHR$(Byte5)
      PUT #1, , A$
     CASE 9
      A$ = CHR$(88) + CHR$(Byte5)
      PUT #1, , A$
     CASE 10
      A$ = CHR$(190) + CHR$(Byte5) + SPACE$(2)
      PUT #1, , A$
     CASE 11
       IF Byte5 < 16 THEN
        A$ = CHR$(142 + Byte5) + CHR$(Byte6) + SPACE$(2)
        PUT #1, , A$
       ELSE
        A$ = CHR$(191) + CHR$(Byte5) + CHR$(Byte6) + SPACE$(2)
        PUT #1, , A$
       END IF
     CASE 12
       IF Byte5 < 16 THEN
        A$ = CHR$(158 + Byte5) + CHR$(Byte6) + SPACE$(2)
        PUT #1, , A$
       ELSE
        A$ = CHR$(192) + CHR$(Byte5) + CHR$(Byte6) + SPACE$(2)
        PUT #1, , A$
       END IF
     CASE 13
       IF Byte5 < 16 THEN
        A$ = CHR$(174 + Byte5) + CHR$(Byte6) + SPACE$(2)
        PUT #1, , A$
       ELSE
        A$ = CHR$(193) + CHR$(Byte5) + CHR$(Byte6) + SPACE$(2)
        PUT #1, , A$
       END IF
     CASE 14
      MeasRef(MBP) = SEEK(1) - 201
      MBP = (MBP + 1) AND 255
    END SELECT
   END IF
 ELSE
  EXIT DO
END IF

LOOP
CLOSE #1

' 2nd bypass, converting the GOTO statements with MeasRef DATA
OPEN CXE$ FOR BINARY AS #1
Q& = LOF(1)
FP& = 201

DO
 A$ = " "
 GET #1, FP&, A$
  ID = ASC(A$)
  IF ID > 141 AND ID < 194 THEN
    SELECT CASE ID
     CASE 142 TO 190
      A$ = " "
      GET #1, FP& + 1, A$
      LM& = MeasRef(ASC(A$))
      A$ = CHR$((LM& AND 255))
      A$ = A$ + CHR$((LM& \ 256) AND 255)
      A$ = A$ + CHR$(LM& \ 65536)
      PUT #1, FP& + 1, A$
     CASE 191 TO 193
      A$ = " "
      GET #1, FP& + 2, A$
      LM& = MeasRef(ASC(A$))
      A$ = CHR$((LM& AND 255))
      A$ = A$ + CHR$((LM& \ 256) AND 255)
      A$ = A$ + CHR$(LM& \ 65536)
      PUT #1, FP& + 2, A$
     END SELECT
   END IF
  FP& = FP& + 1
 IF ID > 84 THEN FP& = FP& + 1
 IF ID > 122 THEN FP& = FP& + 1
 IF ID > 140 THEN FP& = FP& + 1
 IF ID > 190 THEN FP& = FP& + 1
LOOP UNTIL FP& >= Q&

CLOSE #1

END SUB

REM $DYNAMIC
SUB CenterText (Row, Text$)

LOCATE Row, 40 - (LEN(Text$) \ 2): PRINT Text$;

END SUB

SUB CreateBG

' Turn off blinking and allow background intensity
REDIM Dummy(7) AS INTEGER
Dummy(0) = &H1003
CALL INT86OLD(&H10, Dummy(), Dummy())
ERASE Dummy

' Fill lines screen
COLOR 1
A$ = "۲ "
A$ = A$ + A$
FOR I = 25 TO 1 STEP -1
DQBwait 1
LOCATE I: PRINT A$ + A$ + A$ + A$ + A$;
NEXT

' Fill with blue
SCREEN 0, , 2, 0
COLOR 1
CLS
FOR I = 0 TO 239
PRINT A$;
NEXT

' Track design
COLOR 7, 1
LOCATE 5, 67: PRINT " MASTER TR "
FOR I = 1 TO 9
LOCATE I + 5, 67: PRINT " MTRACK 0" + LTRIM$(STR$(I)) + " "
NEXT
FOR I = 0 TO 6
LOCATE I + 15, 67: PRINT " MTRACK" + STR$(I + 10) + " "
NEXT

' Red Bar for description
COLOR 12, 0: LOCATE 2, 1: PRINT STRING$(80, 176)
LOCATE 23, 36: PRINT " Tick Signature:"

' Shading for TIME and FPS
COLOR 9
LOCATE 1, 1: PRINT STRING$(80, 219)
LOCATE 1, 32: PRINT " "
LOCATE 1, 43: PRINT " "
LOCATE 1, 52: PRINT " "
LOCATE 1, 67: PRINT " "
LOCATE 23, 3: PRINT " AUTO Repeat: OFF "
LOCATE 23, 23: PRINT " Play/Stop "
LOCATE 20, 48: PRINT " Current Ticks: "
LOCATE 17, 49: PRINT " Time Elapse: "
LOCATE 15, 50: PRINT " LoopVal: "
LOCATE 21, 48: PRINT SPACE$(16)

' Draw field stuff
MakeBoxF 5, 2, 20, 42, 32, 10, 0

' Draw menu stuff
COLOR 7
LOCATE 1, 3: PRINT " FILE  EDIT  MUSIC "
SCREEN 0, , 1, 0
FPS = 73
G! = TIMER + 1

END SUB

SUB EndProg

PCOPY 0, 1
DQBsetDrive LEFT$(OPath$, 1)
Dummy = DQBchDir(OPath$)
DQBremoveSB
DQBclose
Q& = SETMEM(40000)

DEF SEG = &HB900
FOR I = 0 TO 39
FOR X = 78 TO 0 STEP -2
FOR Y = 0 TO 3840 STEP 160
C = Y + X
C1 = PEEK(C)
C2 = PEEK(C + 1)
 POKE C + 2, C1
 POKE C + 3, C2
 IF X = 78 THEN
  FOR II = 0 TO 3840 STEP 160
   POKE II, 0
  NEXT
 END IF
NEXT
NEXT
DQBwait 1
PCOPY 1, 0
NEXT

FOR I = 0 TO 39
FOR X = 80 TO 158
FOR Y = 0 TO 3840 STEP 160
C = Y + X
 C1 = PEEK(C + 2)
 C2 = PEEK(C + 3)
 POKE C, C1
 POKE C + 1, C2
NEXT
NEXT
DQBwait 1
PCOPY 1, 0
NEXT

SCREEN 0, , 0, 0
CLS
A$ = "Thanks for using Cyber Chick Music Editor v2 "
B$ = "۲"

FOR I = 1 TO LEN(A$)
  X = 51 - (50 * SIN(I * (3.141593 / 90)))
 
  LOCATE 1
  COLOR 4, 6: LOCATE , X: PRINT B$;
  COLOR 14, 6: LOCATE , X + 4: PRINT " ";
  COLOR 14, 2: LOCATE , X + 8: PRINT B$;
  COLOR 2, 3: LOCATE , X + 12: PRINT B$;
  COLOR 3, 1: LOCATE , X + 16: PRINT B$;
  COLOR 1, 5: LOCATE , X + 20: PRINT B$;
  COLOR 5, 0: LOCATE , X + 24: PRINT B$ + "    "
    COLOR 10
 LOCATE 2, 1: PRINT LEFT$(A$, I) + ""
DQBwait 1
NEXT

LOCATE 2, 46: PRINT "   "
COLOR 7

END

END SUB

SUB ErrorPROMPT.Disp

SELECT CASE AWindow
CASE 1: A$ = "File not found or bad format"
CASE 2: A$ = "Invalid File"
CASE 3: A$ = "CAS to CXE conversion exceeds 187.5k"
CASE 13: A$ = "Not enough memory on selected track"
END SELECT

MakeBoxF 12, 15, 16, 69, 32, 0, 0
MakeBoxF 11, 13, 15, 67, 32, 15, 4
MakeBox 11, 13, 15, 67, 15, 4
CenterText 11, " " + A$ + " "
CenterText 14, "<  OK  >"
IF DummyInteger(2) OR SBAR THEN InvertBox 13, 35, 13, 42

END SUB

SUB ErrorPROMPT.Input

IF DummyInteger(3) THEN
 CleanDummies
 AWindow = 0
END IF

' Mouse Area for OK button
IF MY = 14 AND MX >= 36 AND MX <= 43 THEN Area = 1
IF CH$ = CHR$(13) OR CH$ = CHR$(27) OR SBAR = -1 THEN DummyInteger(3) = 1
StdInp 0, 1, DummyInteger(3), Area

END SUB

REM $STATIC
SUB EventInput

SELECT CASE UCASE$(CH$)
 CASE "1" TO "9", "0", "[", "]", "\": I = 1
 CASE "-", "=", "/", "*", "`", "'": I = 1
 CASE "A" TO "Z", ",", ".", ";": I = 1
END SELECT
IF I = 0 THEN EXIT SUB

Att = ATrack
Evv = TrackScr(Att, 1)
Evv2 = TrackScr(Att, 2)
IF Evv2 >= Evv THEN StepNeg = 1 ELSE StepNeg = -1

ID = ByteGet4(Att, Evv)
AE = AEvent(SGN(Att))

' Undo buffer
Undo = Att + 1
DQBcopyLayer Undo, 19
UndoTL = TrackLen(Att)

SELECT CASE ASC(CH$)
 CASE 49 TO 54
   Tim& = TTE&(Att, Evv)
   PM& = Tim&
    SELECT CASE CH$
     CASE "1": Tim& = Tim& - (TickSig * 256&)
     CASE "2": Tim& = Tim& + (TickSig * 256&)
     CASE "3": Tim& = Tim& - (TickSig * 16&)
     CASE "4": Tim& = Tim& + (TickSig * 16&)
     CASE "5": Tim& = Tim& - TickSig
     CASE "6": Tim& = Tim& + TickSig
    END SELECT
   IF Tim& < 0 THEN Tim& = 0
   L& = (65535 * TickSig) + (TickSig - 1)
   IF Tim& > L& THEN Tim& = L&
   PutTime Att, Evv, Tim&
   IF PM& <> Tim& THEN CAS.Sort.Track Att
   Modified = 1
 CASE 55 TO 57, 48
   Tim& = TTE&(Att, Evv)
   PM& = Tim&
    SELECT CASE CH$
     CASE "7": Tim& = Tim& - 16
     CASE "8": Tim& = Tim& + 16
     CASE "9": Tim& = Tim& - 1
     CASE "0": Tim& = Tim& + 1
    END SELECT
   IF Tim& < 0 THEN Tim& = 0
   L& = (65535 * TickSig) + (TickSig - 1)
   IF Tim& > L& THEN Tim& = L&
   PutTime Att, Evv, Tim&
   IF PM& <> Tim& THEN CAS.Sort.Track Att
   Modified = 1
END SELECT

' Everything else:
IF Att THEN

 SELECT CASE ID
  CASE 1
     A$ = KeyB
     C = INSTR(A$, LCASE$(CH$))
     IF C THEN
      FOR Revi = Evv TO Evv2 STEP StepNeg
      PutByte7 Att, Revi, C - 1
      NEXT Revi
      DQBplaySound ByteGet5(Att, Evv) + 1, ByteGet6(Att, Evv) + 1, Pitch(ByteGet7(Att, Evv)), ByteGet8(Att, Evv) AND 1
      Modified = 1
     END IF
    SELECT CASE CH$
     CASE "/", "*"
        FOR Revi = Evv TO Evv2 STEP StepNeg
        C = ByteGet7(Att, Revi)
        IF CH$ = "/" THEN C = C - 1 ELSE C = C + 1
        IF C = -1 THEN C = 30
        IF C = 31 THEN C = 0
        PutByte7 Att, Revi, C
        NEXT Revi
        DQBplaySound ByteGet5(Att, Evv) + 1, ByteGet6(Att, Evv) + 1, Pitch(ByteGet7(Att, Evv)), ByteGet8(Att, Evv) AND 1
        Modified = 1
     CASE "`"
        FOR Revi = Evv TO Evv2 STEP StepNeg
        PutByte8 Att, Revi, ByteGet8(Att, Revi) XOR 1
        NEXT Revi
        DQBplaySound ByteGet5(Att, Evv) + 1, ByteGet6(Att, Evv) + 1, Pitch(ByteGet7(Att, Evv)), ByteGet8(Att, Evv) AND 1
        Modified = 1
     CASE "[", "]"
        FOR Revi = Evv TO Evv2 STEP StepNeg
        P = ByteGet5(Att, Revi)
        IF CH$ = "[" THEN P = (P - 1) AND 15
        IF CH$ = "]" THEN P = (P + 1) AND 15
        PutByte5 Att, Revi, P
        NEXT Revi
        DQBplaySound ByteGet5(Att, Evv) + 1, ByteGet6(Att, Evv) + 1, Pitch(ByteGet7(Att, Evv)), ByteGet8(Att, Evv) AND 1
        Modified = 1
      CASE "-"
        FOR Revi = Evv TO Evv2 STEP StepNeg
        PutByte6 Att, Revi, (ByteGet6(Att, Revi) - 1) AND 15
        NEXT Revi
        DQBplaySound ByteGet5(Att, Evv) + 1, ByteGet6(Att, Evv) + 1, Pitch(ByteGet7(Att, Evv)), ByteGet8(Att, Evv) AND 1
        Modified = 1
      CASE "="
        FOR Revi = Evv TO Evv2 STEP StepNeg
        PutByte6 Att, Revi, (ByteGet6(Att, Revi) + 1) AND 15
        NEXT Revi
        DQBplaySound ByteGet5(Att, Evv) + 1, ByteGet6(Att, Evv) + 1, Pitch(ByteGet7(Att, Evv)), ByteGet8(Att, Evv) AND 1
        Modified = 1
    END SELECT
  CASE 2
      IF CH$ = "-" THEN
       FOR Revi = Evv TO Evv2 STEP StepNeg
       PutByte5 Att, Revi, (ByteGet5(Att, Revi) - 1) AND 15
       NEXT Revi
       Modified = 1
      END IF
      IF CH$ = "=" THEN
       FOR Revi = Evv TO Evv2 STEP StepNeg
       PutByte5 Att, Revi, (ByteGet5(Att, Revi) + 1) AND 15
       NEXT Revi
       Modified = 1
      END IF
       
        FOR Revi = Evv TO Evv2 STEP StepNeg
        P = ByteGet6(Att, Revi)
        C = P
        SELECT CASE UCASE$(CH$)
         CASE "Q": P = (P - 8)
         CASE "W": P = (P + 8)
         CASE "E": P = (P - 1)
         CASE "R": P = (P + 1)
        END SELECT
        IF P < 0 THEN P = 0
        IF P > 63 THEN P = 63
        PutByte6 Att, Revi, P
        IF C <> P THEN Modified = 1
        NEXT Revi
        
  CASE 3
      IF CH$ = "-" THEN
      FOR Revi = Evv TO Evv2 STEP StepNeg
      PutByte5 Att, Revi, (ByteGet5(Att, Revi) - 1) AND 15
      NEXT Revi
      Modified = 1
      END IF

      IF CH$ = "=" THEN
      FOR Revi = Evv TO Evv2 STEP StepNeg
      PutByte5 Att, Revi, (ByteGet5(Att, Revi) + 1) AND 15
      NEXT Revi
      Modified = 1
      END IF
 
  CASE 4
      IF CH$ = "-" THEN
      FOR Revi = Evv TO Evv2 STEP StepNeg
      PutByte5 Att, Revi, (ByteGet5(Att, Revi) - 1) AND 15
      NEXT Revi
      Modified = 1
      END IF

      IF CH$ = "=" THEN
      FOR Revi = Evv TO Evv2 STEP StepNeg
      PutByte5 Att, Revi, (ByteGet5(Att, Revi) + 1) AND 15
      NEXT Revi
      Modified = 1
      END IF

      FOR Revi = Evv TO Evv2 STEP StepNeg
      P = ByteGet6(Att, Revi) + (ByteGet7(Att, Revi) * 256&)
      C = P
      SELECT CASE UCASE$(CH$)
        CASE "Q": P = (P - 256)
        CASE "W": P = (P + 256)
        CASE "E": P = (P - 16)
        CASE "R": P = (P + 16)
        CASE "T": P = (P - 1)
        CASE "Y": P = (P + 1)
      END SELECT
      IF P < Pitch(0) THEN P = Pitch(0)
      IF P > Pitch(30) THEN P = Pitch(30)
      PutByte6 Att, Revi, P AND 255
      PutByte7 Att, Revi, P \ 256
      IF C <> P THEN Modified = 1
      NEXT Revi
 END SELECT

ELSE

 SELECT CASE ID
  CASE 1 TO 3
  
   IF CH$ = "`" THEN
   FOR Revi = Evv TO Evv2 STEP StepNeg
   PutByte4 0, Revi, (ID MOD 3) + 1
   NEXT Revi
   Modified = 1
   END IF
 
  CASE 4 TO 8
  
   IF CH$ = "`" THEN
   FOR Revi = Evv TO Evv2 STEP StepNeg
   PutByte4 0, Revi, ((ID - 3) MOD 5) + 4
   NEXT Revi
   Modified = 1
   END IF

    FOR Revi = Evv TO Evv2 STEP StepNeg
    P = ByteGet5(0, Revi)
    C = P
     SELECT CASE UCASE$(CH$)
      CASE "Q": P = (P - 16)
      CASE "W": P = (P + 16)
      CASE "E": P = (P - 1)
      CASE "R": P = (P + 1)
     END SELECT
     PutByte5 0, Revi, P AND 255
     IF C <> P THEN Modified = 1
     NEXT Revi

  CASE 9
   
    FOR Revi = Evv TO Evv2 STEP StepNeg
    P = ByteGet5(0, Revi)
    C = P
     SELECT CASE UCASE$(CH$)
      CASE "Q": P = (P - 8)
      CASE "W": P = (P + 8)
      CASE "E": P = (P - 1)
      CASE "R": P = (P + 1)
     END SELECT
     IF P < 0 THEN P = 0
     IF P > 63 THEN P = 63
     PutByte5 0, Revi, P
     IF C <> P THEN Modified = 1
    NEXT Revi
      
  CASE 10
   
    FOR Revi = Evv TO Evv2 STEP StepNeg
    P = ByteGet5(0, Revi)
    C = P
     SELECT CASE UCASE$(CH$)
      CASE "Q": P = (P - 16)
      CASE "W": P = (P + 16)
      CASE "E": P = (P - 1)
      CASE "R": P = (P + 1)
     END SELECT
     PutByte5 0, Revi, P AND 255
     IF C <> P THEN Modified = 1
     NEXT Revi

  CASE 11 TO 13
    IF CH$ = "`" THEN
    FOR Revi = Evv TO Evv2 STEP StepNeg
    PutByte4 0, Revi, ((ID - 10) MOD 3) + 11
    NEXT Revi
    Modified = 1
    END IF

    FOR Revi = Evv TO Evv2 STEP StepNeg
    P = ByteGet5(0, Revi)
    C = P
    I = ByteGet6(0, Revi)
    J = I
     SELECT CASE UCASE$(CH$)
      CASE "Q": P = (P - 16)
      CASE "W": P = (P + 16)
      CASE "E": P = (P - 1)
      CASE "R": P = (P + 1)
      CASE "T": I = (I - 16)
      CASE "Y": I = (I + 16)
      CASE "U": I = (I - 1)
      CASE "I": I = (I + 1)
     END SELECT
     PutByte5 0, Revi, P AND 255
     PutByte6 0, Revi, I AND 255
     IF C <> P THEN Modified = 1
     IF I <> J THEN Modified = 1
     NEXT Revi

  END SELECT
END IF
CH$ = ""

END SUB

REM $DYNAMIC
SUB FieldDisplay

' Field box highlight
SELECT CASE AField
 CASE 0: MakeABox 4, 1, 21, 43
 CASE 1: MakeABox 4, 45, 13 + ((ATrack > 0) * 4), 64
 CASE 2: MakeABox 4, 66, 22, 78
END SELECT

' Main Field
C = 15
IF TrackLen(ATrack) < C THEN
 TrackScr(ATrack, 0) = 0
 C = TrackLen(ATrack) - 1
END IF
 FOR I = 0 TO C
  PrintEvent ATrack, I + TrackScr(ATrack, 0), 5 + I, 0
 NEXT

' Event flashing back
C = TrackScr(ATrack, 1) - TrackScr(ATrack, 0)
I = TrackScr(ATrack, 1) - TrackScr(ATrack, 2)
 IF I >= 0 THEN
  IF I > 15 THEN I = 15
   FOR J = 0 TO I
    K = C + 5 + J - I
    IF K < 5 THEN K = 5
    IF K > 20 THEN K = 20
    PokeBCol K, 2, 1, 40
   NEXT
 ELSE
  IF I < -15 THEN I = -15
   FOR J = 0 TO I STEP -1
    K = C + 5 + J - I
    IF K < 5 THEN K = 5
    IF K > 20 THEN K = 20
    PokeBCol K, 2, 1, 40
   NEXT
END IF

' Highlight events
IF TrackLen(ATrack) AND TrackPTR(ATrack) > 0 THEN
 Y = TrackPTR(ATrack) - TrackScr(ATrack, 0)
  IF Y >= 1 AND Y <= 16 THEN
    PokeBCol Y + 4, 2, 4, 40
  END IF
END IF

' Draw scroll bar
IF TrackLen(ATrack) > 16 THEN
 COLOR 0, 7
 LOCATE 5, 42: PRINT CHR$(24)
 FOR I = 6 TO 20
 LOCATE I, 42: PRINT ""
 NEXT
 LOCATE 20, 42: PRINT CHR$(25)
 Y = Interpolate(6, 19, TrackScr(ATrack, 0), (TrackLen(ATrack) - 16))
 COLOR 15, 0: LOCATE Y, 42: PRINT CHR$(219)
END IF

' Show events
COLOR 7, 1
IF ATrack THEN
 LOCATE 5, 46: PRINT " Play Note        "
 LOCATE 6, 46: PRINT " Channel Volume   "
 LOCATE 7, 46: PRINT " Stop Channel     "
 LOCATE 8, 46: PRINT " Pitch Bend       "
  IF AField = 1 THEN
   PokeCol 5, 47, 15, 1
   PokeCol 6, 55, 15, 1
   PokeCol 7, 47, 15, 1
   PokeCol 8, 53, 15, 1
  END IF
ELSE
 LOCATE 5, 46: PRINT " Stop Music       "
 LOCATE 6, 46: PRINT " Stop CVoices     "
 LOCATE 7, 46: PRINT " Repeat Music     "
 LOCATE 8, 46: PRINT " Set Chan Vol     "
 LOCATE 9, 46: PRINT " LET LoopVal      "
 LOCATE 10, 46: PRINT " IF LoopVal       "
 LOCATE 11, 46: PRINT " GOTO 00000:000   "
 LOCATE 12, 46: PRINT " Measure Ins      "
  IF AField = 1 THEN
   PokeCol 5, 47, 15, 1
   PokeCol 6, 52, 15, 1
   PokeCol 7, 47, 15, 1
   PokeCol 8, 56, 15, 1
   PokeCol 9, 47, 15, 1
   PokeCol 10, 47, 15, 1
   PokeCol 11, 47, 15, 1
   PokeCol 12, 47, 15, 1
  END IF
END IF

IF AField = 2 THEN
 PokeCol 5, 70, 15, 1
 FOR I = 0 TO 9
  PokeCol 6 + I, 76, 15, 1
 NEXT
 FOR I = 0 TO 5
  PokeCol 16 + I, 68 + I, 15, 1
 NEXT
END IF

COLOR 2, 0
LOCATE 15, 59: PRINT LoopVal
LOCATE 21, 52: PRINT TickStr$(Ticks&)
LOCATE 23, 52: PRINT TickSig

I = AEvent(SGN(ATrack))
InvertBox I + 4, 45, I + 4, 62            ' Active event
InvertBox ATrack + 4, 66, ATrack + 4, 76  ' Active track

' Design time elapse
GG& = TimeE&
H% = GG& \ 252000
M% = GG& \ 4200 MOD 60
S% = GG& \ 70 MOD 60
F% = GG& MOD 70
OH$ = LTRIM$(STR$(H%))
OM$ = LTRIM$(STR$(M%))
OS$ = LTRIM$(STR$(S%))
OF$ = LTRIM$(STR$(F%))
IF H% < 10 THEN OH$ = "0" + OH$
IF M% < 10 THEN OM$ = "0" + OM$
IF S% < 10 THEN OS$ = "0" + OS$
IF F% < 10 THEN OF$ = "0" + OF$
LOCATE 18, 51: PRINT OH$ + ":" + OM$ + ":" + OS$ + ":" + OF$

END SUB

REM $STATIC
SUB File.Disp

' Put files and directories into string
Ref$ = CHR$(255)
FOR I = 0 TO 7
 C = DummyInteger(3)
 DummyString(I + 1) = DirSub$(0, I + C)
 C = DummyInteger(10)
 DummyString(I + 9) = DirSub$(1, I + C)
NEXT

' Window
MakeBoxF 5, 4, 23, 44, 32, 0, 0
MakeBoxF 4, 2, 22, 42, 32, 1, 1

' Display path
COLOR 10, 1
LOCATE 9, 5: PRINT LEFT$(DummyString(0), 32)

' Display files
C = DummyInteger(1)
IF C > 8 THEN C = 8: TT = 1
FOR I = 1 TO C
 LOCATE 11 + I, 5: PRINT DummyString(I)
NEXT

' Display directories
C = DummyInteger(8)
IF C > 8 THEN C = 8: TTT = 1
FOR I = 1 TO C
 LOCATE 11 + I, 25: PRINT DummyString(I + 8)
NEXT

' Display boxes
MakeBox 4, 2, 22, 42, 7, 1
MakeBox2 11, 4, 20, 20, 7, 1
MakeBox2 11, 23, 20, 40, 7, 1
MakeBox2 5, 4, 7, 40, 7, 1

' Action
SELECT CASE AWindow
 CASE 8: LOCATE 4, 14: PRINT " Open CAS File "
 CASE 9: LOCATE 4, 12: PRINT " Save CAS File As "
 CASE 10: LOCATE 4, 7: PRINT " Load WAV File for Track #" + LTRIM$(STR$(ATrack)) + " "
END SELECT
LOCATE 21, 13: PRINT "<  OK  >  < CANCEL >"
LOCATE 6, 6
PRINT DummyString(17)

' Labels
LOCATE 11, 26: PRINT " Dir/Drives: "
LOCATE 11, 8: PRINT " Files: "
LOCATE 8, 5: PRINT "Path:"
LOCATE 5, 16: PRINT " File Name: "

' Name and chosen stuff
COLOR 15
SELECT CASE DummyInteger(4)
 CASE 0: IF (FrameTile AND 16) THEN PokeCol 6, 6 + DummyInteger(7), 15, 9 + (INS * 3)
 CASE 1: C = DummyInteger(2) - DummyInteger(3) + 12: PokeBCol C, 5, 9, 14
 CASE 2: C = DummyInteger(9) - DummyInteger(10) + 12: PokeBCol C, 24, 9, 14
 CASE 3: PokeCol 21, 13, 15, 1: PokeCol 21, 20, 15, 1
 CASE 4: PokeCol 21, 23, 15, 1: PokeCol 21, 32, 15, 1
END SELECT

' Scroll bar for files
IF TT THEN
 LOCATE 12, 19: PRINT CHR$(24)
 FOR I = 13 TO 18
 LOCATE I, 19: PRINT ""
 NEXT
 LOCATE 19, 19: PRINT CHR$(25)
 Y = Interpolate(13, 18, DummyInteger(3), (DummyInteger(1) - 8))
 LOCATE Y, 19: PRINT CHR$(219)
END IF

' Scroll bar for Dirs/drives
IF TTT THEN
 LOCATE 12, 39: PRINT CHR$(24)
 FOR I = 13 TO 18
 LOCATE I, 39: PRINT ""
 NEXT
 LOCATE 19, 39: PRINT CHR$(25)
 Y = Interpolate(13, 18, DummyInteger(10), (DummyInteger(8) - 8))
 LOCATE Y, 39: PRINT CHR$(219)
END IF

' Highlights
IF (SBAR OR MLB1) AND DummyInteger(4) > 2 THEN
 SELECT CASE DummyInteger(6)
  CASE 1: InvertBox 20, 12, 20, 19
  CASE 2: InvertBox 20, 22, 20, 31
 END SELECT
END IF

END SUB

SUB File.Input

' Mouse ring
IF SMouseHeld THEN
 CH$ = ""
 C = MY - 13
 IF C < 0 THEN C = 0
 IF C > 5 THEN C = 5
 DummyInteger(4) = SMouseHeld
 IF SMouseHeld = 1 THEN
   YY = Interpolate(8, DummyInteger(1), C, 5) - 1
   DummyInteger(2) = 0
   DummyInteger(3) = 0
 END IF
 IF SMouseHeld = 2 THEN
   YY = Interpolate(8, DummyInteger(8), C, 5) - 1
   DummyInteger(9) = 0
   DummyInteger(10) = 0
 END IF
FileSubScroll YY
EXIT SUB
END IF

' Executing new action
IF DummyInteger(0) >= 2 OR CH$ = CHR$(27) THEN

 IF DummyInteger(4) = 4 OR CH$ = CHR$(27) THEN Anything = 0
 IF DummyInteger(0) = 3 THEN
 IF INSTR(DummyString(17), "*") THEN PEZ = 1
 IF INSTR(DummyString(17), "?") THEN PEZ = 1
 IF PEZ THEN
  DummyInteger(0) = 1
  GrabFiles DummyString(17)
  EXIT SUB
 END IF
 SELECT CASE AWindow
  CASE 8
   CAS.Load NoSpace$(DummyString(17))
   IF AWindow > 0 AND AWindow < 3 THEN GT = AWindow
  CASE 9
   IF LEN(DQBdir$(NoSpace$(DummyString(17)), 32)) THEN
    C = 1: AWindow = 5
   ELSE
    C = 0: CAS.Save NoSpace$(DummyString(17)): AWindow = 0
   END IF
  CASE 10
   IF DQBloadSound(ATrack, NoSpace$(DummyString(17))) THEN GT = 1
   IF GT = 0 THEN
    Samples(ATrack - 1) = NoSpace$(DummyString(17))
    Modified = 1
   END IF
 END SELECT
 END IF
 A$ = DummyString(17)
 CleanDummies
 IF AWindow <> 5 THEN AWindow = 0 ELSE DummyString(17) = A$
 IF GT THEN AWindow = GT
 EXIT SUB

END IF

' New action
IF DummyInteger(0) = 0 THEN
  DummyInteger(2) = 0: DummyInteger(3) = 0
  DummyInteger(9) = 0: DummyInteger(10) = 0
 DummyInteger(0) = 1
 IF AWindow < 10 THEN GrabFiles "*.CAS" ELSE GrabFiles "*.WAV"
 DummyString(17) = DummyString(17) + (SPACE$(32 - LEN(DummyString(17))))
 DummyInteger(7) = LEN(RTRIM$(DummyString(17)))
END IF

IF MY = 6 AND MX >= 6 AND MX <= 38 THEN Area = 1  ' Mouse on file name

IF MY >= 12 AND MY <= 19 THEN
 SELECT CASE MX
  CASE 5 TO 19: Area = 2  ' File field
  CASE 24 TO 39: Area = 3 ' Dir field
 END SELECT
END IF

IF MY = 21 THEN
 SELECT CASE MX
  CASE 13 TO 20: Area = 4
  CASE 23 TO 32: Area = 5
 END SELECT
END IF

' New Press
IF Area AND MLB1 = 1 THEN DummyInteger(4) = Area - 1: DummyInteger(5) = Area

' Highlight
IF MLB1 THEN
 IF Area > 0 AND DummyInteger(5) = Area THEN
 DummyInteger(6) = DummyInteger(4) - 2
 ELSE
 DummyInteger(6) = 0
 END IF
END IF

' Release
IF DummyInteger(5) AND MLB1 = -1 THEN
IF Area > 3 THEN DummyInteger(0) = Area - 1
END IF

' Space bar
IF SBAR AND DummyInteger(4) > 2 THEN DummyInteger(6) = DummyInteger(4) - 2
' File name cursor
IF MLB1 = 1 AND Area = 1 THEN DummyInteger(7) = MX - 6

IF (DummyInteger(4) = 1) OR (DummyInteger(4) = 2) THEN
 IF Area THEN
  IF DummyInteger(4) = 1 THEN C = 2: KK = 19 ELSE C = 9: KK = 39
  IF MLB1 THEN
   K = MY - 12
   L = DummyInteger(C) - DummyInteger(C + 1)
   IF K > L AND MX < KK THEN FileSubScroll K - L
   IF K < L AND MX < KK THEN FileSubScroll K - L
  END IF
 END IF
END IF

IF MLB1 = 1 AND DummyInteger(4) = 1 THEN
 IF MX = 19 AND MY > 12 AND MY < 19 THEN
  Y = Interpolate(13, 18, DummyInteger(3), (DummyInteger(1) - 8))
  IF MY < Y THEN FileSubScroll -8
  IF MY > Y THEN FileSubScroll 8
  IF MY = Y THEN SMouseHeld = 1
 END IF
END IF

IF MLB1 = 1 AND DummyInteger(4) = 2 THEN
 IF MX = 39 AND MY > 12 AND MY < 19 THEN
  Y = Interpolate(13, 18, DummyInteger(10), (DummyInteger(8) - 8))
  IF MY < Y THEN FileSubScroll -8
  IF MY > Y THEN FileSubScroll 8
  IF MY = Y THEN SMouseHeld = 2
 END IF
END IF

' Mouse press arrows
IF MLB2 = 1 THEN
 IF DummyInteger(1) > 8 AND DummyInteger(4) = 1 THEN
 IF MX = 19 THEN
  IF MY = 12 THEN FileSubScroll -1
  IF MY = 19 THEN FileSubScroll 1
 END IF
 END IF
 IF DummyInteger(8) > 8 AND DummyInteger(4) = 2 THEN
 IF MX = 39 THEN
  IF MY = 12 THEN FileSubScroll -1
  IF MY = 19 THEN FileSubScroll 1
 END IF
 END IF
END IF

' Switch to subdirectory :)
IF MDD THEN
 IF MX >= 5 AND MX <= 18 AND DummyInteger(4) = 1 THEN CH$ = CHR$(13)
 IF MX >= 24 AND MX <= 38 AND DummyInteger(4) = 2 THEN CH$ = CHR$(13)
END IF
IF DummyInteger(4) > 2 AND SBAR = -1 THEN CH$ = CHR$(13)

' Tab key
SELECT CASE UCASE$(CH$)
 CASE CHR$(9): DummyInteger(4) = (DummyInteger(4) + 1) MOD 5
 CASE CHR$(0) + CHR$(15): DummyInteger(4) = (DummyInteger(4) + 4) MOD 5
 CASE CHR$(13)
  IF DummyInteger(4) = 4 THEN DummyInteger(0) = 2
  IF DummyInteger(4) = 3 OR DummyInteger(4) < 2 THEN DummyInteger(0) = 3
  IF DummyInteger(4) = 2 THEN
   A$ = DirSub$(1, DummyInteger(9))
    IF INSTR(A$, "]") AND INSTR(A$, "[") THEN
    DQBsetDrive MID$(A$, 3, 1)
    ELSE
    IF DQBchDir(A$) THEN ErrorEND "Invalid file or path"
    END IF
   DummyInteger(0) = 0
  END IF
END SELECT

' Scroll keys
C = 0
IF DummyInteger(4) = 0 THEN InputString DummyString(17), DummyInteger(7), 32
IF DummyInteger(4) = 1 THEN C = 1
IF DummyInteger(4) = 2 THEN C = 8

IF C THEN
SELECT CASE UCASE$(CH$)
 CASE CHR$(0) + CHR$(71): FileSubScroll -16384
 CASE CHR$(0) + CHR$(72): FileSubScroll -1
 CASE CHR$(0) + CHR$(73): FileSubScroll -8
 CASE CHR$(0) + CHR$(79): FileSubScroll 16383
 CASE CHR$(0) + CHR$(80): FileSubScroll 1
 CASE CHR$(0) + CHR$(81): FileSubScroll 8
 CASE ELSE
  IF UCASE$(CH$) = LEFT$(DirSub$(C \ 8, DummyInteger(C + 1) + 1), 1) THEN FileSubScroll 1: EXIT SUB
  FOR I = 0 TO DummyInteger(C) - 1
   IF UCASE$(CH$) = LEFT$(DirSub$(C \ 8, I), 1) THEN
   IF TT = 0 THEN TT = 1: FileSubScroll I - DummyInteger(C + 1)
   END IF
  NEXT
END SELECT
END IF

END SUB

REM $DYNAMIC
SUB FilePROMPT.Disp

SELECT CASE AWindow
CASE 4: A$ = "Do you want to save?"
CASE 5: A$ = "The file already exists. Overwrite?"
CASE 6: A$ = "Do you want to play and test CXE?"
END SELECT

MakeBoxF 12, 19, 16, 65, 32, 0, 0
MakeBoxF 11, 17, 15, 63, 32, 15, 1
MakeBox 11, 17, 15, 63, 7, 1
CenterText 11, " " + A$ + " "
CenterText 14, "< YES >  < NO >  < CANCEL >"

' Active choice
SELECT CASE DummyInteger(0)
 CASE 0: PokeCol 14, 27, 15, 1: PokeCol 14, 33, 15, 1
 CASE 1: PokeCol 14, 36, 15, 1: PokeCol 14, 41, 15, 1
 CASE 2: PokeCol 14, 44, 15, 1: PokeCol 14, 53, 15, 1
END SELECT

' Active highlight
IF DummyInteger(2) OR SBAR THEN
 SELECT CASE DummyInteger(2)
  CASE 1: InvertBox 13, 26, 13, 32
  CASE 2: InvertBox 13, 35, 13, 40
  CASE 3: InvertBox 13, 43, 13, 52
 END SELECT
END IF

END SUB

REM $STATIC
SUB FilePROMPT.Input

' Mouse Area for YES, NO, and CANCEL button
IF MY = 14 AND MX >= 27 AND MX <= 33 THEN Area = 1
IF MY = 14 AND MX >= 36 AND MX <= 41 THEN Area = 2
IF MY = 14 AND MX >= 44 AND MX <= 53 THEN Area = 3

StdInp DummyInteger(0), 0, DummyInteger(3), Area

' Keypress
IF CH$ = CHR$(13) OR SBAR = -1 THEN
 DummyInteger(2) = DummyInteger(0) + 1
 DummyInteger(3) = 1
END IF
IF CH$ = CHR$(27) THEN DummyInteger(2) = 3: DummyInteger(3) = 1
IF CH$ = CHR$(9) THEN DummyInteger(0) = (DummyInteger(0) + 1) MOD 3
IF CH$ = CHR$(0) + CHR$(15) THEN DummyInteger(0) = (DummyInteger(0) + 2) MOD 3
IF UCASE$(CH$) = "Y" THEN DummyInteger(2) = 1: DummyInteger(3) = 1
IF UCASE$(CH$) = "N" THEN DummyInteger(2) = 2: DummyInteger(3) = 1

IF DummyInteger(3) THEN
SELECT CASE AWindow
 CASE 4
   SELECT CASE DummyInteger(2)
    CASE 1: AWindow = 9
    CASE 2: AWindow = 0
   END SELECT
 CASE 5
   SELECT CASE DummyInteger(2)
    CASE 1
      Program$ = DummyString(17)
      DummyString(17) = ""
      CAS.Save Program$
      AWindow = 0
    CASE 2
      AWindow = 9
    CASE 3
      DummyInteger(2) = 3
   END SELECT
 CASE 6
   IF DummyInteger(2) = 1 THEN CXE.Play LEFT$(Program$, INSTR(Program$, ".") - 1) + ".CXE"
   DummyInteger(2) = 3
END SELECT
IF DummyInteger(2) = 3 THEN Anything = 0: AWindow = 0
CleanDummies
END IF

END SUB

SUB FileSubScroll (IncDec)

' Use temp variables
IF DummyInteger(4) <> 1 THEN C = 7
Count = DummyInteger(C + 1)
High = DummyInteger(C + 2)
Temp = High
Cam = DummyInteger(C + 3)

' Reset positions
IF Count = 0 THEN
  DummyInteger(C + 2) = 0
  DummyInteger(C + 3) = 0
  EXIT SUB
END IF

' Correct any dead bottoms
IF Count - Cam < 8 AND Count > 7 THEN Cam = Count - 8

' Highlight move
C = High
C = C + IncDec
IF C < 0 THEN C = 0
IF C > Count - 1 THEN C = Count - 1
High = C

' Inc and Dec camera
C = High - Cam
IF C > 7 THEN Cam = Cam + (C - 7)
IF C < 0 THEN Cam = Cam + C

' Give back variables
IF DummyInteger(4) = 1 THEN C = 1 ELSE C = 8
 DummyInteger(C) = Count
 DummyInteger(C + 1) = High
 DummyInteger(C + 2) = Cam
 IF C = 1 THEN DummyString(17) = DirSub$(0, High)

' Play back sound effects
 IF Temp <> DummyInteger(2) AND DummyInteger(4) = 1 THEN
 IF AWindow = 10 THEN
  FOR I = 1 TO 32: DQBstopVoice I: NEXT
  DQBwait 1
  IF DQBloadSound(17, NoSpace$(DummyString(17))) = 0 THEN
   DQBwait 1
   DQBplaySound 17, 32, 22050, 0
  END IF
 END IF
 END IF


END SUB

REM $DYNAMIC
SUB FPS.Display

' Calculate FPS
T = T - (T < 32760)
IF G! < TIMER THEN G! = TIMER + 1: FPS = T: T = 0
IF ABS(G! - TIMER) > 2 THEN G! = 0

' Design Time string
COLOR 10, 0
GG& = INT(TIMER + .5)
H% = (GG& \ 3600) MOD 12
IF H% = 0 THEN H% = 12
M% = GG& \ 60 MOD 60
S% = GG& MOD 60
IF GG& >= 43200 THEN AP$ = " PM " ELSE AP$ = " AM "
OM$ = LTRIM$(STR$(M%))
OS$ = LTRIM$(STR$(S%))
IF M% < 10 THEN OM$ = "0" + OM$
IF S% < 10 THEN OS$ = "0" + OS$
TheTime$ = LTRIM$(STR$(H%)) + ":" + OM$ + ":" + OS$ + AP$

' Print Time, FPS, and everything else
LOCATE 1, 36: PRINT "FPS:" + STR$(FPS)
LOCATE 1, 56: PRINT TheTime$
LOCATE 3, 63: PRINT LTRIM$(STR$(TrackScr(ATrack, 1))) + "" + LTRIM$(STR$(TrackScr(ATrack, 2))) + "/" + LTRIM$(STR$(TrackLen(ATrack)))
COLOR 12: CenterText 2, " Description: " + Description$ + " "
COLOR 15, 1: CenterText 3, " Cyber Chick Music Editor v2 - " + Program$ + " "
IF ATrack THEN IF LEN(Samples(ATrack - 1)) THEN LOCATE 23, 65: PRINT " " + Samples(ATrack - 1) + " "
IF Ref$ = CHR$(255) THEN Ref$ = "Tab=Field  Arrow=Item  Enter=Execute  Esc=Cancel  Space=Toggle"
COLOR 14, 0
IF Ref$ = CHR$(254) THEN
 COLOR 12: IF FrameTile AND 8 THEN COLOR 15, 12
 M$ = " ۲ "
 Ref$ = M$ + "RECORDING IN PROGRESS" + M$
 LOCATE 25, 8 * SIN(FrameTile * (3.141593 / 32)) + 20: PRINT Ref$;
 ELSE
 CenterText 25, Ref$
END IF
COLOR 14, 6

' Auto-Repeat
IF MLooped THEN LOCATE 23, 3: PRINT " AUTO Repeat: ON  "
' Playing
IF CASPlaying THEN LOCATE 23, 23: PRINT " Play/Stop "

END SUB

SUB InvertBox (Row1, Col1, Row2, Col2)

DEF SEG = &HB900
 FOR Y = Row1 TO Row2
  FOR I = Col1 TO Col2
   Coor = (Y * 160) + (I * 2) + 1
   F = PEEK(Coor) \ 16
   B = PEEK(Coor)
   POKE Coor, B * 16 + F
  NEXT
 NEXT

END SUB

SUB MakeABox (R1, C1, R2, C2)

COLOR 1 + (((FrameTile AND 31) > 16) * -8), 0
LOCATE R1, C1: PRINT STRING$((C2 - C1) + 1, "")
LOCATE R2, C1: PRINT STRING$((C2 - C1) + 1, "")
FOR I = R1 TO R2
LOCATE I, C1: PRINT ""
LOCATE I, C2: PRINT ""
NEXT
LOCATE R1, C1: PRINT ""
LOCATE R2, C2: PRINT ""
LOCATE R1, C2: PRINT ""
LOCATE R2, C1: PRINT ""

END SUB

SUB MakeBox (R1, C1, R2, C2, F, B)

COLOR F, B
LOCATE R1, C1: PRINT STRING$((C2 - C1) + 1, "")
LOCATE R2, C1: PRINT STRING$((C2 - C1) + 1, "")
FOR I = R1 TO R2
LOCATE I, C1: PRINT ""
LOCATE I, C2: PRINT ""
NEXT
LOCATE R1, C1: PRINT ""
LOCATE R2, C2: PRINT ""
LOCATE R1, C2: PRINT ""
LOCATE R2, C1: PRINT ""

END SUB

REM $STATIC
SUB MakeBox2 (R1, C1, R2, C2, F, B)

COLOR F, B
LOCATE R1, C1: PRINT STRING$((C2 - C1) + 1, "")
LOCATE R2, C1: PRINT STRING$((C2 - C1) + 1, "")
FOR I = R1 TO R2
LOCATE I, C1: PRINT ""
LOCATE I, C2: PRINT ""
NEXT
LOCATE R1, C1: PRINT ""
LOCATE R2, C2: PRINT ""
LOCATE R1, C2: PRINT ""
LOCATE R2, C1: PRINT ""

END SUB

REM $DYNAMIC
SUB MakeBoxF (Row1, Col1, Row2, Col2, ASCii, ForCol, BackCol)

COLOR ForCol, BackCol
FOR I = Row1 TO Row2
LOCATE I, Col1: PRINT STRING$(Col2 - Col1 + 1, ASCii);
NEXT

END SUB

FUNCTION Notation$ (Note)

 SELECT CASE Note MOD 12
  CASE 0: A$ = "C"
  CASE 1: A$ = "C#"
  CASE 2: A$ = "D"
  CASE 3: A$ = "D#"
  CASE 4: A$ = "E"
  CASE 5: A$ = "F"
  CASE 6: A$ = "F#"
  CASE 7: A$ = "G"
  CASE 8: A$ = "G#"
  CASE 9: A$ = "A"
  CASE 10: A$ = "A#"
  CASE 11: A$ = "B"
 END SELECT

Notation$ = A$ + LTRIM$(STR$(Note \ 12))

END FUNCTION

REM $STATIC
SUB PasteWindowDisp

IF AWindow = 0 THEN EXIT SUB

' Basic outline
Ref$ = CHR$(255)
MakeBoxF 5, 25, 23, 55, 32, 0, 0
MakeBoxF 4, 23, 22, 53, 32, 1, 1
MakeBox 4, 23, 22, 53, 9, 1
LOCATE 4, 34: PRINT ""
LOCATE 4, 42: PRINT ""

' Line between track and buttons
FOR I = 7 TO 21
LOCATE I, 41: PRINT CHR$(179)
NEXT
LOCATE 6, 41: PRINT CHR$(218)
LOCATE 22, 41: PRINT CHR$(207)
LOCATE 8, 23: PRINT CHR$(199)
LOCATE 11, 23: PRINT CHR$(199)
LOCATE 16, 23: PRINT CHR$(199)

FOR I = 24 TO 39
LOCATE 8, I: PRINT CHR$(196)
LOCATE 11, I: PRINT CHR$(196)
LOCATE 16, I: PRINT CHR$(196)
NEXT

' Track list
COLOR 7, 1
 LOCATE 4, 35: PRINT " PASTE "
 LOCATE 5, 34: PRINT "Destination Track:"
 LOCATE 7, 24: PRINT " Select Timing:"
 LOCATE 9, 25: PRINT "( ) Keep copied"
 LOCATE 10, 25: PRINT "    starting"
 LOCATE 12, 25: PRINT "( ) Change the"
 LOCATE 13, 25: PRINT "    starting:"
COLOR 1, 7
 IF DummyInteger(6) THEN
 LOCATE 12, 26
 ELSE
 LOCATE 9, 26
 END IF
 PRINT CHR$(8)

IF DummyInteger(6) THEN
 COLOR 10, 0
 LOCATE DummyInteger(9), DummyInteger(8): PRINT DummyString(0)
  IF (FrameTile AND 16) AND DummyInteger(0) = 1 THEN
   PokeCol DummyInteger(9), DummyInteger(8) + DummyInteger(3), 15, 9
 END IF
END IF

COLOR 7, 1
FOR I = 0 TO 8
LOCATE I + 6, 50: PRINT "0" + LTRIM$(STR$(I + 1)) + " "
NEXT
FOR I = 0 TO 6
LOCATE I + 15, 49: PRINT I + 10
NEXT
FOR I = 0 TO 15
LOCATE I + 6, 42: PRINT " MTRACK "
NEXT

LOCATE 18, 29: PRINT "<  OK  >"
LOCATE 20, 28: PRINT "< CANCEL >"

COLOR 15
SELECT CASE DummyInteger(0)
CASE 0
 FOR I = 0 TO 9
  PokeCol 6 + I, 51, 15, 1
 NEXT
 FOR I = 0 TO 5
  PokeCol 16 + I, 43 + I, 15, 1
 NEXT
CASE 1
  PokeCol 9, 29, 15, 1
  PokeCol 12, 29, 15, 1
CASE 2
  PokeCol 18, 29, 15, 1
  PokeCol 18, 36, 15, 1
CASE 3
  PokeCol 20, 28, 15, 1
  PokeCol 20, 37, 15, 1
END SELECT

PokeBCol DummyInteger(7) + 6, 42, 9, 10

' Active highlight
IF SBAR OR MLB1 THEN
 SELECT CASE DummyInteger(2)
  CASE 3: InvertBox 17, 28, 17, 35
  CASE 4: InvertBox 19, 27, 19, 36
 END SELECT
END IF

END SUB

SUB PasteWindowInp

' Start
IF DummyInteger(4) = 0 THEN
 DummyInteger(4) = 1
 DummyInteger(7) = ATrack - 1
 IF TrackLen(ATrack) THEN Tks& = TTE&(ATrack, TrackLen(ATrack) - 1)
 DummyString(0) = TickStr$(Tks&)
 X = 29: DummyInteger(8) = X
 Y = 15: DummyInteger(9) = Y
 InpTime DummyString(0), DummyInteger(3), X, Y
 CH$ = ""
END IF

' END
IF DummyInteger(4) = 2 THEN
 AWindow = 0
 IF DummyInteger(0) <= 2 THEN CAS.Paste DummyInteger(7) + 1
 CleanDummies
END IF

' Mouse Area for YES, NO, and CANCEL button
IF MY >= 6 AND MY <= 21 AND MX >= 42 AND MX <= 52 THEN Area = 1
IF MY >= 9 AND MY <= 15 AND MX >= 24 AND MX <= 40 THEN Area = 2
IF MY = 18 AND MX >= 29 AND MX <= 36 THEN Area = 3
IF MY = 20 AND MX >= 28 AND MX <= 37 THEN Area = 4

IF Area = 1 AND MLB1 > 0 THEN DummyInteger(7) = MY - 6
IF Area = 2 AND MLB1 = 1 THEN IF MY < 12 THEN DummyInteger(6) = 0 ELSE DummyInteger(6) = 1

StdInp DummyInteger(0), 4, DummyInteger(4), Area

' Track field
IF DummyInteger(0) = 0 THEN
 SELECT CASE UCASE$(CH$)
  CASE CHR$(0) + CHR$(71): DummyInteger(7) = 0
  CASE CHR$(0) + CHR$(72): DummyInteger(7) = DummyInteger(7) + (DummyInteger(7) > 0)
  CASE CHR$(0) + CHR$(73)
    DummyInteger(7) = DummyInteger(7) - 4
    IF DummyInteger(7) < 0 THEN DummyInteger(7) = 0
  CASE CHR$(0) + CHR$(79): DummyInteger(7) = 15
  CASE CHR$(0) + CHR$(80): DummyInteger(7) = DummyInteger(7) - (DummyInteger(7) < 15)
  CASE CHR$(0) + CHR$(81)
    DummyInteger(7) = DummyInteger(7) + 4
    IF DummyInteger(7) > 15 THEN DummyInteger(7) = 15
  CASE "0": DummyInteger(7) = 9
  CASE "1" TO "9": DummyInteger(7) = VAL(CH$) - 1
  CASE "M": DummyInteger(7) = 10
  CASE "T": DummyInteger(7) = 11
  CASE "R": DummyInteger(7) = 12
  CASE "A": DummyInteger(7) = 13
  CASE "C": DummyInteger(7) = 14
  CASE "K": DummyInteger(7) = 15
 END SELECT
END IF

' Track field
IF DummyInteger(0) = 1 THEN
 SELECT CASE UCASE$(CH$)
  CASE CHR$(0) + CHR$(72), CHR$(0) + CHR$(80)
   DummyInteger(6) = DummyInteger(6) XOR 1
  CASE "K": DummyInteger(6) = 0
  CASE "C": DummyInteger(6) = 1
 END SELECT
 IF DummyInteger(6) THEN InpTime DummyString(0), DummyInteger(3), DummyInteger(8), DummyInteger(9)
END IF

IF SBAR = -1 AND DummyInteger(0) > 1 THEN CH$ = CHR$(13)
SELECT CASE UCASE$(CH$)
 CASE CHR$(13): DummyInteger(4) = 2
 CASE CHR$(9): DummyInteger(0) = (DummyInteger(0) + 1) AND 3
 CASE CHR$(0) + CHR$(15): DummyInteger(0) = (DummyInteger(0) - 1) AND 3
 CASE CHR$(27): DummyInteger(4) = 2: DummyInteger(0) = 3
END SELECT

END SUB

REM $DYNAMIC
SUB PokeBCol (Row, Colm, BG, Length)

DEF SEG = &HB900
FOR I = 0 TO Length
Coor = ((Row - 1) * 160) + ((Colm - 1) * 2) + 1 + (I * 2)
FG = PEEK(Coor) AND 15
POKE Coor, BG * 16 + FG
NEXT

END SUB

SUB PokeCol (Row, Colm, FG, BG)

DEF SEG = &HB900
POKE ((Row - 1) * 160) + ((Colm - 1) * 2) + 1, BG * 16 + FG

END SUB

SUB PrintEvent (Trk, Eve, Row, Col)

JX = (Eve * 8&) MOD 320
JY = (Eve \ 40)
Byte4 = DQBpoint(Trk + 1, JX + 3, JY)
Byte5 = DQBpoint(Trk + 1, JX + 4, JY)
Byte6 = DQBpoint(Trk + 1, JX + 5, JY)
Byte7 = DQBpoint(Trk + 1, JX + 6, JY)
Byte8 = DQBpoint(Trk + 1, JX + 7, JY)
IF Byte4 = 0 THEN EXIT SUB

' Get blue time
COLOR 9, 0
LOCATE Row, Col + 3
PRINT TickStr$(TTE&(Trk, Eve))

' Make event command green and give position for it
COLOR 12
LOCATE Row, Col + 13

IF Trk THEN
 SELECT CASE Byte4
  CASE 1
    PRINT "PLAY"
    COLOR 10
     A$ = Notation$(Byte7)
    LOCATE Row, Col + 18
    PRINT A$
    LOCATE Row, Col + 21: PRINT ","
    LOCATE Row, Col + 23: PRINT Samples(Byte5)
    LOCATE Row, Col + 35: PRINT ","
    LOCATE Row, Col + 36: PRINT STR$(Byte6 + 1)
    LOCATE Row, Col + 39: PRINT ","
    LOCATE Row, Col + 41
     IF Byte8 THEN
      PRINT CHR$(18)
     ELSE
      PRINT CHR$(26)
     END IF
  CASE 2
    PRINT "SET VOLUME Channel #"
    LOCATE Row, Col + 36: PRINT "to"
    COLOR 10
    LOCATE Row, Col + 33: PRINT LTRIM$(STR$(Byte5 + 1))
    LOCATE Row, Col + 38: PRINT Byte6
  CASE 3
    PRINT "STOP Channel #"
    COLOR 10
    LOCATE Row, Col + 27: PRINT LTRIM$(STR$(Byte5 + 1))
  CASE 4
    PRINT "PITCH BEN Channel #"
    COLOR 10
    LOCATE Row, Col + 34: PRINT ","
    LOCATE Row, Col + 32: PRINT LTRIM$(STR$(Byte5 + 1))
    LOCATE Row, Col + 35: PRINT Byte6 + (Byte7 * 256&)
 END SELECT
ELSE
 SELECT CASE Byte4
  CASE 1: PRINT "Stop MUSIC"
  CASE 2: PRINT "Stop Voices"
  CASE 3: PRINT "Repeat MUSIC"
  CASE 4: PRINT "INC LoopVal"
  CASE 5: PRINT "DEC LoopVal"
  CASE 6 TO 8
      IF Byte4 = 6 THEN A$ = "MOV"
      IF Byte4 = 7 THEN A$ = "ADD"
      IF Byte4 = 8 THEN A$ = "SUB"
      PRINT A$ + " LoopVal,"
       COLOR 10
       LOCATE Row, Col + 25
       PRINT Byte5
     CASE 9
      PRINT "Set All Volume to:"
       COLOR 10
       LOCATE Row, Col + 31
       PRINT Byte5
     CASE 10
      PRINT "GOTO Measure:"
       COLOR 10
       LOCATE Row, Col + 26
       PRINT Byte5
     CASE 11 TO 13
      IF Byte4 = 11 THEN A$ = "<"
      IF Byte4 = 12 THEN A$ = ">"
      IF Byte4 = 13 THEN A$ = "="
      PRINT "LoopV " + A$ + "     GOTO Meas: "
       COLOR 10
       LOCATE Row, Col + 20: PRINT Byte5
       LOCATE Row, Col + 35: PRINT Byte6
     CASE 14
      PRINT "Ĵ Measure #"
      LOCATE Row, Col + 37: PRINT ""
       COLOR 10
       LOCATE Row, Col + 32: PRINT Byte5
 END SELECT
END IF

END SUB

REM $STATIC
SUB PutByte4 (Track, Event, Byte)

JX = (Event * 8&) MOD 320
JY = (Event \ 40)
DQBpset Track + 1, JX + 3, JY, Byte

END SUB

SUB PutByte5 (Track, Event, Byte)

JX = (Event * 8&) MOD 320
JY = (Event \ 40)
DQBpset Track + 1, JX + 4, JY, Byte

END SUB

SUB PutByte6 (Track, Event, Byte)

JX = (Event * 8&) MOD 320
JY = (Event \ 40)
DQBpset Track + 1, JX + 5, JY, Byte

END SUB

SUB PutByte7 (Track, Event, Byte)

JX = (Event * 8&) MOD 320
JY = (Event \ 40)
DQBpset Track + 1, JX + 6, JY, Byte

END SUB

SUB PutByte8 (Track, Event, Byte)

JX = (Event * 8&) MOD 320
JY = (Event \ 40)
DQBpset Track + 1, JX + 7, JY, Byte

END SUB

REM $DYNAMIC
SUB ShowMouseCursor

FrameTile = (FrameTile + 1) AND 255

COLOR 15, 0
LOCATE MY, MX
 SELECT CASE (FrameTile \ 2) AND 7
  CASE 0, 7: PRINT "";
  CASE 1, 6: PRINT "";
  CASE 2, 5: PRINT "";
  CASE 3, 4: PRINT "";
 END SELECT

END SUB

SUB StartRef

IF CASPlaying THEN
 SELECT CASE (FrameTile \ 7) AND 3
  CASE 0: A$ = ""
  CASE 1: A$ = "\"
  CASE 2: A$ = "I"
  CASE 3: A$ = "/"
 END SELECT
   Ref$ = "PLAYING... " + A$ + SPACE$(6) + "<F5=Stop music>"
  ELSE
   Ref$ = "<Alt=Activate menu> <F5=Play music>"
END IF

END SUB

