'$DYNAMIC
'$INCLUDE: 'DIRECTQB.BI'
'$INCLUDE: 'CCMUSIC.BI'

REM $STATIC
SUB DescWindowDisp

' Basic
Ref$ = CHR$(255)
MakeBoxF 11, 19, 16, 65, 32, 0, 0
MakeBoxF 11, 17, 15, 63, 32, 7, 5
MakeBox 10, 17, 15, 63, 7, 5
MakeBox2 11, 18, 13, 62, 7, 5
CenterText 10, " " + "Describe your music" + " "
CenterText 14, "<  OK  >  < CANCEL >"

' Description
COLOR 10, 5
LOCATE 12, 20
PRINT DummyString(1)

' Active choice
SELECT CASE DummyInteger(0)
 CASE 0: IF (FrameTile AND 16) THEN PokeCol 12, 20 + DummyInteger(3), 15, 9 + (INS * 3)
 CASE 1: PokeCol 14, 30, 14, 13: PokeCol 14, 37, 14, 13
 CASE 2: PokeCol 14, 40, 14, 13: PokeCol 14, 49, 14, 13
END SELECT

' Active highlight
IF SBAR OR MLB1 THEN
 SELECT CASE DummyInteger(2)
  CASE 2: InvertBox 13, 29, 13, 36
  CASE 3: InvertBox 13, 39, 13, 48
 END SELECT
END IF

END SUB

SUB DescWindowInput

' Start
IF DummyInteger(4) = 0 THEN
 DummyInteger(4) = 1
 DummyString(1) = Description$
 DummyString(1) = DummyString(1) + SPACE$(40 - LEN(Description$))
 DummyInteger(3) = LEN(RTRIM$(DummyString(1)))
END IF

' Mouse Area for YES, NO, and CANCEL button
IF MY = 12 AND MX >= 20 AND MX <= 60 THEN Area = 1
IF MY = 14 AND MX >= 30 AND MX <= 37 THEN Area = 2
IF MY = 14 AND MX >= 40 AND MX <= 49 THEN Area = 3

' Mouse position on Description
IF Area = 1 AND MLB1 > 0 THEN DummyInteger(3) = MX - 20

StdInp DummyInteger(0), 3, DummyInteger(5), Area

' Keypress
IF ((SBAR = -1 AND DummyInteger(2) > 1)) THEN DummyInteger(2) = DummyInteger(0) + 1: DummyInteger(5) = 1
IF CH$ = CHR$(13) THEN
 IF DummyInteger(0) = 0 THEN DummyInteger(0) = 1
 DummyInteger(5) = 1
END IF
IF CH$ = CHR$(27) THEN DummyInteger(2) = 3: DummyInteger(5) = 1
IF CH$ = CHR$(9) THEN DummyInteger(0) = (DummyInteger(0) + 1) MOD 3
IF CH$ = CHR$(0) + CHR$(15) THEN DummyInteger(0) = (DummyInteger(0) + 2) MOD 3

' Desc input
IF DummyInteger(0) = 0 THEN InputString DummyString(1), DummyInteger(3), 40

IF DummyInteger(5) THEN
AWindow = 0
IF DummyInteger(0) = 1 THEN Description$ = RTRIM$(DummyString(1)): Modified = 1
CleanDummies
END IF

END SUB

SUB MPWindowDisp

IF AWindow = 0 THEN EXIT SUB

' Basic outline
Ref$ = CHR$(255)
MakeBoxF 8, 25, 14, 55, 32, 0, 0
MakeBoxF 7, 23, 13, 53, 32, 1, 1
MakeBox 7, 23, 13, 53, 9, 1
LOCATE 7, 30: PRINT ""
LOCATE 7, 45: PRINT ""

' Track list
COLOR 7, 1
LOCATE 7, 31: PRINT " MASTER PASTE "
LOCATE 9, 24: PRINT " Start Timing:"

' Cursor Time
COLOR 10, 0
LOCATE 9, 40: PRINT DummyString(0)
 IF (FrameTile AND 16) AND DummyInteger(0) = 0 THEN
 PokeCol 9, 40 + DummyInteger(4), 15, 9
END IF

' Buttons
COLOR 7, 1
LOCATE 11, 28: PRINT "<  OK  >"
LOCATE 11, 38: PRINT "< CANCEL >"

' Highlights
SELECT CASE DummyInteger(0)
 CASE 1: PokeCol 11, 28, 15, 1: PokeCol 11, 35, 15, 1
 CASE 2: PokeCol 11, 38, 15, 1: PokeCol 11, 47, 15, 1
END SELECT

' Active highlight
SELECT CASE DummyInteger(2)
 CASE 2: InvertBox 10, 27, 10, 34
 CASE 3: InvertBox 10, 37, 10, 46
END SELECT

END SUB

SUB MPWindowInp

' END
IF DummyInteger(3) = 2 THEN
 AWindow = 0
 DummyInteger(6) = 1
 IF DummyInteger(0) < 2 THEN CAS.Paste 0
 CleanDummies
 EXIT SUB
END IF

' START
IF DummyInteger(3) = 0 THEN
 DummyInteger(3) = 1
 IF TrackLen(0) THEN Tks& = TTE&(ATrack, TrackLen(0) - 1)
 DummyString(0) = TickStr$(Tks&)
 InpTime DummyString(0), DummyInteger(4), 12, 40
 CH$ = ""
END IF

' Mouse areas
IF MY = 9 AND MX >= 40 AND MX <= 48 THEN Area = 1
IF MY = 11 AND MX >= 28 AND MX <= 35 THEN Area = 2
IF MY = 11 AND MX >= 38 AND MX <= 47 THEN Area = 3
StdInp DummyInteger(0), 3, DummyInteger(3), Area

' Input time
IF DummyInteger(0) = 0 THEN InpTime DummyString(0), DummyInteger(4), 40, 9

' KEYS OK CANCEL
IF SBAR = -1 AND DummyInteger(0) > 0 THEN DummyInteger(3) = 2
SELECT CASE UCASE$(CH$)
 CASE CHR$(13): DummyInteger(3) = 2
 CASE CHR$(27): DummyInteger(3) = 2: DummyInteger(0) = 2
 CASE CHR$(9): DummyInteger(0) = (DummyInteger(0) + 1) MOD 3
 CASE CHR$(0) + CHR$(15): DummyInteger(0) = (DummyInteger(0) + 2) MOD 3
END SELECT

END SUB

SUB MTransDisp

' Basic
Ref$ = CHR$(255)
MakeBoxF 11, 25, 18, 59, 32, 0, 0
MakeBoxF 10, 23, 17, 57, 32, 7, 1
MakeBox 10, 23, 17, 57, 7, 1
LOCATE 12, 32: PRINT "New Time:"
LOCATE , 33: PRINT "Index A:"
LOCATE , 33: PRINT "Index B:"
CenterText 10, " " + "MEASURE TIME TRANSPOSE" + " "
CenterText 16, "<  OK  >  < CANCEL >"

' Text input
COLOR 10, 0
FOR I = 0 TO 2
LOCATE 12 + I, 42: PRINT DummyString(I)
NEXT

' Show highlights
I = FrameTile AND 16
SELECT CASE DummyInteger(0)
 CASE 0: IF I THEN PokeCol 12, 42 + DummyInteger(4), 15, 9
 CASE 1: IF I THEN PokeCol 13, 42 + DummyInteger(5), 15, 9
 CASE 2: IF I THEN PokeCol 14, 42 + DummyInteger(6), 15, 9
 CASE 3: PokeCol 16, 30, 15, 1: PokeCol 16, 37, 15, 1
 CASE 4: PokeCol 16, 40, 15, 1: PokeCol 16, 49, 15, 1
END SELECT

' Active highlight
IF SBAR OR MLB1 THEN
 SELECT CASE DummyInteger(2)
  CASE 4: InvertBox 15, 29, 15, 36
  CASE 5: InvertBox 15, 39, 15, 48
 END SELECT
END IF

END SUB

SUB MTransInp

' Start
IF DummyInteger(3) = 0 THEN
 DummyInteger(3) = 1
 A = TrackScr(ATrack, 1)
 B = TrackScr(ATrack, 2)
 IF A > B THEN SWAP A, B
 DummyString(0) = TickStr$(TTE&(ATrack, A))
 DummyString(1) = LTRIM$(STR$(A))
 DummyString(2) = LTRIM$(STR$(B))
 InpTime DummyString(0), 0, 42, 18
 InpNumbers DummyString(1), 0, 4, 0, 8000
 InpNumbers DummyString(2), 0, 4, 0, 8000
END IF

' End
IF DummyInteger(3) = 2 THEN

 I = TrackLen(ATrack)
 IF I AND DummyInteger(0) = 3 THEN
  Undo = ATrack + 1
  DQBcopyLayer Undo, 19
  UndoTL = I
  Modified = 1
  EveA = VAL(DummyString(1))
  EveB = VAL(DummyString(2))
  IF EveA > EveB THEN SWAP EveA, EveB
   PP = 1
   Numb1& = Str2Tim&(DummyString(0))
   FOR I = EveA TO EveB
    JX1 = (I * 8&) MOD 320
    JY1 = I \ 40
    Numb2& = DQBpoint(ATrack + 1, JX1, JY1)
    Numb2& = Numb2& + (DQBpoint(ATrack + 1, JX1 + 1, JY1) * 256&)
    Numb2& = Numb2& + (DQBpoint(ATrack + 1, JX1 + 2, JY1) * 65536)
    IF PP THEN PP = 0: Numb3& = Numb2&
    Numb2& = (Numb2& - Numb3&) + Numb1&
    L& = (65535 * TickSig) + (TickSig - 1)
    IF Numb2& > L& THEN Numb2& = L&
    DQBpset ATrack + 1, JX1, JY1, Numb2& AND 255
    DQBpset ATrack + 1, JX1 + 1, JY1, (Numb2& \ 256) AND 255
    DQBpset ATrack + 1, JX1 + 2, JY1, (Numb2& \ 65536)
   NEXT
   CAS.Sort.Track ATrack
 END IF
 AWindow = 0
 CleanDummies
 EXIT SUB
END IF

' Mouse areas
IF MX >= 42 THEN
 IF MY = 12 AND MX <= 50 THEN Area = 1
 IF MX <= 46 THEN
  IF MY = 13 THEN Area = 2
  IF MY = 14 THEN Area = 3
 END IF
END IF
IF MY = 16 THEN
 SELECT CASE MX
 CASE 30 TO 37: Area = 4
 CASE 40 TO 49: Area = 5
END SELECT
END IF

IF Area > 1 AND Area < 4 AND MLB1 = 1 THEN
  DummyInteger(Area + 3) = MX - 42
END IF
StdInp DummyInteger(0), 5, DummyInteger(3), Area

C& = TrackLen(ATrack)
SELECT CASE DummyInteger(0)
 CASE 0: InpTime DummyString(0), DummyInteger(4), 42, 12
 CASE 1: InpNumbers DummyString(1), DummyInteger(5), 4, 0, C&
 CASE 2: InpNumbers DummyString(2), DummyInteger(6), 4, 0, C&
END SELECT

' General keys
IF SBAR = -1 AND DummyInteger(0) >= 3 THEN CH$ = CHR$(13)
SELECT CASE CH$
 CASE CHR$(13): DummyInteger(3) = 2
 CASE CHR$(27): DummyInteger(3) = 2: DummyInteger(0) = 4
 CASE CHR$(9), CHR$(0) + CHR$(80): DummyInteger(0) = (DummyInteger(0) + 1) MOD 5
 CASE CHR$(0) + CHR$(15), CHR$(0) + CHR$(72): DummyInteger(0) = (DummyInteger(0) + 4) MOD 5
END SELECT

END SUB

SUB MusicKeyboard

' Keyboard area
IF MX >= 23 AND MX <= 53 AND MY >= 7 AND MY <= 10 THEN Area = 1

' MUSIC Keyboard
SELECT CASE Scan
 CASE 16 TO 25: LK = Scan - 15
 CASE 43: LK = 11
 CASE 30 TO 40: LK = Scan - 18
 CASE 44 TO 52: LK = Scan - 21
 CASE ELSE: LK = 0
END SELECT
IF LK THEN
 DummyInteger(10) = DummyInteger(10) - (DummyInteger(10) < 2)
 IF DummyInteger(11) <> Scan AND LK > 0 THEN DummyInteger(10) = 1
ELSE
 IF DummyInteger(9) AND DummyInteger(10) <> 0 THEN
  IF AWindow = 18 THEN FitEvent Ticks&, C, 3, VAL(DummyString(2)) - 1, 0, 0, 0
  DQBstopVoice 16 + VAL(DummyString(2))
 END IF
 DummyInteger(10) = 0
END IF

' Play sample with MUSIC keyboard
IF DummyInteger(10) = 1 THEN
 IF LK THEN
   IF AWindow = 18 THEN
    C = VAL(DummyString(1))
    L = TrackLen(C)
    FitEvent Ticks&, C, 1, VAL(DummyString(0)) - 1, VAL(DummyString(2)) - 1, LK - 1, DummyInteger(6)
    ScrollField ATrack, 16383
   END IF
   DQBplaySound VAL(DummyString(0)), 16 + VAL(DummyString(2)), Pitch(LK - 1), DummyInteger(6)
   Anything = LK
 END IF
END IF
DummyInteger(11) = Scan

' Play sample with mouse
IF MLB1 AND Area = 1 THEN
 IF MLB1 = 1 THEN DummyInteger(8) = 0
 IF DummyInteger(8) <> MX THEN
  IF AWindow = 18 THEN
    C = VAL(DummyString(1))
    FitEvent Ticks&, C, 1, VAL(DummyString(0)) - 1, VAL(DummyString(2)) - 1, MX - 23, DummyInteger(6)
    ScrollField ATrack, 16383
  END IF
  DQBplaySound VAL(DummyString(0)), 16 + VAL(DummyString(2)), Pitch(MX - 23), DummyInteger(6)
  Anything = MX - 22
 END IF
END IF
IF DummyInteger(9) AND MLB1 = -1 THEN
 IF AWindow = 18 THEN
   C = VAL(DummyString(1))
   FitEvent Ticks&, C, 3, VAL(DummyString(2)) - 1, 0, 0, 0
   ScrollField ATrack, 16383
 END IF
 DQBstopVoice 16 + VAL(DummyString(2))
END IF
DummyInteger(8) = MX

END SUB

SUB NTransDisp

' Basic
Ref$ = CHR$(255)
MakeBoxF 10, 30, 19, 54, 32, 0, 0
MakeBoxF 9, 28, 18, 52, 32, 7, 1
MakeBox 9, 28, 18, 52, 7, 1
LOCATE 11, 30: PRINT "Note range:"
LOCATE , 33: PRINT "Index A:"
LOCATE , 33: PRINT "Index B:"
LOCATE , 35: PRINT "Track:"
LOCATE , 30: PRINT "Step down trans: [ ]"
CenterText 9, " " + "NOTATION TRANSPOSE" + " "
CenterText 17, "<  OK  >  < CANCEL >"

COLOR 10, 0
FOR I = 0 TO 3
LOCATE 11 + I, 42: PRINT DummyString(I)
NEXT
IF DummyInteger(8) THEN LOCATE 15, 48: PRINT "X"

C = FrameTile AND 16
SELECT CASE DummyInteger(0)
CASE 0: IF C THEN PokeCol 11, 42 + DummyInteger(4), 15, 9
CASE 1: IF C THEN PokeCol 12, 42 + DummyInteger(5), 15, 9
CASE 2: IF C THEN PokeCol 13, 42 + DummyInteger(6), 15, 9
CASE 3: IF C THEN PokeCol 14, 42 + DummyInteger(7), 15, 9
CASE 4: PokeCol 15, 47, 15, 1: PokeCol 15, 49, 15, 1
CASE 5: PokeCol 17, 30, 15, 1: PokeCol 17, 37, 15, 1
CASE 6: PokeCol 17, 40, 15, 1: PokeCol 17, 49, 15, 1
END SELECT

' Active highlight
IF SBAR OR MLB1 THEN
 SELECT CASE DummyInteger(2)
  CASE 6: InvertBox 16, 29, 16, 36
  CASE 7: InvertBox 16, 39, 16, 48
 END SELECT
END IF

END SUB

SUB NTransInp

' Start
IF DummyInteger(3) = 0 THEN
 DummyInteger(3) = 1
 DummyString(1) = LTRIM$(STR$(TrackScr(ATrack, 1)))
 DummyString(2) = LTRIM$(STR$(TrackScr(ATrack, 2)))
  InpNumbers DummyString(0), 0, 2, 0, 24
  InpNumbers DummyString(1), 0, 4, 0, 8000
  InpNumbers DummyString(2), 0, 4, 0, 8000
  IF ATrack THEN DummyString(3) = LTRIM$(STR$(ATrack)) ELSE DummyString(3) = "1"
 InpNumbers DummyString(3), 0, 2, 1, 16
END IF

' End
IF DummyInteger(3) = 2 THEN
 IF DummyInteger(0) = 5 THEN
  C = VAL(DummyString(0))
  IF DummyInteger(8) THEN C = -C
  CAS.Trans.Note VAL(DummyString(3)), C, VAL(DummyString(1)), VAL(DummyString(2))
 END IF
 AWindow = 0
 CleanDummies
 EXIT SUB
END IF

' Mouse areas
IF MX >= 42 THEN
 IF MY = 11 AND MX <= 44 THEN Area = 1
 IF MY = 12 AND MX <= 46 THEN Area = 2
 IF MY = 13 AND MX <= 46 THEN Area = 3
 IF MY = 14 AND MX <= 44 THEN Area = 4
END IF
IF MY = 15 THEN Area = 5
IF MY = 17 THEN
 IF MX >= 30 AND MX <= 37 THEN Area = 6
 IF MX >= 40 AND MX <= 49 THEN Area = 7
END IF

IF Area < 5 AND MLB1 = 1 AND Area > 0 THEN
 DummyInteger(Area + 3) = MX - 42
END IF
StdInp DummyInteger(0), 7, DummyInteger(3), Area

IF DummyInteger(0) = 4 THEN
IF MLB1 = -1 AND MX >= 47 AND MX <= 49 THEN DummyInteger(8) = DummyInteger(8) XOR 1
IF SBAR = -1 THEN DummyInteger(8) = DummyInteger(8) XOR 1
END IF


C& = TrackLen(VAL(DummyString(3)))
SELECT CASE DummyInteger(0)
 CASE 0: InpNumbers DummyString(0), DummyInteger(4), 2, 0, 24
 CASE 1: InpNumbers DummyString(1), DummyInteger(5), 4, 0, C&
 CASE 2: InpNumbers DummyString(2), DummyInteger(6), 4, 0, C&
 CASE 3: InpNumbers DummyString(3), DummyInteger(7), 2, 1, 16
END SELECT

' General keys
IF SBAR = -1 AND DummyInteger(0) >= 5 THEN CH$ = CHR$(13)
SELECT CASE CH$
 CASE CHR$(13): DummyInteger(3) = 2
 CASE CHR$(27): DummyInteger(3) = 2: DummyInteger(0) = 6
 CASE CHR$(9), CHR$(0) + CHR$(80): DummyInteger(0) = (DummyInteger(0) + 1) MOD 7
 CASE CHR$(0) + CHR$(15), CHR$(0) + CHR$(72): DummyInteger(0) = (DummyInteger(0) + 6) MOD 7
END SELECT

END SUB

SUB QuantizeDisp

' Basic
Ref$ = CHR$(255)
MakeBoxF 7, 30, 22, 54, 32, 0, 0
MakeBoxF 7, 28, 21, 52, 32, 7, 1
MakeBox 6, 28, 21, 52, 7, 1
LOCATE 16, 29: PRINT STRING$(23, "-")
LOCATE 17, 35: PRINT "Index A:"
LOCATE 18, 35: PRINT "Index B:"
CenterText 6, " " + "QUANTIZE EVENTS" + " "
CenterText 20, "<  OK  >  < CANCEL >"

C = 1
IF DummyInteger(0) = 0 THEN COLOR 15
FOR I = 0 TO 8
 LOCATE I + 7, 36: PRINT LTRIM$(STR$(TickSig \ C)) + "/" + LTRIM$(STR$(TickSig))
 C = C + C
NEXT
PokeBCol DummyInteger(3) + 7, 29, 9, 22

COLOR 10, 0
LOCATE 17, 45: PRINT DummyString(0)
LOCATE 18, 45: PRINT DummyString(1)

' Highlights
SELECT CASE DummyInteger(0)
CASE 1: IF (FrameTile AND 16) THEN PokeCol 17, 45 + DummyInteger(5), 15, 9
CASE 2: IF (FrameTile AND 16) THEN PokeCol 18, 45 + DummyInteger(6), 15, 9
CASE 3: PokeCol 20, 30, 15, 1: PokeCol 20, 37, 15, 1
CASE 4: PokeCol 20, 40, 15, 1: PokeCol 20, 49, 15, 1
END SELECT

' Active highlight
IF SBAR OR MLB1 THEN
 SELECT CASE DummyInteger(2)
  CASE 4: InvertBox 19, 29, 19, 36
  CASE 5: InvertBox 19, 39, 19, 48
 END SELECT
END IF

END SUB

SUB QuantizeInp

' Start
IF DummyInteger(4) = 0 THEN
 DummyInteger(4) = 1
 DummyString(0) = LTRIM$(STR$(TrackScr(ATrack, 1)))
 DummyString(1) = LTRIM$(STR$(TrackScr(ATrack, 2)))
 InpNumbers DummyString(0), DummyInteger(5), 4, 0, 8000
 InpNumbers DummyString(1), DummyInteger(6), 4, 0, 8000
END IF

' End
IF DummyInteger(4) = 2 THEN
 IF DummyInteger(0) <= 3 THEN CAS.Quantize ATrack, DummyInteger(3), VAL(DummyString(0)), VAL(DummyString(1))
 AWindow = 0
 CleanDummies
 EXIT SUB
END IF

' Special Mouse areas
IF MY >= 7 AND MY <= 15 AND MX >= 29 AND MX <= 51 THEN Area = 1
IF MY >= 17 AND MY <= 18 AND MX >= 45 AND MX <= 49 THEN Area = MY - 15
IF MY = 20 THEN
IF MX >= 30 AND MX <= 37 THEN Area = 4
IF MX >= 40 AND MX <= 49 THEN Area = 5
END IF

StdInp DummyInteger(0), 5, DummyInteger(4), Area

' Special mouse area for input
IF MLB1 AND Area = 1 THEN DummyInteger(3) = MY - 7
IF Area AND MLB1 = 1 AND Area < 4 THEN DummyInteger(Area + 3) = MX - 45

' Special Input for string
SELECT CASE DummyInteger(0)
 CASE 0
    C = DummyInteger(3)
    SELECT CASE CH$
     CASE CHR$(0) + CHR$(71), CHR$(0) + CHR$(73): C = 0
     CASE CHR$(0) + CHR$(72): C = C + (C > 0)
     CASE CHR$(0) + CHR$(79), CHR$(0) + CHR$(81): C = 8
     CASE CHR$(0) + CHR$(80): C = C - (C < 8)
    END SELECT
    DummyInteger(3) = C
 CASE 1: InpNumbers DummyString(0), DummyInteger(5), 4, 0, CLNG(TrackLen(ATrack))
 CASE 2: InpNumbers DummyString(1), DummyInteger(6), 4, 0, CLNG(TrackLen(ATrack))
END SELECT

' Standard Keypress
IF SBAR = -1 THEN CH$ = CHR$(13)
SELECT CASE CH$
CASE CHR$(13): DummyInteger(4) = 2
CASE CHR$(27): DummyInteger(4) = 2: DummyInteger(0) = 4
CASE CHR$(9): DummyInteger(0) = (DummyInteger(0) + 1) MOD 5
CASE CHR$(0) + CHR$(15): DummyInteger(0) = (DummyInteger(0) + 4) MOD 5
END SELECT

END SUB

SUB RecDisp

IF AWindow <> 17 THEN EXIT SUB

' Basic
Ref$ = CHR$(255)
MakeBoxF 6, 23, 22, 57, 32, 0, 0
MakeBoxF 5, 21, 21, 55, 32, 15, 1
MakeBox 5, 21, 21, 55, 15, 1
LOCATE 5, 34: PRINT " " + "RECORD" + " "
COLOR 12: LOCATE 12, 23: PRINT "< RECORD >"
COLOR 10: LOCATE 12, 34: PRINT "< PLAYBACK >"
COLOR 14: LOCATE , 34: PRINT "< STOP >"

' Keyboard
A1$ = "             "
COLOR , 0
IF DummyInteger(0) = 0 THEN COLOR 15 ELSE COLOR 7
FOR I = 7 TO 9
LOCATE I, 23: PRINT A1$
NEXT
LOCATE 10, 23: PRINT "C#D#EF#G#A#BC#D#EF#G#A#BC#D#EF#"

LOCATE 12, 47: IF Undo THEN COLOR 15: PRINT "< UNDO >" ELSE COLOR 8: PRINT "< undo >"
COLOR 7, 1
LOCATE 6, 23: PRINT UCASE$(KeyB)
LOCATE 15, 25: PRINT "Sample:"
LOCATE 16, 23: PRINT "Loop voice: [ ] Release VCE: [ ]"
LOCATE 18, 22: PRINT "REC Track:        Channel:"
LOCATE 20, 32: PRINT "< OK/CLOSE >"
A$ = Samples(VAL(DummyString(0)) - 1)
IF A$ = "" THEN A$ = "[ NONE ]"
LOCATE 15, 36: PRINT "---" + A$

COLOR 10, 0
LOCATE 15, 33: PRINT "   ": LOCATE 15, 33: PRINT DummyString(0)
LOCATE 18, 33: PRINT "   ": LOCATE 18, 33: PRINT DummyString(1)
LOCATE 18, 49: PRINT "   ": LOCATE 18, 49: PRINT DummyString(2)
IF DummyInteger(6) THEN LOCATE 16, 36: PRINT "X"
IF DummyInteger(9) THEN LOCATE 16, 53: PRINT "X"

' Tiny highlights
SELECT CASE DummyInteger(0)
 CASE 1: PokeCol 12, 23, 15, 9: PokeCol 12, 32, 15, 9
 CASE 2: PokeCol 12, 34, 15, 9: PokeCol 12, 45, 15, 9
 CASE 3: PokeCol 12, 47, 15, 9: PokeCol 12, 54, 15, 9
 CASE 4: PokeCol 13, 34, 15, 9: PokeCol 13, 41, 15, 9
 CASE 5: IF (FrameTile AND 16) THEN PokeCol 15, 33 + DummyInteger(3), 15, 9
 CASE 6: PokeCol 16, 35, 15, 9: PokeCol 16, 37, 15, 9
 CASE 7: PokeCol 16, 52, 15, 9: PokeCol 16, 54, 15, 9
 CASE 8: IF (FrameTile AND 16) THEN PokeCol 18, 33 + DummyInteger(4), 15, 9
 CASE 9: IF (FrameTile AND 16) THEN PokeCol 18, 49 + DummyInteger(5), 15, 9
 CASE 10: PokeCol 20, 32, 15, 9: PokeCol 20, 43, 15, 9
END SELECT

' Held highlights
SELECT CASE DummyInteger(2)
 CASE 2: InvertBox 11, 22, 11, 31
 CASE 3: InvertBox 11, 33, 11, 44
 CASE 4: IF Undo THEN InvertBox 11, 46, 11, 53
 CASE 5: InvertBox 12, 33, 12, 40
 CASE 11: InvertBox 19, 31, 19, 42
END SELECT

END SUB

SUB RecInp

' Start
IF DummyInteger(12) = 0 THEN
 Undo = 0
 UndoTL = 0
 DummyInteger(12) = 1
 IF ATrack THEN DummyString(1) = LTRIM$(STR$(ATrack)) ELSE DummyString(1) = "1"
 IF LEN(DummyString(1)) = 1 THEN DummyString(1) = "0" + DummyString(1)
 DummyString(0) = DummyString(1)
 DummyString(2) = DummyString(1)
END IF

' END
IF DummyInteger(12) = 2 THEN
 AWindow = 0
 CleanDummies
END IF

' Areas
IF MX >= 23 AND MX <= 53 AND MY >= 7 AND MY <= 10 THEN Area = 1
IF MY = 12 THEN
 SELECT CASE MX
  CASE 23 TO 32: Area = 2
  CASE 34 TO 45: Area = 3
  CASE 47 TO 54: Area = 4
 END SELECT
END IF
IF MY = 13 AND MX >= 34 AND MX <= 41 THEN Area = 5 ' STOP
IF MY = 15 AND MX >= 22 AND MX <= 54 THEN Area = 6 ' Sample
IF MY = 16 THEN
 SELECT CASE MX
  CASE 22 TO 38: Area = 7 ' Loop
  CASE 39 TO 54: Area = 8 ' Release
 END SELECT
END IF
IF MY = 18 THEN
 SELECT CASE MX
  CASE 26 TO 35: Area = 9  ' Track
  CASE 40 TO 51: Area = 10 ' Channel
 END SELECT
END IF
IF MY = 20 AND MX >= 32 AND MX <= 43 THEN Area = 11 ' OK

' New Press
IF MLB1 = 1 THEN
IF Area THEN DummyInteger(0) = Area - 1: DummyInteger(1) = Area
SELECT CASE Area
CASE 3, 5: SBAR = 1
CASE 6: IF MX > 32 AND MX < 36 THEN DummyInteger(3) = MX - 33
CASE 9: IF MX > 32 AND MX < 36 THEN DummyInteger(4) = MX - 33
CASE 10: IF MX > 48 AND MX < 52 THEN DummyInteger(5) = MX - 49
END SELECT
END IF

IF MLB1 = -1 THEN
 IF DummyInteger(0) = 3 OR DummyInteger(0) = 1 THEN CH$ = CHR$(13)
 IF MY = 16 THEN
  IF MX >= 35 AND MX <= 37 THEN DummyInteger(6) = DummyInteger(6) XOR 1
  IF MX >= 52 AND MX <= 54 THEN DummyInteger(9) = DummyInteger(9) XOR 1
 END IF
END IF

' Highlight
IF MLB1 AND Area > 0 AND DummyInteger(1) = Area THEN
  DummyInteger(2) = Area
 ELSE
  DummyInteger(2) = 0
END IF
IF SBAR THEN DummyInteger(2) = DummyInteger(0) + 1

' Release
IF DummyInteger(0) = 10 THEN
 IF CH$ = CHR$(13) OR SBAR = -1 THEN DummyInteger(12) = 2
END IF
IF DummyInteger(1) AND MLB1 = -1 THEN
IF Area = 11 THEN DummyInteger(12) = 2 ELSE DummyInteger(1) = 0 ' close
END IF

MusicKeyboard
Anything = 0

' General keys
SELECT CASE CH$
 CASE CHR$(27): DummyInteger(12) = 2
 CASE CHR$(9), CHR$(0) + CHR$(80): DummyInteger(0) = (DummyInteger(0) + 1) MOD 11
 CASE CHR$(0) + CHR$(15), CHR$(0) + CHR$(72): DummyInteger(0) = (DummyInteger(0) + 10) MOD 11
END SELECT

' What to do in items
SELECT CASE DummyInteger(0)
CASE 1                                                     ' RECORD MODULE
  IF SBAR = -1 OR CH$ = CHR$(13) THEN
   CASPlaying = 0
   CAS.Stop
   FOR I = 17 TO 32: DQBstopVoice I: NEXT: CASPlaying = 1
   C = VAL(DummyString(1))
   Undo = C + 1
   DQBcopyLayer Undo, 19
   UndoTL = TrackLen(C)
   Modified = 1
   AWindow = 18
   DummyInteger(0) = 0
   ATrack = C
  END IF
CASE 2: IF SBAR = 1 OR CH$ = CHR$(13) THEN CASPlaying = 0: CAS.Stop: FOR I = 17 TO 32: DQBstopVoice I: NEXT: CASPlaying = 1
CASE 3
 IF SBAR = -1 OR CH$ = CHR$(13) THEN
  DQBcopyLayer 19, Undo
  TrackLen(Undo - 1) = UndoTL
  Undo = 0
 END IF
CASE 4: IF SBAR = 1 OR CH$ = CHR$(13) THEN CASPlaying = 0: CAS.Stop: FOR I = 17 TO 32: DQBstopVoice I: NEXT
CASE 5: InpNumbers DummyString(0), DummyInteger(3), 2, 1, 16
CASE 6: IF SBAR = -1 THEN DummyInteger(6) = DummyInteger(6) XOR 1
CASE 7: IF SBAR = -1 THEN DummyInteger(9) = DummyInteger(9) XOR 1
CASE 8: InpNumbers DummyString(1), DummyInteger(4), 2, 1, 16
CASE 9: InpNumbers DummyString(2), DummyInteger(5), 2, 1, 16
END SELECT

END SUB

SUB RecNowDisp

Ref$ = CHR$(254)

MakeBoxF 7, 24, 12, 56, 32, 0, 0
MakeBoxF 6, 22, 11, 54, 219, 9, 9
COLOR 14
LOCATE 11, 30: PRINT "< STOP RECORDING >"

A1$ = "             "
COLOR 15, 0
LOCATE 6, 23: PRINT UCASE$(KeyB)
FOR I = 7 TO 9
LOCATE I, 23: PRINT A1$
NEXT
LOCATE 10, 23: PRINT "C#D#EF#G#A#BC#D#EF#G#A#BC#D#EF#"

END SUB

SUB RecNowInp

MusicKeyboard
Anything = 0
M = VAL(DummyString(1))
TrackScr(M, 2) = TrackScr(M, 1)

' Going back to record
IF MY = 11 AND MX >= 30 AND MX <= 47 AND MLB1 = -1 THEN CH$ = CHR$(13)
IF SBAR = -1 OR CH$ = CHR$(13) OR CH$ = CHR$(27) THEN
 CASPlaying = 0
 CAS.Stop
 TrackScr(M, 1) = 0
 TrackScr(M, 2) = 0
 CAS.Sort.Track M
 AWindow = 17
 SBAR = 0
 CH$ = ""
END IF

END SUB

SUB SSegWindowDisp

' Basic
Ref$ = CHR$(255)
MakeBoxF 9, 23, 21, 57, 32, 0, 0
MakeBoxF 8, 21, 20, 55, 32, 7, 5
MakeBox 8, 21, 20, 55, 7, 5
CenterText 8, " " + "Select segment" + " "

' Window
LOCATE 10, 24: PRINT " Index select:"
LOCATE 11, 24: PRINT " ( ) Index Point A:"
LOCATE 12, 24: PRINT " ( ) Index Point B:"
LOCATE 13, 24: PRINT STRING$(28, "_")
LOCATE 15, 24: PRINT " Time select:"
LOCATE 16, 24: PRINT " ( ) Time Point A:"
LOCATE 17, 24: PRINT " ( ) Time Point B:"
LOCATE 19, 29: PRINT "<  OK  >  < CANCEL >"

' Boxer
COLOR 5, 15
SELECT CASE DummyInteger(5)
 CASE 0: I = 11
 CASE 1: I = 12
 CASE 2: I = 16
 CASE 3: I = 17
END SELECT
LOCATE I, 26: PRINT CHR$(8)

' Highlights
SELECT CASE DummyInteger(0)
CASE 0
  PokeCol 10, 25, 15, 13
  PokeCol 15, 25, 15, 13
  PokeCol 11, 41, 15, 13
  PokeCol 12, 41, 15, 13
  PokeCol 16, 40, 15, 13
  PokeCol 17, 40, 15, 13
CASE 1: PokeCol 19, 29, 15, 13: PokeCol 19, 36, 15, 13
CASE 2: PokeCol 19, 39, 15, 13: PokeCol 19, 48, 15, 13
END SELECT

' Active highlight
SELECT CASE DummyInteger(2)
 CASE 2: InvertBox 18, 28, 18, 35
 CASE 3: InvertBox 18, 38, 18, 47
END SELECT

' Input
COLOR 10, 0
I = DummyInteger(5)
SELECT CASE DummyInteger(5) \ 2
 CASE 0
   LOCATE 11, 43: PRINT DummyString(0)
   LOCATE 12, 43: PRINT DummyString(1)
   IF (FrameTile AND 16) AND DummyInteger(0) = 0 THEN
   IF DummyInteger(5) THEN PokeCol 12, 43 + DummyInteger(7), 15, 9 ELSE PokeCol 11, 43 + DummyInteger(6), 15, 9
   END IF
 CASE 1
   LOCATE 16, 43: PRINT DummyString(2)
   LOCATE 17, 43: PRINT DummyString(3)
   IF (FrameTile AND 16) AND DummyInteger(0) = 0 THEN
    IF DummyInteger(5) = 2 THEN PokeCol 16, 43 + DummyInteger(8), 15, 9
    IF DummyInteger(5) = 3 THEN PokeCol 17, 43 + DummyInteger(9), 15, 9
   END IF
END SELECT

END SUB

REM $DYNAMIC
SUB SSegWindowInp

C = TrackLen(ATrack)

' Start
IF DummyInteger(4) = 0 THEN
 DummyInteger(4) = 1
 Tim& = TTE&(ATrack, C - 1)
 DummyString(1) = STR$(C)
 DummyString(2) = "00000:000"
 DummyString(3) = TickStr$(Tim&)
 InpNumbers DummyString(0), 0, 4, 1, CLNG(C)
 InpNumbers DummyString(1), 0, 4, 1, CLNG(C)
END IF

' End
IF DummyInteger(4) = 2 THEN
 IF DummyInteger(0) < 2 THEN
  SELECT CASE DummyInteger(5) \ 2
   CASE 0
     TrackScr(ATrack, 1) = VAL(DummyString(0)) - 1
     TrackScr(ATrack, 2) = VAL(DummyString(1)) - 1
   CASE 1
     Tim1& = Str2Tim&(DummyString(2))
     Tim2& = Str2Tim&(DummyString(3))
     FOR I = 0 TO C - 1
     Tim& = TTE&(ATrack, I)
      IF Tim& >= Tim1& AND Tim& <= Tim2& THEN
      IF TTL = 0 THEN TTL = 1: TrackScr(ATrack, 1) = I
      TrackScr(ATrack, 2) = I
      END IF
     NEXT
  END SELECT
 END IF
 AWindow = 0
 CleanDummies
END IF

' KEYS OK CANCEL
IF SBAR = -1 AND DummyInteger(0) > 0 THEN DummyInteger(4) = 2
SELECT CASE UCASE$(CH$)
 CASE CHR$(13): DummyInteger(4) = 2
 CASE CHR$(27): DummyInteger(4) = 2: DummyInteger(0) = 2
 CASE CHR$(9): DummyInteger(0) = (DummyInteger(0) + 1) MOD 3
 CASE CHR$(0) + CHR$(15): DummyInteger(0) = (DummyInteger(0) + 2) MOD 3
END SELECT

' Mouse areas
IF MY >= 11 AND MY <= 17 AND MX >= 22 AND MX <= 54 THEN Area = 1
IF MY = 19 AND MX >= 29 AND MX <= 36 THEN Area = 2
IF MY = 19 AND MX >= 39 AND MX <= 48 THEN Area = 3
IF MX >= 43 AND MX <= 47 AND MLB1 = 1 THEN
 IF MY = 11 THEN DummyInteger(6) = MX - 43
 IF MY = 12 THEN DummyInteger(7) = MX - 43
END IF

IF Area = 1 AND MLB1 = 1 THEN
 SELECT CASE MY
  CASE 11: DummyInteger(5) = 0
  CASE 12: DummyInteger(5) = 1
  CASE 16: DummyInteger(5) = 2
  CASE 17: DummyInteger(5) = 3
 END SELECT
END IF

StdInp DummyInteger(0), 3, DummyInteger(4), Area

' Choice keys
IF DummyInteger(0) = 0 THEN
 I = DummyInteger(5)
 SELECT CASE UCASE$(CH$)
  CASE CHR$(0) + CHR$(72): I = (I - 1) AND 3
  CASE CHR$(0) + CHR$(80): I = (I + 1) AND 3
  CASE "I": IF I >= 2 THEN I = I - 2
  CASE "T": IF I < 2 THEN I = I + 2
  CASE "A": I = I - (I AND 1)
  CASE "B": I = I - ((I AND 1) = 0)
 END SELECT
 SELECT CASE I \ 2
  CASE 0: InpNumbers DummyString(I), DummyInteger(6 + I), 4, 1, CLNG(C)
  CASE 1: InpTime DummyString(I), DummyInteger(6 + I), 43, 14 + I
 END SELECT
 DummyInteger(5) = I
END IF

END SUB

REM $STATIC
SUB StepRecDisp

IF DummyInteger(13) THEN Ref$ = CHR$(254) ELSE Ref$ = CHR$(255)
MakeBoxF 6, 24, 21, 56, 32, 0, 0
MakeBoxF 5, 22, 20, 54, 219, 1, 1
MakeBox 5, 22, 20, 54, 15, 9
LOCATE 5, 32: PRINT " STEP RECORD "

A1$ = "             "
COLOR , 0
IF DummyInteger(0) THEN COLOR 7
FOR I = 7 TO 9
LOCATE I, 23: PRINT A1$
NEXT
LOCATE 10, 23: PRINT "C#D#EF#G#A#BC#D#EF#G#A#BC#D#EF#"

LOCATE 12, 24
IF DummyInteger(13) = 0 OR ((FrameTile AND 31) < 28) THEN
 COLOR 7, 4: PRINT "< REC/STOP >"
  ELSE
 COLOR 12, 7: PRINT STRING$(12, 219)
END IF

COLOR 7, 1
LOCATE 6, 23: PRINT UCASE$(KeyB)
LOCATE 15, 25: PRINT "Sample:"
LOCATE , 26: PRINT "Track:"
LOCATE , 24: PRINT "Channel:"
LOCATE 15, 40: PRINT "Time Insert:"
LOCATE 17, 43: PRINT "Time Inc:"
LOCATE , 24: PRINT "Loop Voice: [ ]"
LOCATE , 32: PRINT "< OK/CLOSE >"

LOCATE 12, 40
IF DummyInteger(13) THEN
COLOR 2, 0: PRINT "< playback >"
ELSE
COLOR 10, 1: PRINT "< PLAYBACK >"
END IF

C = UndoTL < TrackLen(VAL(DummyString(1)))
IF C THEN
 COLOR 15, 0
 LOCATE 13, 24
 PRINT "< UNDO LAST >"
 LOCATE 13, 40
 PRINT "< UNDO ALL >"
ELSE
 COLOR 8, 0
 LOCATE 13, 24
 PRINT "< undo last >"
 LOCATE 13, 40
 PRINT "< undo all >"
END IF

COLOR 10, 0
LOCATE 15, 33: PRINT DummyString(0) ' Sample
LOCATE , 33: PRINT DummyString(1)   ' Track
LOCATE , 33: PRINT DummyString(2)   ' Channel
LOCATE 16, 42: PRINT DummyString(3)
LOCATE 18, 42: PRINT DummyString(4)
IF DummyInteger(6) THEN LOCATE 18, 37: PRINT "X"

I = FrameTile AND 16
SELECT CASE DummyInteger(0)
 CASE 1: PokeCol 12, 24, 15, 9: PokeCol 12, 35, 15, 9
 CASE 2: PokeCol 12, 40, 15, 9: PokeCol 12, 51, 15, 9
 CASE 3: PokeCol 13, 24, 15, 9: PokeCol 13, 36, 15, 9
 CASE 4: PokeCol 13, 40, 15, 9: PokeCol 13, 51, 15, 9
 CASE 5: IF I THEN PokeCol 15, 33 + DummyInteger(3), 15, 9
 CASE 6: IF I THEN PokeCol 16, 33 + DummyInteger(4), 15, 9
 CASE 7: IF I THEN PokeCol 17, 33 + DummyInteger(5), 15, 9
 CASE 8: PokeCol 18, 36, 15, 9: PokeCol 18, 38, 15, 9
 CASE 9: IF I THEN PokeCol 16, 42 + DummyInteger(14), 15, 9
 CASE 10: IF I THEN PokeCol 18, 42 + DummyInteger(15), 15, 9
 CASE 11: PokeCol 19, 32, 15, 9: PokeCol 19, 43, 15, 9
END SELECT

' Held highlights
SELECT CASE DummyInteger(2)
 CASE 2: InvertBox 11, 22, 11, 34
 CASE 3: IF DummyInteger(13) = 0 THEN InvertBox 11, 36, 11, 50
 CASE 4: IF C THEN InvertBox 12, 22, 12, 35
 CASE 5: IF C THEN InvertBox 12, 36, 12, 50
 CASE 12: InvertBox 18, 31, 18, 42
END SELECT

END SUB

SUB StepRecInp

' Start
IF DummyInteger(12) = 0 THEN
 DummyInteger(12) = 1
 IF ATrack THEN DummyString(1) = LTRIM$(STR$(ATrack)) ELSE DummyString(1) = "1"
 IF LEN(DummyString(1)) = 1 THEN DummyString(1) = "0" + DummyString(1)
 DummyString(1) = DummyString(1) + " "
 DummyString(0) = DummyString(1)
 DummyString(2) = DummyString(1)
 DummyString(3) = "00000:000"
 DummyString(4) = DummyString(3)
END IF

' END
IF DummyInteger(12) = 2 THEN
 AWindow = 0
 FOR I = 17 TO 32: DQBstopVoice I: NEXT
 CleanDummies
END IF

' Mouse areas
IF MY >= 7 AND MY <= 10 AND MX >= 23 AND MX <= 53 THEN Area = 1
IF MY = 12 THEN
 IF MX >= 24 AND MX <= 35 THEN Area = 2
 IF MX >= 40 AND MX <= 51 THEN Area = 3
END IF
IF MY = 13 THEN
 IF MX >= 24 AND MX <= 36 THEN Area = 4
 IF MX >= 40 AND MX <= 51 THEN Area = 5
END IF
IF MX >= 23 AND MX <= 35 THEN
 IF MY >= 15 AND MY <= 17 THEN Area = MY - 9
END IF
IF MY = 18 AND MX >= 23 AND MX <= 38 THEN Area = 9
IF MX >= 42 AND MX <= 50 THEN
 IF MY = 16 THEN Area = 10
 IF MY = 18 THEN Area = 11
END IF
IF MY = 19 AND MX >= 32 AND MX <= 43 THEN Area = 12

' New Press
IF MLB1 = 1 THEN
 IF Area THEN DummyInteger(0) = Area - 1: DummyInteger(1) = Area
 IF MX > 32 AND MX < 36 THEN I = 1 ELSE I = 0
 SELECT CASE Area
  CASE 6: IF I THEN DummyInteger(3) = MX - 33
  CASE 7: IF I THEN DummyInteger(4) = MX - 33
  CASE 8: IF I THEN DummyInteger(5) = MX - 33
 END SELECT
END IF

IF MLB1 = -1 THEN IF DummyInteger(0) >= 1 AND DummyInteger(0) <= 4 THEN CH$ = CHR$(13)

' Highlight
IF MLB1 AND Area > 0 AND DummyInteger(1) = Area THEN
  DummyInteger(2) = Area
 ELSE
  DummyInteger(2) = 0
END IF
IF SBAR THEN DummyInteger(2) = DummyInteger(0) + 1

' Release
IF DummyInteger(0) = 10 THEN
 IF CH$ = CHR$(13) OR SBAR = -1 THEN DummyInteger(12) = 2
END IF
IF DummyInteger(1) AND MLB1 = -1 THEN
IF Area = 12 THEN DummyInteger(12) = 2 ELSE DummyInteger(1) = 0
END IF

' -------- RECORDING WINDOW

MusicKeyboard
IF DummyInteger(13) THEN
  I = VAL(DummyString(1))
  ATrack = I
  IF TrackLen(I) >= 8000 THEN Anything = 0
                        ' INSERT
  IF Anything THEN
   Tim& = Str2Tim&(DummyString(3))
   L = TrackLen(I)
   PutTime I, L, Tim&
   PutByte4 I, L, 1
   PutByte5 I, L, VAL(DummyString(0)) - 1
   PutByte6 I, L, VAL(DummyString(2)) - 1
   PutByte7 I, L, Anything - 1
   PutByte8 I, L, DummyInteger(6)
   TrackLen(I) = L + 1
   Tim2& = Str2Tim&(DummyString(4))
   DummyString(3) = TickStr$(Tim& + Tim2&)
   TrackScr(I, 2) = TrackScr(I, 1)
   ScrollField I, 16384
  END IF
                             ' END
   IF DummyInteger(0) < 2 THEN
    IF TrackLen(I) >= 8000 THEN CH$ = CHR$(13)
    IF CH$ = CHR$(13) OR CH$ = CHR$(27) OR SBAR = -1 THEN
     CH$ = ""
     SBAR = 0
     CAS.Sort.Track I
     FOR I = 17 TO 32: DQBstopVoice I: NEXT
     DummyInteger(13) = 0
    END IF
   END IF
END IF
Anything = 0

'---------------------- END RECORDING

' General keys
SELECT CASE CH$
 CASE CHR$(27): DummyInteger(12) = 2
 CASE CHR$(9), CHR$(0) + CHR$(80): DummyInteger(0) = (DummyInteger(0) + 1) MOD 12
 CASE CHR$(0) + CHR$(15), CHR$(0) + CHR$(72): DummyInteger(0) = (DummyInteger(0) + 11) MOD 12
END SELECT

' Select choice
SELECT CASE DummyInteger(0)
 CASE 1                                                     ' RECORD MODULE
  IF SBAR = -1 OR CH$ = CHR$(13) THEN
   CASPlaying = 0
   CAS.Stop
   FOR I = 17 TO 32: DQBstopVoice I: NEXT
   C = VAL(DummyString(1))
   Undo = C + 1
   DQBcopyLayer Undo, 19
   UndoTL = TrackLen(C)
   Modified = 1
   DummyInteger(13) = 1
   DummyInteger(0) = 0
  END IF
 CASE 2
   IF SBAR = 1 OR CH$ = CHR$(13) THEN
    IF DummyInteger(13) = 0 THEN
    FOR I = 17 TO 32: DQBstopVoice I: NEXT
    CASPlaying = CASPlaying XOR 1
    IF CASPlaying = 0 THEN CAS.Stop
    END IF
   END IF
 CASE 3
   IF SBAR = -1 OR CH$ = CHR$(13) THEN
    I = VAL(DummyString(1))
    IF UndoTL < TrackLen(I) THEN
     TrackLen(I) = TrackLen(I) - 1
      J = TrackLen(I)
      Tim& = TTE&(I, J)
      FOR X = 0 TO 7
      DQBpset I + 1, ((J * 8&) MOD 320) + X, J \ 40, 0
      NEXT
     ScrollField I, 16384
     TrackScr(I, 2) = TrackScr(I, 1)
     DummyString(3) = TickStr$(Tim&)
    END IF
   END IF
 CASE 4
   IF SBAR = -1 OR CH$ = CHR$(13) THEN
    I = VAL(DummyString(1))
    IF UndoTL < TrackLen(I) THEN
      DQBcopyLayer 19, Undo
      TrackLen(I) = UndoTL
     ScrollField I, 16384
     TrackScr(I, 2) = TrackScr(I, 1)
    END IF
   END IF
 CASE 5: InpNumbers DummyString(0), DummyInteger(3), 2, 1, 16
 CASE 6: InpNumbers DummyString(1), DummyInteger(4), 2, 1, 16
 CASE 7: InpNumbers DummyString(2), DummyInteger(5), 2, 1, 16
 CASE 8
   I = 0
   IF SBAR = -1 THEN I = 1
   IF MLB1 = -1 AND MY = 18 AND MX >= 36 AND MX <= 38 THEN I = 1
   IF I THEN DummyInteger(6) = DummyInteger(6) XOR 1
 CASE 9: InpTime DummyString(3), DummyInteger(14), 42, 16
 CASE 10: InpTime DummyString(4), DummyInteger(15), 42, 18
 CASE 11: IF CH$ = CHR$(13) OR SBAR = -1 THEN DummyInteger(12) = 2
END SELECT

END SUB

SUB TempoDisp

IF AWindow = 0 THEN EXIT SUB

' Draw box
Ref$ = "Tap tempo pad for beat. Reset to start all over. Use any key for beat."
MakeBoxF 9, 30, 20, 54, 32, 0, 0
MakeBoxF 9, 28, 19, 52, 32, 7, 1
MakeBox 8, 28, 19, 52, 7, 1
CenterText 8, " " + "TEST TEMPO" + " "
LOCATE 9, 30: PRINT "Time Elapse:"
LOCATE , 30: PRINT "Average BPM:"
LOCATE , 30: PRINT " # of Beats:"
LOCATE , 30: PRINT " Prev. Beat:"
LOCATE 18, 29: PRINT "< RESET >  < OK/CLOSE >"

C = DummyInteger(4)
I = DummyInteger(6)
IF C THEN
COLOR 15, 9
 A1$ = LTRIM$(STR$(C \ 4320))
 A1$ = STRING$(2 - LEN(A1$), "0") + A1$
 A2$ = LTRIM$(STR$((C \ 72) MOD 60))
 A2$ = STRING$(2 - LEN(A2$), "0") + A2$
 A3$ = LTRIM$(STR$(C MOD 60))
 A3$ = STRING$(2 - LEN(A3$), "0") + A3$
 LOCATE 9, 43: PRINT A1$ + ":" + A2$ + ":" + A3$
 IF I THEN IF C / I THEN LOCATE 10, 43: PRINT LTRIM$(STR$(CINT(4320 / (C / I))))
 LOCATE 11, 43: PRINT LTRIM$(STR$(I))
 LOCATE , 43: PRINT LTRIM$(STR$(DummyInteger(5)))
END IF

' Tempo Highlight
IF DummyInteger(0) = 0 THEN
 I = 14
 C = 6
ELSE
 I = 1
 C = 0
END IF
MakeBox2 13, 30, 17, 50, I, C
MakeBoxF 14, 31, 16, 49, 32, I, C
LOCATE 15, 34: PRINT "TEMPO TAP PAD"

' Highlights
SELECT CASE DummyInteger(0)
CASE 1: PokeCol 18, 29, 15, 1: PokeCol 18, 37, 15, 1
CASE 2: PokeCol 18, 40, 15, 1: PokeCol 18, 51, 15, 1
END SELECT

' Active highlight
IF SBAR OR MLB1 THEN
 SELECT CASE DummyInteger(2)
  CASE 2: InvertBox 17, 28, 17, 36
  CASE 3: InvertBox 17, 39, 17, 50
 END SELECT
END IF

END SUB

SUB TempoInp

' Start
IF DummyInteger(3) = 0 THEN
 CH$ = ""
 MLB1 = 2
 DummyInteger(3) = 1
 DummyInteger(7) = Scan
END IF

' End
IF DummyInteger(3) = 2 THEN
 CleanDummies
 AWindow = 0
 EXIT SUB
END IF

' Mouse area
IF MY >= 13 AND MY <= 17 AND MX >= 30 AND MX <= 50 THEN Area = 1
IF MY = 18 THEN
 IF MX >= 29 AND MX <= 37 THEN Area = 2
 IF MX >= 40 AND MX <= 51 THEN Area = 3
END IF

' Standard New Press
IF Area AND MLB1 = 1 THEN
 DummyInteger(0) = Area - 1
 DummyInteger(1) = Area
END IF

' Standard Highlight
IF MLB1 AND Area > 0 AND DummyInteger(1) = Area THEN
  DummyInteger(2) = Area
 ELSE
  DummyInteger(2) = 0
END IF
IF SBAR THEN DummyInteger(2) = DummyInteger(0) + 1

' Standard Release
IF DummyInteger(1) AND MLB1 = -1 THEN
 IF Area > 2 THEN DummyInteger(3) = 2 ELSE DummyInteger(1) = 0
 IF Area = 2 THEN DummyInteger(4) = 0
END IF

' Standard Keypress
IF SBAR = -1 THEN CH$ = CHR$(13)
SELECT CASE CH$
 CASE CHR$(13)
   SELECT CASE DummyInteger(0)
    CASE 0: CH$ = ""
    CASE 1: DummyInteger(4) = 0
    CASE 2: DummyInteger(3) = 2
   END SELECT
 CASE CHR$(27): DummyInteger(3) = 2: DummyInteger(0) = 2: CH$ = ""
 CASE CHR$(9): DummyInteger(0) = (DummyInteger(0) + 1) MOD 3: CH$ = ""
 CASE CHR$(0) + CHR$(15): DummyInteger(0) = (DummyInteger(0) + 2) MOD 3: CH$ = ""
END SELECT
IF CH$ = "" THEN DummyInteger(7) = Scan

' Touching Tap Pad
IF DummyInteger(0) = 0 THEN
 I = 0
 IF DummyInteger(7) <> Scan THEN
   DummyInteger(7) = Scan
  IF Scan < 127 THEN I = 1
 END IF
 IF MLB1 = 1 THEN I = 1
 IF I AND DummyInteger(4) = 0 THEN DummyInteger(4) = 1
 IF I THEN
  DummyInteger(5) = DummyInteger(8): DummyInteger(8) = 0
  DummyInteger(6) = DummyInteger(6) + 1
 END IF
END IF

' Miscelaneous
C = DummyInteger(4)
IF C THEN
 C = C - (C < 32766)
 DummyInteger(4) = C
 C = DummyInteger(8)
 C = C - (C < 32766)
 DummyInteger(8) = C
ELSE
 DummyInteger(5) = 0
 DummyInteger(6) = 0
END IF

END SUB

SUB TickSigDisp

' Basic
Ref$ = CHR$(255)
MakeBoxF 11, 30, 16, 54, 32, 0, 0
MakeBoxF 11, 28, 15, 52, 32, 15, 5
MakeBox 10, 28, 15, 52, 7, 5
MakeBox2 11, 37, 13, 42, 7, 5
CenterText 10, " " + "Time/Tick Signature" + " "
CenterText 14, "<  OK  >  < CANCEL >"

' Description
COLOR 10, 5
LOCATE 12, 38
PRINT DummyString(0)

' Highlights
SELECT CASE DummyInteger(0)
CASE 0: IF (FrameTile AND 16) THEN PokeCol 12, 38 + DummyInteger(3), 15, 9
CASE 1: PokeCol 14, 30, 15, 13: PokeCol 14, 37, 15, 13
CASE 2: PokeCol 14, 40, 15, 13: PokeCol 14, 49, 15, 13
END SELECT

' Active highlight
IF SBAR OR MLB1 THEN
 SELECT CASE DummyInteger(2)
  CASE 2: InvertBox 13, 29, 13, 36
  CASE 3: InvertBox 13, 39, 13, 48
 END SELECT
END IF

END SUB

SUB TickSigInp

' Special Start
IF DummyInteger(4) = 0 THEN
 DummyInteger(4) = 1
 DummyString(0) = LTRIM$(STR$(TickSig))
 DummyString(1) = DummyString(0)
END IF

' Special End
IF DummyInteger(4) = 2 THEN
 IF DummyInteger(0) = 2 THEN TickSig = VAL(DummyString(1)) ELSE Modified = 1
 AWindow = 0
 CleanDummies
 EXIT SUB
END IF

' Special Mouse areas
IF MY = 12 AND MX >= 38 AND MX <= 41 THEN Area = 1
IF MY = 14 AND MX >= 30 AND MX <= 37 THEN Area = 2
IF MY = 14 AND MX >= 40 AND MX <= 49 THEN Area = 3

' Special mouse area for input
IF Area = 1 AND MLB1 = 1 THEN DummyInteger(3) = MX - 38
StdInp DummyInteger(0), 3, DummyInteger(4), Area

' Special Input for string
IF DummyInteger(0) = 0 THEN
InpNumbers DummyString(0), DummyInteger(3), 3, 8, 256
TickSig = VAL(DummyString(0))
END IF

' Standard Keypress
IF SBAR = -1 AND DummyInteger(0) > 0 THEN CH$ = CHR$(13)
SELECT CASE CH$
CASE CHR$(13): DummyInteger(4) = 2
CASE CHR$(27): DummyInteger(4) = 2: DummyInteger(0) = 2
CASE CHR$(9): DummyInteger(0) = (DummyInteger(0) + 1) MOD 3
CASE CHR$(0) + CHR$(15): DummyInteger(0) = (DummyInteger(0) + 2) MOD 3
END SELECT

END SUB

REM $DYNAMIC
FUNCTION TickStr$ (Tks&)

A$ = LTRIM$(STR$(Tks& MOD TickSig))
A$ = STRING$(3 - LEN(A$), "0") + A$
A$ = LTRIM$(STR$(Tks& \ TickSig)) + ":" + A$
A$ = STRING$(9 - LEN(A$), "0") + A$
TickStr$ = A$

END FUNCTION

REM $STATIC
SUB UnloadDisp
IF AWindow = 0 THEN EXIT SUB

' Basic outline
Ref$ = CHR$(255)
MakeBoxF 5, 31, 23, 55, 32, 0, 0
MakeBoxF 4, 29, 22, 53, 32, 1, 1
MakeBox 4, 29, 22, 53, 9, 1
LOCATE 4, 33: PRINT ""
LOCATE 4, 50: PRINT ""

' Track list
COLOR 7, 1
 LOCATE 4, 34: PRINT " Unload Samples "
 FOR I = 0 TO 15
 LOCATE I + 5, 33: PRINT "[ ] " + HEX$(I)
 IF ASC(MID$(DummyString(1), I + 1, 1)) THEN LOCATE I + 5, 34: PRINT "X"
 NEXT
 LOCATE 21, 32: PRINT "<  OK  >"
 LOCATE 21, 42: PRINT "< CANCEL >"

 COLOR 10
 FOR I = 0 TO 15
 LOCATE I + 5, 40: PRINT Samples(I)
 NEXT

 SELECT CASE DummyInteger(0)
 CASE 0: PokeBCol DummyInteger(4) + 5, 30, 9, 22
 CASE 1: PokeCol 21, 32, 15, 1: PokeCol 21, 39, 15, 1
 CASE 2: PokeCol 21, 42, 15, 1: PokeCol 21, 51, 15, 1
 END SELECT

 SELECT CASE DummyInteger(2)
 CASE 2: InvertBox 20, 31, 20, 38
 CASE 3: InvertBox 20, 41, 20, 50
 END SELECT

END SUB

SUB UnloadInp

' START
IF DummyInteger(3) = 0 THEN
 DummyInteger(3) = 1
 FOR I = 0 TO 15
 IF LEN(Samples(I)) THEN DummyString(0) = DummyString(0) + CHR$(I)
 NEXT
 DummyString(1) = STRING$(16, CHR$(0))
END IF

' END
IF DummyInteger(3) = 2 THEN
 AWindow = 0
  IF DummyInteger(0) < 2 THEN
  FOR I = 1 TO LEN(DummyString(0))
   C = ASC(MID$(DummyString(0), I, 1))
   V = ASC(MID$(DummyString(1), C + 1, 1))
   IF V THEN
    IF LEN(OPath$) THEN
    IF DQBloadRawSound(C + 1, OPath$ + "BLANK", 1, 320) THEN
     ErrorEND "Blank file missing"
    END IF
    END IF
    Modified = 1
    Samples(C) = ""
   END IF
  NEXT
  END IF
 CleanDummies
 EXIT SUB
END IF

' Mouse areas
IF MY >= 5 AND MY <= 20 AND MX >= 30 AND MX <= 52 THEN Area = 1
IF MY = 21 AND MX >= 32 AND MX <= 39 THEN Area = 2
IF MY = 21 AND MX >= 42 AND MX <= 51 THEN Area = 3

' Highlight
IF MLB1 AND Area > 0 AND DummyInteger(1) = Area THEN
 IF MLB1 = -1 AND MX > 32 AND MX < 36 THEN
  L = ASC(MID$(DummyString(1), DummyInteger(4) + 1, 1)) XOR 1
  MID$(DummyString(1), DummyInteger(4) + 1, 1) = CHR$(L)
 END IF
END IF
IF Area = 1 THEN DummyInteger(4) = MY - 5

StdInp DummyInteger(0), 3, DummyInteger(3), Area

' KEYS OK CANCEL
IF SBAR = -1 AND DummyInteger(0) > 0 THEN DummyInteger(3) = 2
SELECT CASE UCASE$(CH$)
 CASE CHR$(13): DummyInteger(3) = 2
 CASE CHR$(27): DummyInteger(3) = 2: DummyInteger(0) = 2
 CASE CHR$(9): DummyInteger(0) = (DummyInteger(0) + 1) MOD 3
 CASE CHR$(0) + CHR$(15): DummyInteger(0) = (DummyInteger(0) + 2) MOD 3
END SELECT

' KEYS FOR SOUNDS
IF DummyInteger(0) = 0 THEN
L = DummyInteger(4)
IF SBAR = -1 THEN
 C = ASC(MID$(DummyString(1), L + 1, 1)) XOR 1
 MID$(DummyString(1), L + 1, 1) = CHR$(C)
END IF
 SELECT CASE UCASE$(CH$)
  CASE "0": L = 0
  CASE CHR$(0) + CHR$(71): L = 0
  CASE CHR$(0) + CHR$(72): L = L - 1
  CASE CHR$(0) + CHR$(73): L = L - 4
  CASE CHR$(0) + CHR$(79): L = 15
  CASE CHR$(0) + CHR$(80): L = L + 1
  CASE CHR$(0) + CHR$(81): L = L + 4
  CASE "1" TO "9": L = VAL(CH$)
  CASE "A" TO "F": L = VAL("&H" + CH$)
 END SELECT
IF L > 15 THEN L = 15
IF L < 0 THEN L = 0
DummyInteger(4) = L
END IF

END SUB

