'  Cyber Chick Level Editor v2 include file
' User defined functions
DEFINT A-Z
DECLARE FUNCTION MyAngle (X1, Y1, X2, Y2)
DECLARE FUNCTION ByteCode (Ptr&)
DECLARE FUNCTION Interpolate (Numb1, Numb2, Value, MaxVal)
DECLARE FUNCTION WScrollInp ()
DECLARE FUNCTION Zero$ (Number, Digits)

DECLARE SUB BG.Disp ()
DECLARE SUB BG.Inp ()
DECLARE SUB Border ()
DECLARE SUB CalcPalTrans.Disp ()
DECLARE SUB CalcPalTrans.Inp ()
DECLARE SUB CalcTrans ()
DECLARE SUB DemoMisc.Disp ()
DECLARE SUB DemoMisc.Inp ()
DECLARE SUB Draw.Disp ()
DECLARE SUB Draw.Inp ()
DECLARE SUB DrawButton (Text$, X, Y, Pressed)
DECLARE SUB DrawObj (X, Y, Index, Special)
DECLARE SUB DrawTile (X, Y, Index)
DECLARE SUB EndProg ()
DECLARE SUB ExtraTile.Disp ()
DECLARE SUB ExtraTile.Inp ()
DECLARE SUB FPSDisplay ()
DECLARE SUB GrabTiles ()
DECLARE SUB Grid ()
DECLARE SUB IErrorEND (Text$)
DECLARE SUB IInput ()
DECLARE SUB Init ()
DECLARE SUB LoadBSV (DestLayer, File$)
DECLARE SUB LoadBIT ()
DECLARE SUB LoadFromMap (X%, Y%)
DECLARE SUB Loading ()
DECLARE SUB LoadMap (Letter$)
DECLARE SUB LoadMusic (File$)
DECLARE SUB LoadSAV ()
DECLARE SUB LoadTIL ()
DECLARE SUB Logo ()
DECLARE SUB MainDisp ()
DECLARE SUB MainInp ()
DECLARE SUB MainLoad.Disp ()
DECLARE SUB MainLoad.Inp ()
DECLARE SUB MyMsg (Code)
DECLARE SUB MybPut (X, Y, SSeg, SOff)
DECLARE SUB MusicLoop ()
DECLARE SUB Object.Disp ()
DECLARE SUB Object.Inp ()
DECLARE SUB PalBitTil ()
DECLARE SUB PALfadeBlack (Level, ColA, ColB)
DECLARE SUB PALfadeIn (ColA, ColB)
DECLARE SUB PALfadeOut (ColA, ColB, Red, Green, Blue)
DECLARE SUB PALoff ()
DECLARE SUB PALpcr (Index, Red, Green, Blue)
DECLARE SUB PALpcw (Index, Red, Green, Blue)
DECLARE SUB PALreset ()
DECLARE SUB PALrotate (ColA, ColB, Dir)
DECLARE SUB PALscr (Index, Red, Green, Blue)
DECLARE SUB PALscw (Index, Red, Green, Blue)
DECLARE SUB PALupdate ()
DECLARE SUB Plans ()
DECLARE SUB Preview.Disp ()
DECLARE SUB Preview.Inp ()
DECLARE SUB PrintS (Text$, X, Y, FC, BC)
DECLARE SUB SaveEverything ()
DECLARE SUB StopMusic ()
DECLARE SUB Tile.Disp ()
DECLARE SUB Tile.Inp ()
DECLARE SUB WScrollDisp ()
DECLARE SUB WTileDraw ()
DECLARE SUB WTileInp ()

' Const values
CONST PI = 3.141593
CONST Rad2Deg = PI / 180
CONST Radian = 180 / PI
CONST HighJump = "44443434333332323232222222212121212112112112111111011010110101010100100010000100000"
CONST LowJump = "222222212121212112112112111111011010110101010100100010000100000"
CONST MusicNames = "0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ"

' Common shared variables
COMMON SHARED MX, MY, MRB, MLB1, MLB2, MDEL, CH$                 ' Input
COMMON SHARED MVptr&, MVLoop, MVwait&, MusicPlaying, Msg, MsgDel
COMMON SHARED MasterSound, FrameTile, MainArea, MainActive
COMMON SHARED Ticks, G!, FPS, Area, Active, Degrees, Desc$
COMMON SHARED LoJump, HiJump, LY, HY, ZoomTrans, Viewing
                                            
' Drawing stuff
COMMON SHARED XHeld, YHeld, XXX, YYY, PMX, PMY
COMMON SHARED Copy, UndoBG, UndoTiles

' Common shared arrays
COMMON SHARED AGets() AS INTEGER
COMMON SHARED Array() AS INTEGER
COMMON SHARED Arrows() AS INTEGER
COMMON SHARED BMap() AS INTEGER
COMMON SHARED BUFPAL() AS INTEGER
COMMON SHARED Buttons() AS INTEGER
COMMON SHARED CMap() AS STRING * 1
COMMON SHARED Copied() AS INTEGER
COMMON SHARED DA() AS INTEGER
COMMON SHARED Demos() AS INTEGER
COMMON SHARED EPut() AS INTEGER
COMMON SHARED Header71() AS INTEGER
COMMON SHARED MouseGFX() AS INTEGER
COMMON SHARED MyCOS() AS LONG
COMMON SHARED MySIN() AS LONG
COMMON SHARED Pitch() AS INTEGER
COMMON SHARED QPut() AS INTEGER
COMMON SHARED SPut() AS INTEGER
COMMON SHARED THEPAL() AS INTEGER
COMMON SHARED TMap() AS INTEGER
COMMON SHARED TPut() AS INTEGER

' Arrays
DIM AGets(33, 18) AS INTEGER
DIM Array(32001) AS INTEGER
DIM Arrows(33, 7) AS INTEGER
DIM BMap(2047) AS INTEGER
DIM BUFPAL(255, 2) AS INTEGER
DIM Buttons(129, 47) AS INTEGER
DIM CMap(-1 TO 72, -1 TO 40) AS STRING * 1
DIM Copied(32001) AS INTEGER
DIM DA(127) AS INTEGER
DIM Demos(17, 3) AS INTEGER
DIM EPut(513) AS INTEGER
DIM Header71(71) AS INTEGER
DIM MouseGFX(129) AS INTEGER
DIM MyCOS(359) AS LONG
DIM MySIN(359) AS LONG
DIM Pitch(30) AS INTEGER
DIM QPut(513) AS INTEGER
DIM SPut(33) AS INTEGER
DIM THEPAL(255, 2) AS INTEGER
DIM TMap(-1 TO 72, -1 TO 40, 0 TO 1) AS INTEGER
DIM TPut(0 TO 129, 1 TO 216) AS INTEGER

