DEFINT A-Z

DECLARE FUNCTION ByteCode (Pointer&)
DECLARE FUNCTION ByteGet4 (Track, Event)
DECLARE FUNCTION ByteGet5 (Track, Event)
DECLARE FUNCTION ByteGet6 (Track, Event)
DECLARE FUNCTION ByteGet7 (Track, Event)
DECLARE FUNCTION ByteGet8 (Track, Event)
DECLARE FUNCTION DirSub$ (FilSub, Poss)
DECLARE FUNCTION Interpolate (Number1, Number2, Value, MaxValue)
DECLARE FUNCTION LowestTrack ()
DECLARE FUNCTION NoSpace$ (Text$)
DECLARE FUNCTION Notation$ (Note)
DECLARE FUNCTION Str2Tim& (Text$)
DECLARE FUNCTION TickStr$ (Tks&)
DECLARE FUNCTION TTE& (Track, Event)

DECLARE SUB ActionPlace ()
DECLARE SUB CAS.Copy (Track, EveA, EveB)
DECLARE SUB CAS.Delete (Track, EveA, EveB)
DECLARE SUB CAS.GOTO.Measure (MeasNumb)
DECLARE SUB CAS.Load (File$)
DECLARE SUB CAS.Paste (Track)
DECLARE SUB CAS.Play ()
DECLARE SUB CAS.Quantize (Trk, Choice, EveA, EveB)
DECLARE SUB CAS.Repeat ()
DECLARE SUB CAS.Save (File$)
DECLARE SUB CAS.Sort.Track (Track)
DECLARE SUB CAS.Stop ()
DECLARE SUB CAS.TO.CXE (CAS$, CXE$)
DECLARE SUB CAS.Trans.Note (Trk, Steps, EveA, EveB)
DECLARE SUB CenterText (Row, Text$)
DECLARE SUB ChanTVolDisp ()
DECLARE SUB ChanTVolInp ()
DECLARE SUB CleanDummies ()
DECLARE SUB ClearProg ()
DECLARE SUB CreateBG ()
DECLARE SUB CXE.Play (CXE$)
DECLARE SUB DescWindowDisp ()
DECLARE SUB DescWindowInput ()
DECLARE SUB EndProg ()
DECLARE SUB ErrorEND (Text$)
DECLARE SUB ErrorPROMPT.Disp ()
DECLARE SUB ErrorPROMPT.Input ()
DECLARE SUB EventInput ()
DECLARE SUB FieldDisplay ()
DECLARE SUB File.Disp ()
DECLARE SUB File.Input ()
DECLARE SUB FilePROMPT.Disp ()
DECLARE SUB FilePROMPT.Input ()
DECLARE SUB FileSubScroll (IncDec)
DECLARE SUB FitEvent (Tim&, Trk, B4, B5, B6, B7, B8)
DECLARE SUB FPS.Display ()
DECLARE SUB GetInput ()
DECLARE SUB GOTODisp ()
DECLARE SUB GOTOInp ()
DECLARE SUB GrabFiles (Mask$)
DECLARE SUB Init ()
DECLARE SUB InpNumbers (Text$, Curs, Leng, Min&, Max&)
DECLARE SUB InpTime (Text$, Curs, X, Y)
DECLARE SUB InputString (Text$, Cursor, Length)
DECLARE SUB InvertBox (Row1, Col1, Row2, Col2)
DECLARE SUB LetLoopDisp ()
DECLARE SUB LetLoopInp ()
DECLARE SUB MakeABox (R1, C1, R2, C2)
DECLARE SUB MakeBox (R1, C1, R2, C2, F, B)
DECLARE SUB MakeBox2 (R1, C1, R2, C2, F, B)
DECLARE SUB MakeBoxF (R1, C1, R2, C2, A, F, B)
DECLARE SUB MakeGrad (An$, Ao$, Ap$, Aq$, Ar$, Au$)
DECLARE SUB MasterDisp ()
DECLARE SUB MasterInp ()
DECLARE SUB MeasureDisp ()
DECLARE SUB MeasureInp ()
DECLARE SUB MenuSubMenu.Disp ()
DECLARE SUB MenuSubMenu.Inp ()
DECLARE SUB MPWindowDisp ()
DECLARE SUB MPWindowInp ()
DECLARE SUB MTransDisp ()
DECLARE SUB MTransInp ()
DECLARE SUB MusicKeyboard ()
DECLARE SUB NTransDisp ()
DECLARE SUB NTransInp ()
DECLARE SUB ParseInput ()
DECLARE SUB PasteWindowDisp ()
DECLARE SUB PasteWindowInp ()
DECLARE SUB PitchDisp ()
DECLARE SUB PitchInp ()
DECLARE SUB PokeBCol (Row, Colm, BG, Length)
DECLARE SUB PokeCol (Row, Colm, FG, BG)
DECLARE SUB PrintEvent (Track, Event, Row, Col)
DECLARE SUB PutByte4 (Track, Event, Byte)
DECLARE SUB PutByte5 (Track, Event, Byte)
DECLARE SUB PutByte6 (Track, Event, Byte)
DECLARE SUB PutByte7 (Track, Event, Byte)
DECLARE SUB PutByte8 (Track, Event, Byte)
DECLARE SUB PutNoteDisp ()
DECLARE SUB PutNoteInp ()
DECLARE SUB PutTime (Track, Event, Ticks&)
DECLARE SUB QuantizeDisp ()
DECLARE SUB QuantizeInp ()
DECLARE SUB RecDisp ()
DECLARE SUB RecInp ()
DECLARE SUB RecNowDisp ()
DECLARE SUB RecNowInp ()
DECLARE SUB ScrollField (Trk, IncDec)
DECLARE SUB SetChannelDisp ()
DECLARE SUB SetChannelInp ()
DECLARE SUB ShowMouseCursor ()
DECLARE SUB SSegWindowDisp ()
DECLARE SUB SSegWindowInp ()
DECLARE SUB StartRef ()
DECLARE SUB StdInp (W, M, SE, A)
DECLARE SUB StepRecDisp ()
DECLARE SUB StepRecInp ()
DECLARE SUB StopCVDisp ()
DECLARE SUB StopCVInp ()
DECLARE SUB TempoDisp ()
DECLARE SUB TempoInp ()
DECLARE SUB TickSigDisp ()
DECLARE SUB TickSigInp ()
DECLARE SUB UnloadDisp ()
DECLARE SUB UnloadInp ()

COMMON SHARED CASPlaying   ' Is CAS playing or not?
COMMON SHARED CLen          ' Clipboard used? (Also length)
COMMON SHARED CTrack         ' Which track do we copy?
COMMON SHARED Description$    ' Description of song
COMMON SHARED FPS, T, G!       ' Frames-per-second, Ticks, prev time.
COMMON SHARED LoopVal           ' Looping flag
COMMON SHARED MeasUsed           ' Number of measures used
COMMON SHARED MLooped             ' Auto-repeat for music
COMMON SHARED Ticks&               ' Current ticks
COMMON SHARED TickSig               ' Tick signature (8-256)
COMMON SHARED TimeE&                 ' Time elapse of music
COMMON SHARED Undo                    ' (0=n, 1-17=track)
COMMON SHARED UndoTL                   ' Undo Track Length
COMMON SHARED MX, MY, CH$, MDD          ' Mouse coordinates and INKEY$
COMMON SHARED MLB1, MLB2, MDel, MDel2    ' Mouse press and release states
COMMON SHARED FrameTile                   ' Cycle for mouse animation
COMMON SHARED Ref$, INS, OPath$, Rav$      ' Reference message
COMMON SHARED CTRL, ALT, SHIFT, SBAR, Scan  ' Second hand keys
COMMON SHARED Program$, Anything, Modified   ' Program name and action
COMMON SHARED AField                        ' Active field: Field, Trk, Eve
COMMON SHARED ATrack                       ' Active track for editing
COMMON SHARED AMenu                       ' Menu chosen: File, Edit, etc.
COMMON SHARED ASubMenu                   ' Sub choice: New, Open, Save, etc.
COMMON SHARED AWindow                   ' Error messages, Events, etc.
COMMON SHARED SMouseHeld               ' For the mouse scroll list ring

COMMON SHARED AEvent() AS INTEGER
COMMON SHARED Pitch() AS INTEGER
COMMON SHARED MeasCAS() AS INTEGER
COMMON SHARED MeasRef() AS LONG
COMMON SHARED Samples() AS STRING
COMMON SHARED NoteMeter() AS INTEGER
COMMON SHARED TrackLen() AS INTEGER
COMMON SHARED TrackPTR() AS INTEGER
COMMON SHARED TrackScr() AS INTEGER
COMMON SHARED SortBuff() AS INTEGER
COMMON SHARED SL() AS INTEGER
COMMON SHARED SR() AS INTEGER
COMMON SHARED DummyString() AS STRING
COMMON SHARED DummyInteger() AS INTEGER
                               
CONST KeyB = "qwertyuiop\asdfghjkl;'zxcvbnm,."

DIM AEvent(1) AS INTEGER        ' Event select
DIM Pitch(30) AS INTEGER        ' Pitch table
DIM MeasCAS(255, 16) AS INTEGER ' EventPTRs for 256 measures
DIM MeasRef(255) AS LONG        ' File position Reference of Measures
DIM Samples(15) AS STRING       ' File names of samples
DIM NoteMeter(16) AS INTEGER    ' Meter for CXE files playing
DIM TrackLen(16) AS INTEGER     ' Number of events in tracks
DIM TrackPTR(16) AS INTEGER     ' Current playing event in tracks
DIM TrackScr(16, 2) AS INTEGER  ' Scrolling positions in tracks
DIM SortBuff(15, 1) AS INTEGER  ' Buffers for sorting
DIM SL(-1 TO 63) AS INTEGER     ' Sort buffer left
DIM SR(-1 TO 63) AS INTEGER     ' Sort buffer right
DIM DummyString(31) AS STRING   ' Used for input boxes
DIM DummyInteger(31) AS INTEGER ' Used for input boxes

