'
' FINAL BOSS 
'

' LoadB "BE7.PAG", 10 = Sprites and data         Tile MAP
' LoadB "BE8.PAG", 7  = Sprites and data         Collision Map
' LoadB "BE9.PAG", 9  = background               Background

' EN
' EN(1, 1) = 24
' EN(1, 2) = Script counter
' EN(1, 3) = Sub script counter for robot
' EN(1, 4) = Action moves
' EN(1, 5) + EN(1, 6) = Alexa's hooverboard's coordinate
' EN(1, 7) = Direction LEFT=0 / MIDDLE=1 / RIGHT=2
' EN(1, 8) + EN(1, 9) = Robot's cartesian coordinates
' EN(1, 10) = Alexa's freezing state LOL
' EN(10-30, 1-3 [x,y,r]) = Clinton Robot coordinates for 21 body parts

' ROBOTOBOR:                    (300 hitpoints) +POWER_BEAM
'   RUNNING TOWARDS ALEXA
'   Human-Like
'          Eye Beam ___________________  OK  --
'          Throw hand as boomerang ____      256
'          Cart wheels ________________  OK  64
'   Tiger-Like
'          Run  _______________________  OK  64
'          Back flip __________________      16-96-16
'          Jump _______________________      16-112
' If Alexa gets behind robot, make robot go left gradually
' Each transition between actions is 256 frame intervals

' 
'  WHEN ROBOTOBOR DIES: Robot falls apart, environment darkens to
'  complete black color. Music fades and new music piece plays
'  instantly
' 

' MORGROM:                                      (200 hitpoints) +POWER_BEAM
'  Jewel on his forehead Head (weakness spot)
'' Stretch effect that lasts 16 frames per half face session' (32 total)

'  Moving pattern:

'        Spit out Ice freezing Alexa!
'        * breath goes out in circles like FIELD GUN. 4 Iceys

'        Fire ring in and out from eyes (40 points)
'        * Gun dir

'        Lightning Beam attacking Alexa by 40 points! (no more than 3 times)
'        * Charging up
'        * Horizontal thunder that's 32 pixels wide

'        Earthquake
'        * His Chin stretches out to make an earthquake
'        * 12 objects fly down in random X coordinates (40 hitpoints loss)

' 
'  WHEN MORGROM DIES: Clinton head falls down, decomposing
'  Music starts to fade slowly. Slow fadeout
' 

SUB AlexaPoint

'CASE 1: SOLID
'CASE 2: LEFT MOVE -1 PIXELS
'CASE 3: RIGHT MOVE +1 PIXELS
'CASE 4: SEMI -SOLID
'CASE 5 TO 8: RIGHT,DOWN,LEFT,UP DoorToDoor
'CASE 9: IF AskToSave THEN AskToSave = 0: SaveGame: EXIT FOR
'CASE 14: ENERGY = ENERGY - 8
'CASE 15: ENERGY = ENERGY - 12
'CASE 16: ENERGY = ENERGY - 16
'CASE 17: ENERGY = ENERGY - 24
'CASE 18: ENERGY = ENERGY - 40
'CASE 19: ENERGY = -1
'CASE 20: LADDAR (6 Pixels Wide)
'CASE 21 TO 28: Anything = APs(I): ZoneTOzone: EXIT FOR (8 possibilities)
'CASE 30 TO 53: Anything = APs(I): GotAnItem: EXIT FOR  (24 Items)
'CASE 55 TO 58: Anything = APs(I): AreaToArea: EXIT FOR (4 DIrections)
'CASE 59: ENERGY = ENERGY + 1
'CASE 230 TO 255: Treasure Items A-Z

END SUB

SUB BeforeRelease

' BETATESTERS:
'  Marcade
'  Lithium
'  Bud The Fish
'  Bram
'  solus
'  Jason

'BETATEST it for about a week

'Make CC.MAK and Add this:
'CC.BAS
'CC2.BAS
'CC3.BAS
'CC4.BAS
'CC5.BAS
'so I don't contradict myself about the "QB.EXE is useless for editing"

END SUB

SUB CoolStuff

''''''''''''''''''''''''''''''''''' DEMO SHOW OFF
'THIS SHOULD BE FUN! =)
'4 demo scenes from theme. (PROGRAMMING ASPECT COMPLETE)  =)
'What to show off:
'
' SLOW MOTION WHEN RECORDING!! LOOKS GOOD!! :D
'
' Snow, Techno, Jungle, and Alien-Like Red environment

' GOULD'S CAVERN: (Gears)
' UNDERWORLD BERG (Icey world)
' MOTTOLA FOREST (Forest)
' ALIEN (Redish)

' Shooting Breakable Walls
' Shooting enemies with Ice Beam, and jumping on them.
' Show her hurt to 30 health so MOZAIC effect shows. :)
' Go into secret covered room
' Roll into Morph Ball
' Climbing on laddars
' Destroy lightning and move onto platform. :)
' Choosing guns and show them off.
' Almost walk into a door
' Show off the maneuvers she can do
' Kill as many enemies as much as you can as fast
' Show off special dynamic platforms
' DoorDepth to DoorDepth will be needed (DoorUp Array)
' Show off water with splashing with its translucency!
' Jump on gears and teeth. :)

END SUB

SUB FinalBoss

' ROBOTOBOR:
'   RUNNING TOWARDS ALEXA
'   Human-Like
'          Eye Beam
'          Throw hand as boomerang
'          Cart wheels
'   Tiger-Like
'          Fire tail
'          Jump
'          Giant mouth

' MORGROM:
'   Jewel on his forehead Head (weakness spot)
'   Moving pattern
'          Spit out Ice freezing Alexa!
'          * breath goes out in circles like FIELD GUN. 4 Iceys
'          Fire ring in and out from eyes
'          * Gun dir
'          Lightning Beam attacking Alexa by 100 points! (no more than 3 times)
'          * Charging up
'          * Horizontal thunder that's 32 pixels wide
'          Earthquake


END SUB

SUB Header36

'01) ORIGINx                      Position on map X axis
'02) ORIGINy                      Position on map Y axis
'03) WIDTHx                       Width of sector
'04) WIDTHy                       Height of sector
'05) ASC(LEFT$(Background$, 1))   Background first letter
'06) ASC(RIGHT$(Background$, 1))  Background last letter
'07) ASC(LEFT$(TileSET$, 1))      Tile set first letter
'08) ASC(RIGHT$(TileSET$, 1))     Tile set last letter
'09) ASC(Music$)                  Name of CXE song
'10) ScrOllMODE                   Background scroll mode
'11) AUTOScrOllSPEED              Scroll speed or depth
'12) MakeNegative                 Makes auto scroll go the other way
'13) Cur BGScrollSteps
'14) DrawTilesWhen                DrawTile layer under, or over
'15) Cur TPaletteSteps
'16) Cur TPaletteDir
'17) Cur BGPaletteSteps
'18) Cur BGPaletteDir
'19) FADEbackground               Background fading switch
'20) FADEbgSTEPs                  Ticks for each fading rotation
'21) FADEbgR                      Red color intensity of Fade out
'22) FADEbgG                      Green color intensity of Fade out
'23) FADEbgB                      Blue color intensity of Fade out
'24) FADEtiles                    Fading tiles switch
'25) FADEtilesSTEPs               Ticks for each fading rotation
'26) FADEtilesR                   Red color intensity of Fade out
'27) FADEtilesG                   Green color intensity of Fade out
'28) FADEtilesB                   Blue color intensity of Fade out
'29) ROTATEbg                     Palette rotation of background switch
'30) ROTATEbgColorA               First point of segment to palette rotate
'31) ROTATEbgColorB               Last point of segment to palette rotate
'32) ROTATEbgDIR                  Flag to tell which way to rotate, 0 & 1
'33) ROTATEtiles                  Palette rotation of tiles switch
'34) ROTATEtilesColorA            First point of segment to palette rotate
'35) ROTATEtilesColorB            Last point of segment to palette rotate
'36) ROTATEtilesDIR               Flag to tell which way to rotate, 0 & nonzero

'00) ExtraTilesON                 0-NONE. 1-BACK. 2-NORMAL. 3-FORE
'01) TileScrollSpeed              0-NORMAL, 0 TO 255, Speed  (BACK or FORE)
'02) PatternWX                    1 TO 4: Length in Width of Pattern
'03) PatternWY                    1 TO 4: Length in Height of Pattern
'04) AutoScrollXsteps             0-255 fast
'05) AutoScrollYsteps             0-255 fast
'06) MakeNegX                     Direction change
'07) MakeNegY                     Direction change
'08) C CurrentX
'09) C CurrentY
'10) Translucency Opacity #1
'11) Translucency Final Color A #1
'12) Translucency Final Color B #1
'13) Translucency Opacity #2
'14) Translucency Final Color A #2
'15) Translucency Final Color B #2
'16) Translucency Opacity #3
'17) Translucency Final Color A #3
'18) Translucency Final Color B #3
'19) Translucency Opacity #4
'20) Translucency Final Color A #4
'21) Translucency Final Color B #4
'22) Translucency Opacity #5
'23) Translucency Final Color A #5
'24) Translucency Final Color B #5
'25) Translucency Opacity #6
'26) Translucency Final Color A #6
'27) Translucency Final Color B #6
'28) Translucency Opacity #7
'29) Translucency Final Color A #7
'30) Translucency Final Color B #7
'31) Translucency Opacity #8
'32) Translucency Final Color A #8
'33) Translucency Final Color B #8

END SUB

SUB Layers

'0 = Video
'B0 = Double Buffer

'01 = A.PAG Main GFX Stuff
'02 = B.PAG GFX ALEXA
'03 = C.PAG GFX REDBLUE
'04 = D.PAG GFX MINI ENEMIES
'05 = Boss Enemy GFX Layer
'06 = Tiles GFX Layer
'07 = Collision and objects MAPPING Layer, Header36 DATA
'08 = Misc Junk Save stuff DATA
'09 = Background GFX
'10 = Lowbyte Tile Layer 1, ExtraTile Map DATA, Translucency DATA
'11 = Highbyte Tile Layer 1
'12 = Lowbyte Tile Layer 2
'13 = Highbyte Tile Layer 2
'14 TO 16 = Music Data

END SUB

SUB MAPS

' MAP    LAYER    PURPOSE

'?0.MAP  7        Collision and Objects
'?1.MAP  10       Lowbyte Layer 1 Tiles
'?2.MAP  11       Highbyte Layer 1 Tiles
'?3.MAP  12       Lowbyte Layer 2 Tiles
'?4.MAP  13       Highbyte Layer 2 Tiles

END SUB

SUB MusicLayOut

'    Background music     Samples Channels
'
'0.CXE = Theme                16   16   DONE
'1.CXE = Menu                 16   16   DONE
'2.CXE = Player Name Insert   16   16   DONE
'3.CXE = Alexa's dream        16   16   DONE
'4.CXE = Boss Enemy           10   16
'5.CXE = Game Over            16   16   DONE
'6.CXE = Clinton's Music      16   16
'7.CXE = Last Scene (WIND)    16   16
'8.CXE = Credits              16   16

'A.CXE = Alexa's House (SAVE)           DONE
'B.CXE = DarkDread City (Super-Beat)    DONE
'C.CXE = Restricted Rocket Area
'D.CXE = Church Organ Choir Music

'E.CXE = Forest Music #1 (Fairy like)
'F.CXE = Forest Music #2 (Waterfall)
'G.CXE = Forest Music #3 (Top of Forest)
'H.CXE = Cavern Forest Dark

'I.CXE = Underworld Berg Icey Theme #1
'J.CXE = Underworld Berg Icey Theme #2
'K.CXE = Entrance to Gould's Cavern
'L.CXE = Gould's Cavern

'L.CXE = Clinton's Colony #1 (Boring part)
'M.CXE = Clinton's Colony #2 (Close to enemy)

END SUB

SUB OutOfTheQuestion

' Nothing is longer out of the question! Mwahahaha Joystick routines
' are now implemented!

END SUB

SUB SoundMap

'if DQBinit(16, 41, 0) (Sound)
'DQBplaySound Slot, Channel, Freq, LoopFlag
'
'SLOTS:

'01 Regular Beam
'02 Ice Beam
'03 Micro Beam
'04 Power Beam
'05 Reflect Beam
'06 Explosion
'07 Bullet stopped
'08 EarthQuake
'09 FanFare
'10 SonarMap
'11 TypeWriter
'12 Alexa Hurt
'13 Alexa Dying
'14 Execution
'15 Open Door
'16 CLOSE Door
'17 Flip/Whoosh
'18 --[Custom]
'19 --[Custom]
'20 --[Custom]
'21 --[Custom]
'22 Instrument 01
'23 Instrument 02
'24 Instrument 03
'25 Instrument 04
'26 Instrument 05
'27 Instrument 06
'28 Instrument 07
'29 Instrument 08
'30 Instrument 09
'31 Instrument 10
'32 Instrument 11 [Some boss enemies use these for sound effects]
'33 Instrument 12 [Some boss enemies use these for sound effects]
'34 Instrument 13 [Some boss enemies use these for sound effects]
'35 Instrument 14 [Some boss enemies use these for sound effects]
'36 Instrument 15 [Some boss enemies use these for sound effects]
'37 Instrument 16 [Some boss enemies use these for sound effects]
'38 Energy Ball
'39 FireBall
'40 Splash     [NOT DECIDED]
'41 Bubble     [NOT DECIDED]
'42 Heart Beat

'Channels:

'01 Gun Channel / FanFare / SonarMap
'02 Explode
'03 Energy Ball / Execution
'04 TypeWriter / OpenDoor / CloseDoor
'05 Bullet Stopped
'06 AlexaHurt / AlexaDying
'07 EarthQuake
'08 Flip
'09 Boss Enemy sound effects 01
'10 Boss Enemy sound effects 02
'11 Boss Enemy sound effects 03
'12 Boss Enemy sound effects 04
'13 Instrument Channel 01
'14 Instrument Channel 02
'15 Instrument Channel 03
'16 Instrument Channel 04
'17 Instrument Channel 05
'18 Instrument Channel 06
'19 Instrument Channel 07
'20 Instrument Channel 08
'21 Instrument Channel 09
'22 Instrument Channel 10
'23 Instrument Channel 11
'24 Instrument Channel 12
'25 Instrument Channel 13
'26 Instrument Channel 14
'27 Instrument Channel 15
'28 Instrument Channel 16
'29 Heartbeat
'30 Splash     [NOT DECIDED]
'31 Bubble     [NOT DECIDED]
'32 FireBall

END SUB

SUB What2Do

' Programming
'   Final Boss Robot enemy needs to get done
'   Final Boss Giant enemy needs to get done

' Music
'   8 Main songs
'   18 Diverse songs
'    DarkDread City     == 5 songs
'    Mottola Forest     == 5 songs
'    Underword Berg     == 4 songs
'    Gould's Cavern     == 3 songs
'    Clintons's Colony  == 1 song
'    27 TOTAL SONGS (19 + 8)

' Graphics
'   64 shades for BG + 64 shades for FG need to be fabricated
'   There are 164 sectors in CC, so management is a must!!

END SUB

SUB WhatsDONE

'01) Collision Detection was a pain, but its done and it's FAST
'02) Scrolling Math is done
'03) EarthQuake routine is done
'04) Her hurt routine is done, where she touches mini-enemies, she's hurt
'05) She can shoot her enemies, way to go
'06) Header36(n) DATA is DONE
'07) Mini Map is in use
'08) 15 Mini-Enemies are done
'09) 96 NON-ANIMATED NON-COLLISION tiles engine
'10) 23 Collisions done
'11) 24 NON-COLLISIONs DONE
'12) Saving game (might need further testing for Zone stuff)
'13) ENERGY STAT. is done
'14) Shooting mini enemies
'15) Alexa can NOW go to other rooms without doors
'16) ICE, MICRO, REFLECT, REGULAR, POWER beams are ALL drawn.
'17) Sub Directories for MAPs, MAINPAGEs, BITMAPs, MUSIC, AND TILEs are done
'18) SAVE AREA Tile-Set Test for Mottola Forest.
'19) LEVEL EDITOR is ENHANCED! =)  EVEN DISPLAY SPRITE, with ROOM REFRESH
'20) When entering Clinton's Colony, MAP is shown as damaged
'21) Palette routines are done! (Fade, Rotate, Buffer, DoubleBuffer)
'22) ALMOST the 1st BOSS ENEMY.
'23) ALMOST the 2nd BOSS ENEMY.
'24) ALMOST the 3rd BOSS ENEMY.
'25) ALMOST the 4th BOSS ENEMY.
'26) Added Background Manual Scrolling
'27) Lightning Bug fixed, so it quits eating up our tiles
'28) MUSIC ENGINE ENGAGED
'29) Jetsoons are finally fixed properly
'30) Demo walking and its custom with "cc demon" switch
'31) LAWBUG has been retouched programming and graphics
'32) REMOVED extra L2.PAG page, saved 64k more memory
'33) ITEM graphics are fully optimized, they were a terrible mess before
'34) Scroll math glitch fixed with ScrollMath, so when in a DoorToDoor
'35) EXTRA TILE LAYER, fully supported. (Supports all 3 modes, B, N, F)
'36) SPECIAL DYNAMIC PLATFORMS IMPLEMENTED. TMap(155 TO 158)
'37) Liquid code for Alexa! LAVA, ICEY, WATER, EX HOT TMap(151 TO 154)
'38) GameOver, SaveGame & SelectPlayer looks much better
'39) DoorTex and Doors confusion BUG has been corrected
'40) GameOver, and SelectPlayer, looks EVEN much better
'41) Huge map of every sector is finished in GIF format
'42) ENERGY Balls are implemented.
'43) Tile system has been rewritten. This will allow more flexible animation
'44) DQB's unused routines are trimmed off, leaving me more base memory!
'45) When Alexa is harmed, her direction of defense has been corrected!
'46) Clearing a player's game will only clear used games. :)
'46) DQBcPut on everything that's 16 by 16 sprites.
'47) Eyesis is complete.
'48) Shouldier is complete.
'49) Laphronic is complete.
'50) Heameur is complete.
'51) Translucency routine, calculator, and file reading is done. :)
'52) Sound effects for all 4 boss enemies complete. :)
'53) Splashes, bubbles, water effects, sounds and gfx, all done. =)
'54) BRT time delay fixed, when block is breaking.
'55) Fading Black is finally introduced
'56) Fixed up the old Zone to Zone bugs
'57) Made Demo-walkthrough easier to do and more instant!
'58) Added Restrictions on demo recording (dying, savegame, pausing)
'59) Music loading on certain parts became fixed!
'60) Auto scrolling and palette effects are separated from drawing
'61) Music settings for FINAL ZONE and NON-FINAL ZONES for Boss enemies done
'62) Gave Pitch(0 TO 24) a Pitch(0 TO 30) range! =)
'63) Made DQBsetFreq routine for pitch bending instruments
'64) Added DQBboxF for DrawTiles just for the sake! Geeesh! :P
'65) Added depth camera doors interpolation.. blah, but it looks neat! =D
'66) Fixed up the camera Y movement, because it irritates me.
'67) Cutscene for visiting Clinton COMPLETELY Done. Sounds+Pics, everything!!
'68) Command line defaults to "command line options" when used
'69) Fixed the DEMO RECORDING, DQBinitVGA was out of place
'70) Map ORGx WIDx, all maps with this info are complete!
'71) Doodle gun starting bullet coordinates are done in all 8 directions!
'72) HTML file of Cyber Chick is done
'73) CCLEVLED now has easier palette editing and a dithering pen!
'74) CCLEVLED now has copy and pasting tiles in Image mode or Tile mode
'75) CCLEVLED adds key support to toggle some windows!
'76) I got the biggest break!! I freed up 10k of MEMORY !!!!!!!!!!!!!!!!!!
'77) I got even 10k more memory by optimizing EnemyMath !!!!!!!!!!!!!!!!!!
'78) I added gears and teeth just like Castlevania games!
'79) I added JOYPAD support through out the entire game!!!!
'80) Debris around explosions now added!!
'81) Fixed the annoying scroll bug in "Cyber Chick initiating"
'82) CREDITS ARE DONE!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
'83) Save State F11, Load State F12 keys are enabled

END SUB

